#include "stm32f4xx.h"
#include "ssd1963.h"
#include "xpt2046.h"
#include "fonts.h"
#include "tables.h"
#include "grafiki.h"
#include "grafiki2.h"

//------------------------------------------------------------------------
//Definicje
#define testkalibracji 0	//definicja funkcji testujacej panel dotykowy
#define  activcalib        (GPIOA->IDR & GPIO_Pin_0)  //definicja aktywowania kalibracji

//Definicje sterujace portami
#define PD0on    GPIOD->BSRRL = GPIO_Pin_0
#define PD1on    GPIOD->BSRRL = GPIO_Pin_1
#define PD2on    GPIOD->BSRRL = GPIO_Pin_2
#define PD3on    GPIOD->BSRRL = GPIO_Pin_3
#define PD4on    GPIOD->BSRRL = GPIO_Pin_4

#define PD0off    GPIOD->BSRRH = GPIO_Pin_0
#define PD1off    GPIOD->BSRRH = GPIO_Pin_1
#define PD2off    GPIOD->BSRRH = GPIO_Pin_2
#define PD3off    GPIOD->BSRRH = GPIO_Pin_3
#define PD4off    GPIOD->BSRRH = GPIO_Pin_4

//------------------------------------------------------------------------
//-------------Definicje typow -------------------------------------------

typedef struct{
uint8_t value;    //wartosc mocy na slider bard
uint8_t onoff;    //parametr okreslajacy czy jest zalaczona czy wylaczona
uint8_t lrt;     //dla frezarki zmianna okreslajaca kierunek obrotow natomiast dla lamp czas dzialania
} StructParamMan;
typedef struct{
	uint8_t onoff;    //Czasomierz
	uint16_t value;   //Wartosc timera
} StructTimeMan;

//Funkcje systemowe
void RCC_init(void);
void GPIO_init(void);
void Systick_init(void); //przerwania od sygnalu taktujacego rdzen
void PWMTIMER1_init(void);
//------------------------------------------------------------------------
//Funkcje graficzne
void drawanimealpharectangle(uint16_t x, uint16_t y, uint16_t width, uint16_t heigh);
void hideanimealpharectangle(uint16_t x, uint16_t y, uint16_t width, uint16_t heigh);
void menuanimbelt(uint16_t x, uint16_t y, uint16_t width, uint16_t height);
void zaznmenu(uint8_t *wmenu, uint8_t *flagazaznacz);
void animecross(uint16_t x, uint16_t y);
void animeset(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, uint16_t color, uint8_t *pierwszerysowanie);
void putsliderbar(uint16_t x, uint16_t y, uint8_t *firstdraw, StructParamMan *wsk, uint16_t *buf, uint32_t *param);
void putslidervalue(uint16_t x, uint16_t y, uint8_t *firstdraw, StructParamMan *wsk, uint16_t *buf, uint32_t *param);
void putbuttons1(uint8_t *firstdraw);
void putbuttons2(uint8_t *firstdraw);
void animearrows1(uint8_t zalwyl1, uint8_t zalwyl2, uint8_t *firstdraw);
void puttimevalue(uint16_t x, uint16_t y, StructParamMan *wsk, uint8_t *wsktime);
void putbuttons3(uint16_t y, uint8_t *firstdraw, StructTimeMan *wsk, uint8_t numerczasomierza);
void animearrows2(uint8_t zalwyl1, uint8_t zalwyl2, uint8_t *firstdraw);
void puttimevalue2(uint16_t x, uint16_t y, StructTimeMan *wsk, uint16_t *wsktime);
void putbulb(uint16_t x, uint16_t y, uint16_t color, uint8_t *firstdraw, uint8_t power);
void putsave(uint16_t x, uint16_t y, uint16_t color, uint8_t *firstdraw, uint8_t *animestart);
//------------------------------------------------------------------------
//Funkcje oraz procedury uytkowe
void lcdputvalue(u16 x, u16 y, u16 value);
uint8_t gettouchvalue(void);
void calibrationtouch(void);
void testcalib(void);
void touchmainmenu(void);
void touchexit(void);
void paramafterstart(void);
void touchmenu1(void);
void touchmenu2(void);
void controltimerlamp(void);
void touchmenu3(void);
void controlczas(void);
void touchmenu4(void);
void Flash_zapisustawien(void);
void Flash_odczytustawien(void);
void Flash_zapis2(void);
void Flash_odczyt2(void);
void ControlOutputs(void);
//------------------------------------------------------------------------
volatile uint32_t ms, timeranime, timertouch, TIMERUS, timeranime2, timerlamp1, timerlamp2, timerczas1, timerczas2, *wskkalib, *wskustawien,
		timerontime1, timerontime2, timerrozruch;
int chosefont, rotate; //zmienna sluzaca do wyboru czcionki uzywanej
uint16_t X, Y, tempczas1, tempczas2;
uint8_t menu=0, flagamenu=1, zaznaczmenu=0, flagazaznaczenia=10, anim2=1, firstsliderbar=1, firstvalue=1, firstbuttons=1, arrows=1,
		temptimer1=255, temptimer2=255, firstbuttons2=1, firstsave=1, firstbulb=1, animesave, powerbacklight, flagaponownejkalibracji, flagazapiszustawienia;
volatile uint32_t TIMERUS, touchms, Xtouch, Ytouch;
const uint16_t xcal1=4000, xcal2=100, ycal1=4000, ycal2=100;
volatile float aX=0, bX=0, dX=0, aY=0, bY=0, dY=0;   //zmienne potrzebne przy pelnej kalibracji
uint16_t buftx[4];
uint16_t bufty[4];
volatile uint8_t wykalibrowano=0, globalk=0, globalk2=0;
void delayms(uint32_t mms);
const uint16_t colorbufer[12]={ 0xFFFF, 0xAF9F, 0x775E, 0x571E, 0x2EFE, 0x16BD, 0x2EFE, 0x571E, 0x775E, 0xAF9F, 0xFFFF, 0xFFFF}; //tablica kolorow zmieniajaca zaznaczenie
//Tablice buforujace dany obszar grafiki do pamieci RAM
uint16_t tftbuf1[11000];
uint32_t tftparam1[3];
uint16_t tftbuf2[1000];
uint32_t tftparam2[3];
uint16_t tftbufslider1[11000];
uint32_t tftparamslider1[3];
uint16_t tftbufslider2[11000];
uint32_t tftparamslider2[3];
uint16_t tftbufvalue1[2000];
uint32_t tftparamvalue1[3];
uint16_t tftbufvalue2[2000];
uint32_t tftparamvalue2[3];
//Struktury okreslajace wlasciowosci dla frezarki oraz lamp.
StructParamMan frezarka, lampa1, lampa2;
StructTimeMan  czasomierz1, czasomierz2;

//-----------------------------------------------------------------------
//---- Definicja adresu poczatku w ktorym beda zapisywane wszystkie dane
#define Flash_User_Start   0x080E0000


int main(void)
{

//------------------------------------------------------------------
//Wywowanie funkcji inicjalizujacych

	RCC_init();
    Systick_init();     //inicjalizacja systick
    GPIO_init();
    PWMTIMER1_init();  //Inicjalizacja portow sterujacych

    LCD_GPIOInit();
	LCD_ResetDevice();      //inicjalizacja sterownika wyswietlacza
	XPT2046_SPI_Init(); //inicjalizacja panelu dotykowego



	LCD_Clear(0xffff);			//wyczyszczenie ekranu na bialo


//--------------------------------------------------------------------
//Sprawdzenie warunku czy wystapienie zadanie o skalibrowanie panelu dotykowego

 wskkalib=(uint32_t *)(Flash_User_Start);  //ustawienie wskaznika na adres komorki ktora jest flaga - czy juz byla doknana kalibracja po pierwszym uruchomienu

if(*wskkalib!=0x256faba4)
	    {
	    	 flagaponownejkalibracji=1;
	  	}

	 if(activcalib)  //jezeli jest wcisniet przycisk odpowiedzialny za ponowna kalibracje touch panelu
	    {
	    	 flagaponownejkalibracji=1;
	  	}


	 if(flagaponownejkalibracji)
	    {
		 TIM4->CCR4=10000; //ustawienie maksymalnego podswietlenia

		 Flash_odczyt2();  //Przed kalibracja odczyt aktualnych ustawien
		 //W tym miejscu nalezy zalaczyc maksymalne podswietlenie wyswietlacza w celu prawidlowej kalibracja touchpanelu

		      chosefont=4;
		      tft_mputs( 200, 220, "Kalibracja panelu dotykowego.",  0xf800, 0xffff, 0 );
		      tft_mputs( 150, 240, "Prosz trzyma pojawiajce si kwadraty.",  0xf800, 0xffff, 0 );
		      calibrationtouch();
	   	}
//--------------------------------------------------------------------

//Wyczyszczenie po kalibracji ekranem o bialym tle
    LCD_Clear(0xffff);	//wyczyszczenie ekranu dotykowego

#if testkalibracji==1
    testcalib(); //wywoanie sprawdzenia touchpanelu
#endif


    //Narysowanie na ekranie tapety
     putfastpicture(0, 0, 800, 480, wallpaper);

     //w tym miejscu nastepuje odczyt wspolczynnikow kalibracji z pamieci flash oraz odczyt wszystkich ustawien
     Flash_odczyt2();

     //Zezwolenie na uzywanie kalibracji przez 3 punkty
     wykalibrowano=1;

     //wywolanie procedury wpisujacej wartosci po uruchomieniu zasilania
     paramafterstart();


//-------------------------------------------------------------------------------------------------------------------------
// Gwna ptla programu
while(1)
{
	//*************************************************************************
	//Menu gwne
	while(!menu)
	{
		//Pierwsze rysowanie po wejscu w dane podmen
		if(flagamenu)
		{
			flagamenu=0;
			//ustawienie flag w taki sposob aby po powrocie do menu glownego mozliwe bylo narysowanie Ikon
			flagazaznaczenia=10;
			zaznaczmenu=0;

			hideanimealpharectangle(400, 240, 750, 440);  //wyczyszczenie wczesniejsze obrazu za pomoca animacji
			drawanimealpharectangle(400, 240, 750, 440);  //narysowanie kwadratu przezroczystosci jako dlo dla wyswietlenia menu
			menuanimbelt(400, 240, 600, 120);             //animowane pojawienie sie paska

			LCD_ReadData(tftbuf1, tftparam1, 250, 99, 550, 131);  //odczytanie fragmentu grafiki z wyswietlacza gdzie beda nazwy
		}

		zaznmenu(&zaznaczmenu, &flagazaznaczenia);
		controltimerlamp();
		controlczas();

		ControlOutputs();

		if( gettouchvalue())  //sprawdzenie czy nacisnieto panel dotykowy
			{
				if(!timertouch)
				{
					timertouch=3000;
		           	touchmainmenu();
				}
			}

	}
	//Koniec menu gwnego
	//***************************************************************************
	//Podmenu 1  - Frezarka
	while(menu==1)
	{
		//Pierwsze rysowanie po wejscu w dane podmenu
		if(flagamenu)
		{
			flagamenu=0;
			chosefont=1;
			tft_mputs( 308, 25, "FREZARKA",  Black1, 0xffff, 1 );
			chosefont=2;
			tft_mputs( 265, 125, "Obroty frezarki",  Black1, 0xffff, 1 );

			putsliderbar(200, 150, &firstsliderbar, &frezarka, tftbufslider1, tftparamslider1);
		    putslidervalue(364, 180, &firstvalue, &frezarka, tftbufvalue1, tftparamvalue1);
		}

		putbuttons1(&firstbuttons); //narysowanie przyciskow jezeli weszlismy w podmenu pierwszy raz lub nastapila zmiana wartosci
		controltimerlamp();
		controlczas();

		ControlOutputs();

		if(!timeranime)  //warunek sprawdzajacy czy mozna podjac animacje
		{
			animecross(750, 21);
			animeset(250, 27, 550, 52, Blue3, &anim2);
			chosefont=1;
			tft_mputs( 308, 25, "FREZARKA",  Black1, 0xffff, 1 );
			timeranime=800;
		}


		if( gettouchvalue())  //sprawdzenie czy nacisnieto panel dotykowy
		{
						touchexit(); //sprawdzenie czy nie nastapilo wyjscie do menu glownego
						touchmenu1(); //oblsuga wszystkich furnkcji w podmenu1
		}
	}//Koniec podmenu 1 frezarka
	//---------------------------------------------------------------------------
	//Podmenu 2  - Manicure
	while(menu==2)
	{
		//Pierwsze rysowanie po wejscu w dane podmenu
		if(flagamenu)
		{
			flagamenu=0;
			chosefont=1;
			tft_mputs( 308, 25, "LAMPA UV",  Black1, 0xffff, 1 );

			chosefont=2;
			tft_mputs( 265, 75, "Moc lampy nr 1",  Black1, 0xffff, 1 );
			putsliderbar(200, 100, &firstsliderbar, &lampa1, tftbufslider1, tftparamslider1);
		    putslidervalue(364, 130, &firstvalue, &lampa1, tftbufvalue1, tftparamvalue1);
		    firstsliderbar=1;  //zezwolenie na pierwsze narysowanie sliderbara
		    firstvalue=1; //zezwolenie na ponowne narysowaie wartosci
			tft_mputs( 265, 160, "Moc lampy nr 2",  Black1, 0xffff, 1 );
			putsliderbar(200, 185, &firstsliderbar, &lampa2, tftbufslider2, tftparamslider2);
			putslidervalue(364, 215, &firstvalue, &lampa2, tftbufvalue2, tftparamvalue2);
		}

		putbuttons2(&firstbuttons);   //wstawienie przyciskow dla podmenu2
		animearrows1(lampa1.onoff, lampa2.onoff, &arrows);
		controltimerlamp();
		controlczas();

		ControlOutputs();

		//Narysowanie wartosci dla timerow
		puttimevalue(176, 290, &lampa1, &temptimer1);
		puttimevalue(551, 290, &lampa2, &temptimer2);

		if(!timeranime)  //warunek sprawdzajacy czy mozna podjac animacje
		{
			animecross(750, 21);
			animeset(250, 27, 550, 52, Blue3, &anim2);
			chosefont=1;
			tft_mputs( 308, 25, "LAMPA UV",  Black1, 0xffff, 1 );
			timeranime=800;
		}


		if( gettouchvalue())  //sprawdzenie czy nacisnieto panel dotykowy
		{
			touchexit(); //sprawdzenie czy nie nastapilo wyjscie do menu glownego
			touchmenu2(); //oblusga touch panelu dla podmenu 2
		}
	}//Koniec podmenu 2 manicure
	//---------------------------------------------------------------------------
	//Podmenu 3  - Timer
	while(menu==3)
	{
		//Pierwsze rysowanie po wejscu w dane podmenu
		if(flagamenu)
		{
			flagamenu=0;
			chosefont=1;
			tft_mputs( 285, 25, "CZASOMIERZ",  Black1, 0xffff, 1 );
		}

		 putbuttons3(100, &firstbuttons, &czasomierz1, 1);
		 putbuttons3(275, &firstbuttons2, &czasomierz2, 2);
		 animearrows2(czasomierz1.onoff, czasomierz2.onoff, &arrows);
		 controltimerlamp();
		 controlczas();

		 ControlOutputs();

		 //Narysowanie wartosci dla czasomierzy
		 puttimevalue2(355, 135, &czasomierz1, &tempczas1);
		 puttimevalue2(355, 310, &czasomierz2, &tempczas2);

		if(!timeranime)  //warunek sprawdzajacy czy mozna podjac animacje
		{
			animecross(750, 21);
			animeset(250, 27, 550, 52, Blue3, &anim2);
			chosefont=1;
			tft_mputs( 285, 25, "CZASOMIERZ",  Black1, 0xffff, 1 );
			timeranime=800;
		}


		if( gettouchvalue())  //sprawdzenie czy nacisnieto panel dotykowy
		{
			touchexit(); //sprawdzenie czy nie nastapilo wyjscie do menu glownego
			touchmenu3(); //obsluga wszystkich przyciskow
		}
	}//Koniec podmenu 3 Timer
	//---------------------------------------------------------------------------
	//Podmenu 4  - Ustawienia
	while(menu==4)
	{
		//Pierwsze rysowanie po wejscu w dane podmenu
		if(flagamenu)
		{
			flagamenu=0;
			chosefont=1;
			tft_mputs( 285, 25, "USTAWIENIA",  Black1, 0xffff, 1 );

			chosefont=4;  //W:14  H:16
			tft_mputs( 142, 144, "Dotknij dyskietk aby",  Pink1, 0xffff, 1 );
			tft_mputs( 163, 160, "zapisa ustawienia",  Pink1, 0xffff, 1 );

			tft_mputs( 149, 286, "Dotknij arwk, eby",  Pink1, 0xffff, 1 );
			tft_mputs( 121, 302, "zmieni moc podwietlenia",  Pink1, 0xffff, 1 );
		}


		putsave(540, 112, Blue3, &firstsave, &animesave);    //funkcja rysujaca animowana dyskietke
		putbulb(540, 254, Blue3, &firstbulb, powerbacklight);
		controltimerlamp();
		controlczas();

		ControlOutputs();

		if(!timeranime)  //warunek sprawdzajacy czy mozna podjac animacje
		{
			animecross(750, 21);
			animeset(250, 27, 550, 52, Blue3, &anim2);
			chosefont=1;
			tft_mputs( 285, 25, "USTAWIENIA",  Black1, 0xffff, 1 );
			timeranime=800;
		}


		if( gettouchvalue())  //sprawdzenie czy nacisnieto panel dotykowy
		{
			touchexit(); //sprawdzenie czy nie nastapilo wyjscie do menu glownego
			touchmenu4(); //oblusga touch panelu w podmenu 2
		}
	}//Koniec podmenu 4 ustawienia
	//---------------------------------------------------------------------------
}
//Koniec gwnej petli programu
//-------------------------------------------------------------------------------------------------------------------------
}


//-------------------------------------------------------------------------------------------------------------------------
//Procedury programowe
void RCC_init(void)
{

	// #define HSE_VALUE    ((uint32_t)8000000) w plliku stm32f4xx.h
	RCC_DeInit();																					//deinicjalizacja zegarow RCC

	//Wylaczenie zegara LSE - ustawienie portow PC14 PC15 jako GPIO


	RCC_HSEConfig(RCC_HSE_ON);                            //zalaczenie szyny HSE

	while(ERROR==RCC_WaitForHSEStartUp());                //odczekaj na zalaczenie HSE
	while(RCC_GetFlagStatus(RCC_FLAG_HSERDY)==RESET);     //sprawdzenie flagi zalaczenia HSE

	FLASH_PrefetchBufferCmd(ENABLE);
	FLASH_SetLatency(FLASH_Latency_2);

	 //fvco=fin * PLLN/PLLM    konfigurowanie petli PLL  --> przy kwarcu 8Mhz -> HCLK->120Mhz
	//fpllout=fvco/PLLP
	RCC_PLLConfig(RCC_PLLSource_HSE,  4,  120, 2, 6);
																				//fusb=fVco/PLLQ
	RCC_PLLCmd(ENABLE);															//zalacz petle PLL
	while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY)==RESET);			                //sprawdzenie flagi zalaczenia petli PLL

	RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);						            //ustawienie zrodla zegara systemowego jako wyjscie z petli PLL
	RCC_HCLKConfig(RCC_SYSCLK_Div1);											// ustawienie AHB(HCLK) jako preskaler=1
	RCC_PCLK1Config(RCC_HCLK_Div1);                                             //ustawienie preskalera na szynie Pheripheralclokc HCLK(AHB)->prescaler
	RCC_PCLK2Config(RCC_HCLK_Div1);                                             //ustawienie preskalera na szynie Pheripheralclokc HCLK(AHB)->prescaler


	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE);                       //zalaczenie taktowania na szyne AHB1 odpowiedzialna
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC | RCC_AHB1Periph_GPIOB, ENABLE);																										//za porty GPIO
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);                       //zalaczenie sygnalu zegarowego na GPIOA - przerwanie zewnetrzne pin1

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1, ENABLE);                        //zalaczenie taktowanie SPI1

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG, ENABLE);

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR, ENABLE);
	PWR_BackupAccessCmd(ENABLE);
	RCC_LSEConfig(RCC_LSE_OFF);

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM4, ENABLE);                      //Zalaczenie Time4

	SystemCoreClockUpdate();
}

void GPIO_init(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure;                  //konfigurowanie za pomoca klasy publicznej portow wejscia i wyjscia

 //Porty uzytkowe do sterowania buzzerami, kierunkiem silnikow,
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 | GPIO_Pin_4;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;          //Port uzywany jako wyjsciowy
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;         //Port uzywany jako zwykly port typu Pull Push
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;     //Czestotliwosc taktowania ustawiona na 100Mhz
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;       //Pull up pull down wstepnie jako no pull
  GPIO_Init(GPIOD, &GPIO_InitStructure);

  //Ustawienie wszystkich portow w stan wysoki
  //GPIOD->BSRRL = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 | GPIO_Pin_4;
  //Ustawienie wszystkich portow w stan niski
  GPIOD->BSRRH = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 | GPIO_Pin_4;

  //Port odpowiedzialny za ponowne uruchomienie kalibracji podczas uruchomienia procesora
  GPIO_InitStructure.GPIO_Pin =   GPIO_Pin_0 ;
  GPIO_InitStructure.GPIO_Mode =  GPIO_Mode_IN;          //Port uzywany jako wejsciowy
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;         //Port uzywany jako zwykly port typu Pull Push
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;     //Czestotliwosc taktowania ustawiona na 100Mhz
  GPIO_InitStructure.GPIO_PuPd =  GPIO_PuPd_DOWN;       //Podciagniecie do dolu
  GPIO_Init(GPIOA, &GPIO_InitStructure);


  //	TIM-1	PA-8 _CH1 - moc frezarki      PA-9 _CH2  PA-11 - moc podsiwtlenia wyswietlacza
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;          //Port uzywany jako wyjsciowy
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;         //Port uzywany jako zwykly port typu Pull Push moze byc zastapiony 																											 //jako OPEN DRAIN
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;     //Czestotliwosc taktowania ustawiona na 100Mhz
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;       //Pull up pull down wstepnie jako PULL UP, mozna ustaiwc 																										 //DOWN , albo NOPULL
  GPIO_Init(GPIOD, &GPIO_InitStructure);

  GPIOD->BSRRH = GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15 ;

  GPIO_PinAFConfig(GPIOD, GPIO_PinSource12, GPIO_AF_TIM4);               //ustawienie wyjscia alternatywnego dla danego timera
  GPIO_PinAFConfig(GPIOD, GPIO_PinSource13, GPIO_AF_TIM4);
  GPIO_PinAFConfig(GPIOD, GPIO_PinSource14, GPIO_AF_TIM4);
  GPIO_PinAFConfig(GPIOD, GPIO_PinSource15, GPIO_AF_TIM4);
}

void Systick_init(void)
{
	while(SysTick_Config(12000));					   //przerwanie co 0,0001=0,1ms
	SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK);  //podzial czestotliwosci HCLK przez 1
	NVIC_SetPriority(SysTick_IRQn,1);                 //tutaj mozna takze uzyc funkcji do zmiany priorytetu przerwania																																																								//w VIC
}



void PWMTIMER1_init(void)
{
	  TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
	  TIM_OCInitTypeDef  TIM_OCInitStructure;


	  // Konfiguracja TIM3
	  // Ustawienia ukladu podstawy czasu
	  TIM_TimeBaseStructure.TIM_Prescaler = 0x04;         // prescelera (prescaler=256)
	  TIM_TimeBaseStructure.TIM_Period = 10000ul;       //czestotliwosc
	  TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;
	  TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;

	  TIM_TimeBaseInit(TIM4, &TIM_TimeBaseStructure);

	  // Kanaly 1 nie uzywane natomiast 3,4,2 uzywamy

	  TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1; //tryb pwm
	  TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
	  TIM_OCInitStructure.TIM_Pulse = 0ul;          //poczatkowe wypelnienie maksymalne (TIMpulse/Timperiod)*100%=100%
	  TIM_OCInitStructure.TIM_OCPolarity=TIM_OCPolarity_High;

	  TIM_OC4Init(TIM4, &TIM_OCInitStructure);
	  TIM_OC4PreloadConfig(TIM4, TIM_OCPreload_Enable);//wlaczenie buforowania

	  TIM_OC3Init(TIM4, &TIM_OCInitStructure);
	  TIM_OC3PreloadConfig(TIM4, TIM_OCPreload_Enable);//wlaczenie buforowania

	  TIM_OC2Init(TIM4, &TIM_OCInitStructure);
	  TIM_OC2PreloadConfig(TIM4, TIM_OCPreload_Enable);//wlaczenie buforowania

	  TIM_OC1Init(TIM4, &TIM_OCInitStructure);
	  TIM_OC1PreloadConfig(TIM4, TIM_OCPreload_Enable);//wlaczenie buforowania


	  TIM_ARRPreloadConfig(TIM4, ENABLE);//wlaczenie buforowania
	  // Wlaczenie timera
	  TIM_Cmd(TIM4, ENABLE);

	  TIM4->CCR2=0;  //wylaczenie w pierwszej chwili lamp
	  TIM4->CCR3=0;
}
//----------------------------------------------------------------------------------------------------------------------------------
//Funkcja kalibracyjna

 void lcdputvalue(u16 x, u16 y, u16 value)
{
	u16 tysieczne, setne, dziesietne, jednosci; //zmienne ktore przechowywuja wartosci do wpisania w bufor i wyswietlenia
	//obliczenie ile jest tysiecznych, setnych, dziesietnych i jednosci
	char buforvalue[8];

	tysieczne=value/1000;
  setne=(value-(1000*tysieczne))/100;
	dziesietne=(value-(1000*tysieczne)-(100*setne))/10;
	jednosci=value-(1000*tysieczne)-(100*setne)-(10*dziesietne);

	//wpisanie do buforvalue wartosci w kodzie ASCII
	buforvalue[0]=0x30+tysieczne;
	buforvalue[1]=0x30+setne;
	buforvalue[2]=0x30+dziesietne;
	buforvalue[3]=0x30+jednosci;
	buforvalue[4]=0x20; //znak spacji
	buforvalue[5]=0x20;
	buforvalue[6]=0x20;
	buforvalue[7]=0x20; //znak spacji

	tft_mputs( x, y, buforvalue, White, Red2, 0);
}

 //-----------------------------------------------------------------------------------------------------------------------------------
 void calibrationtouch(void)
 {

 	uint16_t touchval[3][3] = {{1,1,1}, {1,1,1}, {1,1,1}};   //Talbica wartosci z przetwornika przy czym
 	//pierwszy element x, drugi y a trzeci 1 - poniewaz tak wyglada macierz
 	int32_t transtouch[3][3];                                     //macierz trans dla macierzy touchval
 	uint32_t dettouch; 										  //wyznacznik macierzy touchval
 	//wspolrzende punktow ktore beda rysowane
 	uint16_t wsppx[3]={40, 400, 750};
 	uint16_t wsppy[3]={40, 450, 240};
 	float invtouch[3][3];                       // inwersja  macierzy A
 	float temporarytouch;

 	uint8_t ip, jp;


 	ms=20000;  //odczekanie 2s
 	while(ms);

 												  //Pierwszy punkt
 	full_rect( 39, 39, 41, 41, 0xf000);            //punkt x=15 y=15


 	 ms=20000;  //odczekanie 2s
 	 while(ms)
 	 	{
 		gettouchvalue();   //pobieraie wartosci z kontrolera oraz usrednianie
 	    }


 	touchval[0][0] = Xtouch;
 	touchval[0][1] = Ytouch;

 	full_rect( 39, 39, 41, 41, 0xffff);			  //Drugi punkt
 	full_rect( 399, 449, 401, 451, 0xf000);        //punkt x=160, y=225



 	    ms=20000;  //odczekanie 2s
 	 	while(ms)
 	 	{
 		gettouchvalue();   //pobieraie wartosci z kontrolera oraz usrednianie
     	}


 	touchval[1][0] = Xtouch;
 	touchval[1][1] = Ytouch;

 	full_rect( 399, 449, 401, 451, 0xffff);        //Trzeci punkt
 	full_rect( 749, 239, 751, 241, 0xf000);        // punkt x=305 y=120



    	ms=20000;  //odczekanie 2s
 	 	while(ms)
 	 	{
 		gettouchvalue();   //pobieraie wartosci z kontrolera oraz usrednianie
 	    }



 	touchval[2][0] = Xtouch;
 	touchval[2][1] = Ytouch;

 	LCD_Clear(0xffff);			   //wyczyszczenie ekranu

 	//obliczanie wyznacznika macierzy pobranych polozen z rownania
 	dettouch = ((touchval[0][0])*(((touchval[1][1])*(touchval[2][2]))-((touchval[1][2])*(touchval[2][1])))) +
 	((touchval[0][1])*(((touchval[1][2])*(touchval[2][0])) - ((touchval[2][2])*(touchval[1][0])))) +
 	((touchval[0][2])*(((touchval[1][0])*(touchval[2][1])) - ((touchval[1][1])*(touchval[2][0]))));

 	//obliczanie elementow macierzy odwroconej za pomoca wzorow - na minior (elementy jeszcze nie podzielone przez wyznacznik)
 	transtouch[0][0] = (touchval[1][1] * touchval[2][2]) - (touchval[1][2] * touchval[2][1]);
 	transtouch[1][0] = (touchval[1][2] * touchval[2][0]) - (touchval[1][0] * touchval[2][2]);
 	transtouch[2][0] = (touchval[1][0] * touchval[2][1]) - (touchval[1][1] * touchval[2][0]);
 	transtouch[0][1] = (touchval[2][1] * touchval[0][2]) - (touchval[0][1] * touchval[2][2]);
 	transtouch[1][1] = (touchval[0][0] * touchval[2][2]) - (touchval[2][0] * touchval[0][2]);
 	transtouch[2][1] = (touchval[2][0] * touchval[0][1]) - (touchval[0][0] * touchval[2][1]);
 	transtouch[0][2] = (touchval[0][1] * touchval[1][2]) - (touchval[1][1] * touchval[0][2]);
 	transtouch[1][2] = (touchval[0][2] * touchval[1][0]) - (touchval[0][0] * touchval[1][2]);
 	transtouch[2][2] = (touchval[0][0] * touchval[1][1]) - (touchval[0][1] * touchval[1][0]);

 	//Obliczenie odwrotnosci
 	temporarytouch = 1/((float)dettouch);

 	//obliczenie wszystkich elementow odwrotnej macierzy
 	for(ip=0;ip<3;ip++)
 	{
 	for(jp=0;jp<3;jp++)
 	{
 	invtouch[ip][jp] = temporarytouch * ((float)transtouch[ip][jp]);
 	}
 	}

 	aX = invtouch[0][0]*(float)wsppx[0] + invtouch[0][1]*(float)wsppx[1] +
 	invtouch[0][2]*(float)wsppx[2];
 	bX = invtouch[1][0]*(float)wsppx[0] + invtouch[1][1]*(float)wsppx[1] +
 	invtouch[1][2]*(float)wsppx[2];
 	dX = invtouch[2][0]*(float)wsppx[0] + invtouch[2][1]*(float)wsppx[1] +
 	invtouch[2][2]*(float)wsppx[2];

 	aY = invtouch[0][0]*(float)wsppy[0] + invtouch[0][1]*(float)wsppy[1] +
 		 invtouch[0][2]*(float)wsppy[2];
 	bY = invtouch[1][0]*(float)wsppy[0] + invtouch[1][1]*(float)wsppy[1] +
 		 invtouch[1][2]*(float)wsppy[2];
 	dY = invtouch[2][0]*(float)wsppy[0] + invtouch[2][1]*(float)wsppy[1] +
 		 invtouch[2][2]*(float)wsppy[2];




 	//w tym miejscu nastepuje zapis wspolczynnikow kalibracji do pamieci flash
 	//-------------------------------------------------------------------
 	Flash_zapis2();
 	//-------------------------------------------------------------------

 }


 //funkcja zwracajaca wartosci wspolrzednych po dotknieciu ekranu
 uint8_t gettouchvalue(void)
 {
 	float temp1, temp2;
 	uint8_t k;
 	uint8_t temp=0;

 	uint32_t bigx=0, bigy=0;

 	if(!touchms)
 	{
 		touchms=50; //5ms pomiedzy pomiarami


 		bufty[globalk]=ADS_Read_AD(CMD_RDX);
 		buftx[globalk]=ADS_Read_AD(CMD_RDY);


 		//Wyelyminowanie dodatkowych zaklocen (fluktuacji )
 		if(buftx[globalk]>100  && buftx[globalk]<4000  && bufty[globalk]>100  && bufty[globalk]<4000)
 		globalk++;
 		else globalk=0;
 	}

 	 if(globalk==4)
 			 		{
 			 			k=globalk;
 			 			//wykasowanie poprzedniego wyniku
 			 			globalk=0;

 			 			for(k=0;k<4; k++)
 			 			{

 			 				bigx+=buftx[k];
 			 				bigy+=bufty[k];
 			 			}

 			 			Xtouch=bigx/k;
 			 			Ytouch=bigy/k;


 		if(wykalibrowano)
 		{

 			if(Ytouch>ycal2 && Ytouch<ycal1 && Xtouch>xcal2 && Xtouch<xcal1) //jezeli odczytana wartosc miesci sie w granicach zmiennych granicznych
 			{

 			temp1 = aX*(float)Xtouch + bX*(float)Ytouch + dX;
 			temp2 = aY*(float)Xtouch + bY*(float)Ytouch + dY;

 			Xtouch=temp1;
 			Ytouch=temp2;
 			temp=1;


 		    }
 			else
 				{
 					Xtouch=0;
 					Ytouch=0;
 					temp=0;
 				}

 			return temp;
 		 }

 			 		}
 	 return temp;

 }

 //----------------------------------------------------------------------------------------
 //Funkcja serwisowa sprawdzajaca dzialanie panelu dotykowego
 #if testkalibracji==1
 void testcalib(void)
 {

	 tft_round_rect(200, 140, 400, 200, 80, Red2, Red2);
	 chosefont=2;

		//---------------------------------------------------------------------
		while(1) //Petla zatrzymujaca program i testujaca tyko program
		{

			lcdputvalue(345, 220, Xtouch);
			lcdputvalue(345, 260, Ytouch);
			if(!ms)
			{
			gettouchvalue();
			ms=200;
			}
		}

 }
#endif

 void delayms(uint32_t mms)
 {
	 ms=mms*10;
	 while(ms)
	 {

	 }
 }

 //-----------------------------------------------------------------------------------------
 //Graficzne funkcje uzytkowe

 void drawanimealpharectangle(uint16_t x, uint16_t y, uint16_t width, uint16_t heigh)
 {
	 uint16_t temp1=0, temp2=0, d=0, k=0, s=0, m=0;
	 uint8_t flaga1=1, flaga2=1;

	 temp1=width/2;
	 temp2=heigh/2;

	 //sprawdzenie czy nie zostaly podane bledne argumenty;
	 if(width%2) return;
	 if(heigh%2) return;
	 if(x<(temp1)) return;
	 if(y<(temp2)) return;


	 do
	 {
		 full_rectalpha( x-d, y-k, x-s, y+k, White);
		 full_rectalpha( x+s, y-k, x+d, y+k, White);
		 full_rectalpha( x-s, y-k, x+s, y-m, White);
		 full_rectalpha( x-s, y+m, x+s, y+k, White);


		if(flaga1)
			{
			s=d;
			d+=2;
			if(d>temp1)
				{
				d=temp1;
				flaga1=0;
				}
			}
		if(flaga2)
			{
			m=k;
			k+=2;
			if(k>temp2)
				{
				k=temp2;
				flaga2=0;
				}
			}



	 } while(flaga1 || flaga2);

 }
//wyczyszczenie ekranu poprzez usuniecie animowane kwadratu alpha
void hideanimealpharectangle(uint16_t x, uint16_t y, uint16_t width, uint16_t heigh)
{
	     uint16_t temp1=0, temp2=0, d=0, k=0, s=0, m=0;
		 uint8_t flaga1=1, flaga2=1;

		 temp1=width/2;
		 temp2=heigh/2;

		 //sprawdzenie czy nie zostaly podane bledne argumenty;
		 if(width%2) return;
		 if(heigh%2) return;
		 if(x<(temp1)) return;
		 if(y<(temp2)) return;

         d=temp1;
         k=temp2;
		 do
		 {
			if(flaga1)
				{
				s=d;
				d-=2;
				if(d<=2) flaga1=0;
				}
			if(flaga2)
				{
				m=k;
				k-=2;
				if(k<=2) flaga2=0;
				}


			putrectanglefromtable( x-s, y-m, x-d, y+m, wallpaper);
			putrectanglefromtable( x+d, y-m, x+s, y+m, wallpaper);
			putrectanglefromtable( x-d, y-m, x+s, y-k, wallpaper);
			putrectanglefromtable( x-d, y+k, x+s, y+m, wallpaper);

		 } while(flaga1 || flaga2);

}

//Animowanie pojawienie sie paska menu
void menuanimbelt(uint16_t x, uint16_t y, uint16_t width, uint16_t height)
{

	         uint16_t temp1=0, temp2=0, d=0, k=0, deltak=2, deltam=1, deltas=1;
			 uint8_t flaga1=1, flaga2=1, i;


			 temp1=width/2;
			 temp2=height/2;

			 //sprawdzenie czy nie zostaly podane bledne argumenty;
			 if(width%2) return;
			 if(height%2) return;
			 if(x<(temp1)) return;
			 if(y<(temp2)) return;

			 do
			 {
				if(flaga1)
					{
					d+=deltak;
					if(d>=temp1) flaga1=0;
					}
				if(flaga2)
					{
					k+=deltak;
					if(k>=temp2) flaga2=0;
					}


				if(d<(temp1-25)) full_rect3( x-d, y-k, x+d, y+k, Blue3); else {
					full_rect3( x-d, y-k+deltam, x+d, y+k-deltam, Blue3);
					deltas++;

					deltam=deltas*deltas/8;

				}

			 } while(flaga1 || flaga2);

				for(i=1; i<5; i++)
				{
					tft_line2(x-temp1+(i*120), y-temp2+5,x-temp1+(i*120),y+temp2-5,White);
				}
}

//Funkcja graficzna odpowiedzialna za zaznaczone menu
void zaznmenu(uint8_t *wmenu, uint8_t *flagazaznacz)
{
	static uint8_t kolor1=0, kolor2=0, kolor3=0, kolor4=0, deltax=12, flagapomocnicza=0;


	//W tym miejscu nastepuje wykasowanie koloru ikon do biaej wartosci
		if(*flagazaznacz!=*wmenu)
		{
			*flagazaznacz=*wmenu;
			putmonograph(108, 188, White, Black1, 104, 104,graphmenu1, 1);
			putmonograph(228, 188, White, Black1, 104, 104,graphmenu2, 1);
			putmonograph(348, 188, White, Black1, 104, 104,graphmenu3, 1);
			putmonograph(468, 188, White, Black1, 104, 104,graphmenu4, 1);
			putmonograph(588+deltax, 200, White, Blue3, 80, 80,graphmenu5, 0);

			putfrombufor(tftbuf1, tftparam1, 250, 99);
			chosefont=7;
			if(*wmenu==1) tft_mputs( 280, 100, "Frezarka", Black1, Black1, 1 );
			if(*wmenu==2) tft_mputs( 280, 100, "Lampa UV", Black1, Black1, 1 );
			if(*wmenu==3) tft_mputs( 250, 100, "Czasomierz",Black1, Black1, 1 );
			if(*wmenu==4) tft_mputs( 250, 100, "Ustawienia", Black1, Black1, 1 );

			kolor2=0; kolor3=0; kolor4=0; kolor1=0;  //po zmianie zaznaczenia ustawinie wszystkich kolorow na zero
		}

if(!timeranime) //Opoznienie czasowe pomiedzy animacjami zmiany kolorw
{
	timeranime=900;

	if(*wmenu==1)
	{
		kolor1++;
		if(kolor1>11) kolor1=0;
	    kolor2=0; kolor3=0; kolor4=0;
	    putmonograph(108, 188, colorbufer[kolor1], Black1, 104, 104,graphmenu1, 1);
	}
	if(*wmenu==2)
	{
		kolor2++;
		if(kolor2>11) kolor2=0;
		kolor1=0; kolor3=0; kolor4=0;
		putmonograph(228, 188, colorbufer[kolor2], Black1, 104, 104,graphmenu2, 1);
	}
	if(*wmenu==3)
	{
		kolor3++;
		if(kolor3>11) kolor3=0;
		kolor1=0; kolor2=0; kolor4=0;
		putmonograph(348, 188, colorbufer[kolor3], Black1, 104, 104,graphmenu3, 1);
	}
	if(*wmenu==4)
	{
		kolor4++;
		if(kolor4>11) kolor4=0;
		kolor1=0; kolor2=0; kolor3=0;
		putmonograph(468, 188,colorbufer[kolor4], Black1, 104, 104,graphmenu4, 1);
	}

	//obsluga strzalek
	if(*wmenu || (deltax!=12))
	{
		if(flagapomocnicza) deltax--; else deltax++;
		if(deltax>23) flagapomocnicza=1; else if(deltax==0) flagapomocnicza=0;

		putmonograph(588+deltax, 200, White, Blue3, 80, 80,graphmenu5, 0);
	}
}


}

//-----------------------------------------------------------------------------------------------
//Fucnkcja obslugi menu glownego
void touchmainmenu(void)
{
	//Zaznaczenie podmenu 1 - frezarka
		if(Xtouch>100 && Xtouch<219 && Ytouch>170 && Ytouch<310)
				{
				if(zaznaczmenu==1) zaznaczmenu=0; else zaznaczmenu=1;

				}
	//Zaznaczenie podmenu 2 - lampa uv
		if(Xtouch>220 && Xtouch<339 && Ytouch>170 && Ytouch<310)
				{
				if(zaznaczmenu==2) zaznaczmenu=0; else zaznaczmenu=2;
				}
		//Zaznaczenie podmenu 3 - czasomierz
		if(Xtouch>340 && Xtouch<459 && Ytouch>170 && Ytouch<310)
				{
			    if(zaznaczmenu==3) zaznaczmenu=0; else zaznaczmenu=3;
				}
		//Zaznaczenie podmenu 4 - ustawienia
		if(Xtouch>460 && Xtouch<579 && Ytouch>170 && Ytouch<310)
				{
		    	if(zaznaczmenu==4) zaznaczmenu=0; else zaznaczmenu=4;
				}
		//Nacisniecie enter w przypadku zaznaczonego podmenu
		if(Xtouch>580 && Xtouch<700 && Ytouch>170 && Ytouch<310)
				{
				if(zaznaczmenu)
					{
					menu=zaznaczmenu;
					flagamenu=1;     //zezwolenie na pierwsze rysowanie w danym podmenu
					timeranime=0;    //wykasowanie timera animacji

					hideanimealpharectangle(400, 240, 750, 440);  //wyczyszczenie wczesniejsze obrazu za pomoca animacji
					drawanimealpharectangle(400, 240, 750, 440);  //narysowanie kwadratu przezroczystosci jako dlo dla wyswietlenia menu
					}
				}
}

//Fucnkja za pomoca ktorej nastepuje wyjscie do menu glownego
void touchexit(void)
{
	if(Xtouch>740 && Xtouch<790 && Ytouch>10 && Ytouch<60)
		{
			menu=0;
			flagamenu=1;
			timeranime=0;  //wykasowanie licnzika animacji
			anim2=1;       //zezwolenie na pierwsze narysowanie animowanego paznokcia
			firstsliderbar=1; //zezwolenie na zbuforowanie obrazu dla sliderbara po wyjsciu z podmenu
			firstvalue=1;   //zezwolenie na zbuforowanie obrazu dla wyswietlenia wartosci
			firstbuttons=1; //ustawienie flagi zezwalajacej na narysowanie przyciskow po wejscu w dane podmenu
			arrows=1;      //zezwolenie na pierwsze narysowanie strzalek
			temptimer1=255; //ustawienie timerow porownawczych dla lamp w celu pierwszego narysowania na wyswietlaczu
			temptimer2=255;
			firstbuttons2=1;  //zezwolenie na narysowanie przyciskow w podmenu 3
			tempczas1=10000;
			tempczas2=10000;
			firstbulb=1;     //zezwolenie na pierwsze narysowanie zarowki
			firstsave=1;     //zezwolenie na pierwsze narysowanie dyskietki
		}
}

//Funkcja rysujaca animowany krzyzyk
void animecross(uint16_t x, uint16_t y)
{
	static uint8_t flaga=0, numer=1, pierwszyodczyt=1;

	if(pierwszyodczyt) //pierwsze odczytanie grafiki z wyswietlacza zanim zostanie wyswietlona animowana grafika
	{
		pierwszyodczyt=0;
		LCD_ReadData(tftbuf2, tftparam2, x-1, y-1, x+25, y+25);
	}

	if(flaga) numer--; else numer++;
	if(numer>5) flaga=1; else if(numer==1) flaga=0;

	putfrombufor(tftbuf2, tftparam2, x-1, y-1);  //wyswietlenie zbuforowanego obszaru grafiki

	switch(numer)
	{
		case 1:
		{
			putmonograph(x, y, Black1, Black1, 24, 24,krzy1, 1);
		break;
		}
		case 2:
		{
			putmonograph(x, y, Black1, Black1, 24, 24,krzy2, 1);
		break;
		}
		case 3:
		{
			putmonograph(x, y, Black1, Black1, 24, 24,krzy3, 1);
		break;
		}
		case 4:
		{
			putmonograph(x, y, Black1, Black1, 24, 24,krzy4, 1);
		break;
		}
		case 5:
		{
			putmonograph(x, y, Black1, Black1, 24, 24,krzy5, 1);
		break;
		}
		case 6:
		{
			putmonograph(x, y, Black1, Black1, 24, 24,krzy6, 1);
		break;
		}
	}
}

//Animowany kwadrat
void animeset(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, uint16_t color, uint8_t *pierwszerysowanie)
{
	static uint16_t deltax=3, flagadeltax=1, deltatt=0, flagadeltatt=1;
	uint16_t xtemp=0, xtemp2=0;


	if(*pierwszerysowanie)
	{
		*pierwszerysowanie=0;
		LCD_ReadData(tftbuf1, tftparam1, x1-2, y1-2, x2+2, y2+2);  //odczytanie fragmentu grafiki z wyswietlacza gdzie beda nazwy
	}

	if(flagadeltax==1) deltax+=5; else deltax-=5;

	if(flagadeltatt) deltatt++; else deltatt--;
	if(deltatt==10) flagadeltatt=0; else if(deltatt==0) flagadeltatt=1;

	xtemp=x1+deltax-deltatt;
	xtemp2=x1+deltax+deltatt+10;

	if(xtemp2>=x2)
	{
		xtemp2=x2;
		flagadeltax=0;
	}
	else if(xtemp<=x1)
	{
		xtemp=x1;
		flagadeltax=1;
	}
	putfrombufor(tftbuf1, tftparam1, x1-2, y1-2);  //wyswietlenie zbuforowanego obszaru grafiki
	full_rect3( xtemp, y1+1, xtemp2, y2-3, Blue3);
}

//funkcja umieszczajaca slider bar na wyswietlaczu
//x, y okresla polozenie, firstdraw okresla czy pierwszy raz nalezy narysowac funkcje po wejscu w dane podmenu, wsk jest wskaznikiem na strukture
void putsliderbar(uint16_t x, uint16_t y, uint8_t *firstdraw, StructParamMan *wsk, uint16_t *buf, uint32_t *param)
{
	uint16_t colortemp, tempval;
	if(wsk->onoff) colortemp=Pink1; else colortemp=Pink2;

	tempval=wsk->value;
	tempval*=4;
	if(tempval>7) tempval=tempval-7; else tempval=0;

	if(*firstdraw)
	{
		*firstdraw=0;  //wykasowanie flagi
		//Narysowanie obramowania
		tft_line2(x, y,x,y+20,Blue3);
		tft_line2(x+400, y,x+400,y+20,Blue3);
		tft_line2(x, y,x+400,y,Blue3);
		tft_line2(x, y+20,x+400,y+20,Blue3);

		LCD_ReadData(buf, param, x-2, y-2, x+400+2, y+20+2);  //odczytanie fragmentu grafiki z wyswietlacza gdzie bedzie sliderbar
	}

	putfrombufor(buf, param, x-2, y-2);  //wyswietlenie zbuforowanego obszaru grafiki pierwszego sliderbara
	full_rect3( x+3, y+3, x+3+tempval, y+17, colortemp);
}

//Funkcja wpisujace poczatkowe parametry po uruchomieniu stacji manicure
void paramafterstart(void)
{
	frezarka.onoff=0;
    lampa1.onoff=0;
    lampa2.onoff=0;
    czasomierz1.onoff=0;
    czasomierz2.onoff=0;
}

//Funkcja rysujaca wartosci mocy lampy lub frezarki w procentach
void putslidervalue(uint16_t x, uint16_t y, uint8_t *firstdraw, StructParamMan *wsk, uint16_t *buf, uint32_t *param)
{
	uint8_t tempvalue, setne, dziesietne, jednosci;
	char buforvalue[5];

	tempvalue=wsk->value;  //odczytanie wartosci do wyswietlenia
	jednosci=tempvalue%10;
	setne=tempvalue/100;
	dziesietne=tempvalue-100*setne;
	dziesietne=dziesietne/10;

	buforvalue[0]=setne+0x30;
	buforvalue[1]=dziesietne+0x30;
	buforvalue[2]=jednosci+0x30;
	buforvalue[3]='%';
	buforvalue[4]=0x00; //znak nul koncacy

	if(*firstdraw)
	{
		*firstdraw=0;
		LCD_ReadData(buf, param, x-2, y-2, x+75, y+20);  //odczytanie fragmentu grafiki z wyswietlacza gdzie bedzie sliderbar
	}
	chosefont=2; //18px wide oraz 18px height
	putfrombufor(buf, param, x-2, y-2);  //wyswietlenie zbuforowanego obszaru grafiki dla wyswietlenia wartosci

	tft_mputs( x, y, buforvalue, Black1, Red2, 1);

}

//Funkcja rysujaca animowane strzalki w podmenu Lampy UV
void animearrows1(uint8_t zalwyl1, uint8_t zalwyl2, uint8_t *firstdraw)
{
	static uint8_t numeranimacji1=1, flagaanimacji1=1, numeranimacji2=1, flagaanimacji2=1, numeranimacjitemp1=1, numeranimacjitemp2=1;
	uint16_t colortemp1=0, colortemp2=0;

	//jezeli funkcja jest pierwszy raz rysowana po wejsciu w dane podmenu
	if(*firstdraw)
	{
	*firstdraw=0;  //wykasowanie flagi zezwalajacej na narysowanie pierwsze

	numeranimacji1=4;
	numeranimacji2=4;

	flagaanimacji1=1;
	flagaanimacji2=1;

	numeranimacjitemp1=0;
	numeranimacjitemp2=0;

	colortemp1=White;
	colortemp2=White;
	}

	if(!timeranime2)
	{
		//Strzalki dla lampy1
		if(!zalwyl1)
		{
			if(flagaanimacji1) numeranimacji1++; else numeranimacji1--;
			if(numeranimacji1==12) flagaanimacji1=0; else if(numeranimacji1==1) flagaanimacji1=1;

			colortemp1=White;
		}
                else if(numeranimacji1!=5)
		{
			if(flagaanimacji1) numeranimacji1++; else numeranimacji1--;
			if(numeranimacji1==12) flagaanimacji1=0; else if(numeranimacji1==1) flagaanimacji1=1;

			colortemp1=Blue3;
		} else colortemp1=Blue3;

		//strzalki dla lampy2
		if(!zalwyl2)
		{
			if(flagaanimacji2) numeranimacji2++; else numeranimacji2--;
			if(numeranimacji2==12) flagaanimacji2=0; else if(numeranimacji2==1) flagaanimacji2=1;

			colortemp2=White;
		}
                else if(numeranimacji2!=5)
		{
			if(flagaanimacji2) numeranimacji2++; else numeranimacji2--;
			if(numeranimacji2==12) flagaanimacji2=0; else if(numeranimacji2==1) flagaanimacji2=1;

			colortemp2=Blue3;
		} else colortemp2=Blue3;

		//jezeli zmienna tymczasowa jest rozna od zmiennej inkremoentowanej lub dekrementowanej to nastepuje narysowanie nowej strzalki
		if(numeranimacji1!=numeranimacjitemp1)
		{
			numeranimacjitemp1=numeranimacji1;

			//dopasowanie dla font 2 -> 18W , 18H
			switch(numeranimacji1)
			{
				case 1:
				{
					putmonograph(65, 290, colortemp1, Pink2, 16, 16,sll1, 0);
					putmonograph(344, 290, colortemp1, Pink2, 16, 16,srr1, 0);
					break;
				}
				case 2:
				{
					putmonograph(65, 290, colortemp1, Pink2, 16, 16,sll2, 0);
					putmonograph(344, 290, colortemp1, Pink2, 16, 16,srr2, 0);
					break;
				}
				case 3:
				{
					putmonograph(65, 290, colortemp1, Pink2, 16, 16,sll3, 0);
					putmonograph(344, 290, colortemp1, Pink2, 16, 16,srr3, 0);
					break;
				}
				case 10:
				{
					putmonograph(65, 290, colortemp1, Pink2, 16, 16,sll3, 0);
					putmonograph(344, 290, colortemp1, Pink2, 16, 16,srr3, 0);
					break;
				}
				case 11:
				{
					putmonograph(65, 290, colortemp1, Pink2, 16, 16,sll2, 0);
					putmonograph(344, 290, colortemp1, Pink2, 16, 16,srr2, 0);
					break;
				}
				case 12:
				{
					putmonograph(65, 290, colortemp1, Pink2, 16, 16,sll1, 0);
					putmonograph(344, 290, colortemp1, Pink2, 16, 16,srr1, 0);
					break;
				}
				default:
				{
					putmonograph(65, 290, colortemp1, Pink2, 16, 16,sll4, 0);
					putmonograph(344, 290, colortemp1, Pink2, 16, 16,srr4, 0);
					break;
				}
			}
		}
		if(numeranimacji2!=numeranimacjitemp2)
		{
			numeranimacjitemp2=numeranimacji2;

			switch(numeranimacji2)
			{
				case 1:
				{
					putmonograph(440, 290, colortemp2, Pink2, 16, 16,sll1, 0);
					putmonograph(719, 290, colortemp2, Pink2, 16, 16,srr1, 0);
					break;
				}
				case 2:
				{
					putmonograph(440, 290, colortemp2, Pink2, 16, 16,sll2, 0);
					putmonograph(719, 290, colortemp2, Pink2, 16, 16,srr2, 0);
					break;
				}
				case 3:
				{
					putmonograph(440, 290, colortemp2, Pink2, 16, 16,sll3, 0);
					putmonograph(719, 290, colortemp2, Pink2, 16, 16,srr3, 0);
					break;
				}
				case 10:
				{
					putmonograph(440, 290, colortemp2, Pink2, 16, 16,sll3, 0);
					putmonograph(719, 290, colortemp2, Pink2, 16, 16,srr3, 0);
					break;
				}
				case 11:
				{
					putmonograph(440, 290, colortemp2, Pink2, 16, 16,sll2, 0);
					putmonograph(719, 290, colortemp2, Pink2, 16, 16,srr2, 0);
					break;
				}
				case 12:
				{
					putmonograph(440, 290, colortemp2, Pink2, 16, 16,sll1, 0);
					putmonograph(719, 290, colortemp2, Pink2, 16, 16,srr1, 0);
					break;
				}
				default:
				{
					putmonograph(440, 290, colortemp2, Pink2, 16, 16,sll4, 0);
					putmonograph(719, 290, colortemp2, Pink2, 16, 16,srr4, 0);
					break;
				}
			}
		}
		timeranime2=1000;  //zmiana wielkosci strzalki co 100ms
	}
}

//obsluga timerow dla lamp
void controltimerlamp(void)
{
	if(lampa1.onoff)
	{
		if(!timerlamp1)
		{
			timerlamp1=10000;
			if(lampa1.lrt) lampa1.lrt--; else lampa1.onoff=0;
		}
	}
	if(lampa2.onoff)
	{
		if(!timerlamp2)
				{
					timerlamp2=10000;
					if(lampa2.lrt) lampa2.lrt--; else lampa2.onoff=0;
				}
	}
}


//obsluga czasomierzy
void controlczas(void)
{
	if(czasomierz1.onoff)
	{
		if(!timerczas1)
		{
			timerczas1=10000;
			if(czasomierz1.value) czasomierz1.value--; else czasomierz1.onoff=0;
		}
	}
	if(czasomierz2.onoff)
	{
		if(!timerczas2)
				{
					timerczas2=10000;
					if(czasomierz2.value) czasomierz2.value--; else czasomierz2.onoff=0;
				}
	}
}

//-------------------------------------------------------------------------------------------------------
//------------------------- Funkcje rysujace jednorazowo przyciski --------------------------------------
//Funkcja rysujaca przyciski w podmenu 1
void putbuttons1(uint8_t *firstdraw)
{
	static StructParamMan tempstruct;

	chosefont=4; //Time new roman 14   h:16  w:14
	if(*firstdraw)
	{
		*firstdraw=0;
		tempstruct.onoff=frezarka.onoff;
		tempstruct.lrt=frezarka.lrt;

		if(tempstruct.lrt)
			{

			tft_round_rect1(250, 220, 100, 50, 10, 1, Pink1);
			tft_mputs( 272, 235, "Lewo", Blue3, Red2, 1);
			tft_round_rect1(450, 220, 100, 50, 10, 1, Pink2);
			tft_mputs( 467, 235, "Prawo", White, Red2, 1);
			}
		else
		{

			tft_round_rect1(250, 220, 100, 50, 10, 1, Pink2);
			tft_mputs( 272, 235, "Lewo", White, Red2, 1);
			tft_round_rect1(450, 220, 100, 50, 10, 1, Pink1);
			tft_mputs( 467, 235, "Prawo", Blue3, Red2, 1);
		}
		if(tempstruct.onoff==1)
		{
			tft_round_rect1(350, 300, 100, 50, 10, 1, Pink1);
			tft_mputs( 360, 315, "Wycz", Blue3, Red2, 1);
		}
		else
		{
			tft_round_rect1(350, 300, 100, 50, 10, 1, Pink2);
			tft_mputs( 360, 315, "Zacz", White, Red2, 1);
		}

	}
	else
	{
		if(tempstruct.onoff!=frezarka.onoff)
		{
			tempstruct.onoff=frezarka.onoff;

			if(tempstruct.onoff==1)
					{
						tft_round_rect1(350, 300, 100, 50, 10, 1, Pink1);
						tft_mputs( 360, 315, "Wycz", Blue3, Red2, 1);
					}
					else
					{
						tft_round_rect1(350, 300, 100, 50, 10, 1, Pink2);
						tft_mputs( 360, 315, "Zacz", White, Red2, 1);
					}
		}
		if(tempstruct.lrt!=frezarka.lrt)
		{
			tempstruct.lrt=frezarka.lrt;

			if(tempstruct.lrt)
					{

					tft_round_rect1(250, 220, 100, 50, 10, 1, Pink1);
					tft_mputs( 272, 235, "Lewo", Blue3, Red2, 1);
					tft_round_rect1(450, 220, 100, 50, 10, 1, Pink2);
					tft_mputs( 467, 235, "Prawo", White, Red2, 1);
					}
				else
				{

					tft_round_rect1(250, 220, 100, 50, 10, 1, Pink2);
					tft_mputs( 272, 235, "Lewo", White, Red2, 1);
					tft_round_rect1(450, 220, 100, 50, 10, 1, Pink1);
					tft_mputs( 467, 235, "Prawo", Blue3, Red2, 1);
				}
		}
	}

}
//Funkcja w pomdenu 2 rysujaca przyciski
void putbuttons2(uint8_t *firstdraw)
{

	static StructParamMan tempstruct1, tempstruct2;
	chosefont=4;  //Time new roman 14   h:16  w:14

	if(*firstdraw)
	{
		*firstdraw=0; //wykasowanie flagi zezwalajacje na pierwsze narysowanie w podmenu 2

		tempstruct1.onoff=lampa1.onoff;
	    tempstruct1.lrt=lampa1.lrt;
	    tempstruct2.onoff=lampa2.onoff;
	    tempstruct2.onoff=lampa2.lrt;

		tft_round_rect1(50, 250, 325, 120, 10, 1, Pink2); //narysowanie kwadratu z zaokraglonymi rogami
		tft_round_rect1(425, 250, 325, 120, 10, 1, Pink2); //narysowanie kwadratu z zaokraglonymi rogami

		chosefont=6;  //Arial black 8pkt H:13px  W:12px
		tft_mputs( 152, 260, "Lampa nr 1", White, Red2, 1);
		tft_mputs( 528, 260, "Lampa nr 2", White, Red2, 1);

		tft_mputs( 147, 320, "Szybki wybr", White, Red2, 1);
		tft_mputs( 521, 320, "Szybki wybr", White, Red2, 1);

		chosefont=2; //18pxH  18pxW
		tft_mputs( 75, 345, "5s 30s 60s 120s", White, Red2, 1);
		tft_mputs( 450, 345, "5s 30s 60s 120s", White, Red2, 1);

		chosefont=4;

		if(tempstruct1.onoff)
		{
			tft_round_rect1(162, 390, 100, 50, 10, 1, Pink1);
			tft_mputs( 172, 405, "Wycz", Blue3, Red2, 1);
		}
		else
		{
			tft_round_rect1(162, 390, 100, 50, 10, 1, Pink2);
			tft_mputs( 172, 405, "Zacz", White, Red2, 1);
		}
		if(tempstruct2.onoff)
		{
			tft_round_rect1(537, 390, 100, 50, 10, 1, Pink1);
			tft_mputs( 547, 405, "Wycz", Blue3, Red2, 1);
		}
		else
		{
			tft_round_rect1(537, 390, 100, 50, 10, 1, Pink2);
			tft_mputs( 547, 405, "Zacz", White, Red2, 1);
		}
	}
	else  //w przypadku gdy nastepuje drugie rysowanie wartosci
	{
		if(tempstruct1.onoff!=lampa1.onoff)
		{
			tempstruct1.onoff=lampa1.onoff;

			if(tempstruct1.onoff)
					{
						tft_round_rect1(162, 390, 100, 50, 10, 1, Pink1);
						tft_mputs( 172, 405, "Wycz", Blue3, Red2, 1);
						putsliderbar(200, 100, &firstsliderbar, &lampa1, tftbufslider1, tftparamslider1);
					}
					else
					{
						tft_round_rect1(162, 390, 100, 50, 10, 1, Pink2);
						tft_mputs( 172, 405, "Zacz", White, Red2, 1);
						putsliderbar(200, 100, &firstsliderbar, &lampa1, tftbufslider1, tftparamslider1);
					}
		}
		if(tempstruct2.onoff!=lampa2.onoff)
		{
			tempstruct2.onoff=lampa2.onoff;

			if(tempstruct2.onoff)
					{
						tft_round_rect1(537, 390, 100, 50, 10, 1, Pink1);
						tft_mputs( 547, 405, "Wycz", Blue3, Red2, 1);
						putsliderbar(200, 185, &firstsliderbar, &lampa2, tftbufslider2, tftparamslider2);
					}
					else
					{
						tft_round_rect1(537, 390, 100, 50, 10, 1, Pink2);
						tft_mputs( 547, 405, "Zacz", White, Red2, 1);
						putsliderbar(200, 185, &firstsliderbar, &lampa2, tftbufslider2, tftparamslider2);
					}
		}
	//-------------------------------------
	//obsluga czasow dla lamp

	}
}

//Funkcja rysujaca wartosci na wyswietlaczu
void puttimevalue(uint16_t x, uint16_t y, StructParamMan *wsk, uint8_t *wsktime)
{
	uint16_t tempcolor=0;
	char buffor[5];

	if(wsk->onoff) tempcolor=Blue3; else tempcolor=White;
	if((wsk->lrt)==0) tempcolor=White;

	if(*wsktime!=(wsk->lrt))
	{
		*wsktime=(wsk->lrt);

		buffor[0]=*wsktime/100;
		buffor[1]=*wsktime-buffor[0]*100;
		buffor[1]=buffor[1]/10;
		buffor[2]=*wsktime%10;
		buffor[3]='s';
		buffor[4]=0x00;
		buffor[0]+=0x30;
		buffor[1]+=0x30;
		buffor[2]+=0x30;

		chosefont=2; //ustawienie czcionki W18px H18px
		tft_mputs( x, y, buffor, tempcolor, Pink2,0 );
	}
}

//Funkcja rysujaca przyciski w menu3 - czasomierz
void putbuttons3(uint16_t y, uint8_t *firstdraw, StructTimeMan *wsk, uint8_t numerczasomierza)
{
	static StructTimeMan temp1, temp2;

	if(*firstdraw) //Pierwsze rysowanie podmenu
	{
		*firstdraw=0;

		tft_round_rect1(250, y, 300, 75, 10, 1, Pink2); //narysowanie kwadratu z zaokraglonymi rogami

		chosefont=6;  //Arial black 8pkt H:13px  W:12px
		if(numerczasomierza==1)
		{
			temp1.onoff=(wsk->onoff);
			tft_mputs( 346, y+10, "Czas nr 1", White, Red2, 1);
		}
		else
		{
			temp2.onoff=(wsk->onoff);
			tft_mputs( 346, y+10, "Czas nr 2", White, Red2, 1);
		}

		chosefont=4;  //Time new roman 14   h:16  w:14
		//Narysowanie przyciskow
		if(wsk->onoff)
		{
			tft_round_rect1(350, y+100, 100, 50, 10, 1, Pink1); //narysowanie kwadratu z zaokraglonymi rogami
			tft_mputs( 358, y+115, "Wycz", Blue3, Red2, 1);
		}
		else
		{
			tft_round_rect1(350, y+100, 100, 50, 10, 1, Pink2); //narysowanie kwadratu z zaokraglonymi rogami
			tft_mputs( 358, y+115, "Zacz", White, Red2, 1);
		}
	}
	//W przypadku gdy funkcja nie jest pierwszy raz wywyolana po wejsciu do danego podmenu
	if(numerczasomierza==1)
	{
	if((temp1.onoff)!=(wsk->onoff))
	{
		temp1.onoff=(wsk->onoff);
		chosefont=4;  //Time new roman 14   h:16  w:14
		if(temp1.onoff)
				{
					tft_round_rect1(350, y+100, 100, 50, 10, 1, Pink1); //narysowanie kwadratu z zaokraglonymi rogami
					tft_mputs( 358, y+115, "Wycz", Blue3, Red2, 1);
				}
				else
				{
					tft_round_rect1(350, y+100, 100, 50, 10, 1, Pink2); //narysowanie kwadratu z zaokraglonymi rogami
					tft_mputs( 358, y+115, "Zacz", White, Red2, 1);
				}
	}
	}
	else
	{
	if((temp2.onoff)!=(wsk->onoff))
	{
		temp2.onoff=(wsk->onoff);
		chosefont=4;  //Time new roman 14   h:16  w:14
		if(temp2.onoff)
				{
					tft_round_rect1(350, y+100, 100, 50, 10, 1, Pink1); //narysowanie kwadratu z zaokraglonymi rogami
					tft_mputs( 358, y+115, "Wycz", Blue3, Red2, 1);
				}
				else
				{
					tft_round_rect1(350, y+100, 100, 50, 10, 1, Pink2); //narysowanie kwadratu z zaokraglonymi rogami
					tft_mputs( 358, y+115, "Zacz", White, Red2, 1);
				}
	}
	}


}

//Funkcja rysujaca animowane strzalki w podmenu Lampy UV
void animearrows2(uint8_t zalwyl1, uint8_t zalwyl2, uint8_t *firstdraw)
{
	static uint8_t numeranimacji1=1, flagaanimacji1=1, numeranimacji2=1, flagaanimacji2=1, numeranimacjitemp1=1, numeranimacjitemp2=1;
	uint16_t colortemp1=0, colortemp2=0;
	const uint16_t y1=135, y2=310;

	//jezeli funkcja jest pierwszy raz rysowana po wejsciu w dane podmenu
	if(*firstdraw)
	{
	*firstdraw=0;  //wykasowanie flagi zezwalajacej na narysowanie pierwsze

	numeranimacji1=4;
	numeranimacji2=4;

	flagaanimacji1=1;
	flagaanimacji2=1;

	numeranimacjitemp1=0;
	numeranimacjitemp2=0;

	colortemp1=White;
	colortemp2=White;
	}

	if(!timeranime2)
	{
		//Strzalki dla lampy1
		if(!zalwyl1)
		{
			if(flagaanimacji1) numeranimacji1++; else numeranimacji1--;
			if(numeranimacji1==12) flagaanimacji1=0; else if(numeranimacji1==1) flagaanimacji1=1;

			colortemp1=White;
		}
                else if(numeranimacji1!=5)
		{
			if(flagaanimacji1) numeranimacji1++; else numeranimacji1--;
			if(numeranimacji1==12) flagaanimacji1=0; else if(numeranimacji1==1) flagaanimacji1=1;

			colortemp1=Blue3;
		} else colortemp1=Blue3;

		//strzalki dla lampy2
		if(!zalwyl2)
		{
			if(flagaanimacji2) numeranimacji2++; else numeranimacji2--;
			if(numeranimacji2==12) flagaanimacji2=0; else if(numeranimacji2==1) flagaanimacji2=1;

			colortemp2=White;
		}
                else if(numeranimacji2!=5)
		{
			if(flagaanimacji2) numeranimacji2++; else numeranimacji2--;
			if(numeranimacji2==12) flagaanimacji2=0; else if(numeranimacji2==1) flagaanimacji2=1;

			colortemp2=Blue3;
		} else colortemp2=Blue3;

		//jezeli zmienna tymczasowa jest rozna od zmiennej inkremoentowanej lub dekrementowanej to nastepuje narysowanie nowej strzalki
		if(numeranimacji1!=numeranimacjitemp1)
		{
			numeranimacjitemp1=numeranimacji1;

			//dopasowanie dla font 2 -> 18W , 18H
			switch(numeranimacji1)
			{
				case 1:
				{
					putmonograph(270, y1, colortemp1, Pink2, 16, 16,sll1, 0);
					putmonograph(514, y1, colortemp1, Pink2, 16, 16,srr1, 0);
					break;
				}
				case 2:
				{
					putmonograph(270, y1, colortemp1, Pink2, 16, 16,sll2, 0);
					putmonograph(514, y1, colortemp1, Pink2, 16, 16,srr2, 0);
					break;
				}
				case 3:
				{
					putmonograph(270, y1, colortemp1, Pink2, 16, 16,sll3, 0);
					putmonograph(514, y1, colortemp1, Pink2, 16, 16,srr3, 0);
					break;
				}
				case 10:
				{
					putmonograph(270, y1, colortemp1, Pink2, 16, 16,sll3, 0);
					putmonograph(514, y1, colortemp1, Pink2, 16, 16,srr3, 0);
					break;
				}
				case 11:
				{
					putmonograph(270, y1, colortemp1, Pink2, 16, 16,sll2, 0);
					putmonograph(514, y1, colortemp1, Pink2, 16, 16,srr2, 0);
					break;
				}
				case 12:
				{
					putmonograph(270, y1, colortemp1, Pink2, 16, 16,sll1, 0);
					putmonograph(514, y1, colortemp1, Pink2, 16, 16,srr1, 0);
					break;
				}
				default:
				{
					putmonograph(270, y1, colortemp1, Pink2, 16, 16,sll4, 0);
					putmonograph(514, y1, colortemp1, Pink2, 16, 16,srr4, 0);
					break;
				}
			}
		}
		if(numeranimacji2!=numeranimacjitemp2)
		{
			numeranimacjitemp2=numeranimacji2;

			switch(numeranimacji2)
			{
				case 1:
				{
					putmonograph(270, y2, colortemp2, Pink2, 16, 16,sll1, 0);
					putmonograph(514, y2, colortemp2, Pink2, 16, 16,srr1, 0);
					break;
				}
				case 2:
				{
					putmonograph(270, y2, colortemp2, Pink2, 16, 16,sll2, 0);
					putmonograph(514, y2, colortemp2, Pink2, 16, 16,srr2, 0);
					break;
				}
				case 3:
				{
					putmonograph(270, y2, colortemp2, Pink2, 16, 16,sll3, 0);
					putmonograph(514, y2, colortemp2, Pink2, 16, 16,srr3, 0);
					break;
				}
				case 10:
				{
					putmonograph(270, y2, colortemp2, Pink2, 16, 16,sll3, 0);
					putmonograph(514, y2, colortemp2, Pink2, 16, 16,srr3, 0);
					break;
				}
				case 11:
				{
					putmonograph(270, y2, colortemp2, Pink2, 16, 16,sll2, 0);
					putmonograph(514, y2, colortemp2, Pink2, 16, 16,srr2, 0);
					break;
				}
				case 12:
				{
					putmonograph(270, y2, colortemp2, Pink2, 16, 16,sll1, 0);
					putmonograph(514, y2, colortemp2, Pink2, 16, 16,srr1, 0);
					break;
				}
				default:
				{
					putmonograph(270, y2, colortemp2, Pink2, 16, 16,sll4, 0);
					putmonograph(514, y2, colortemp2, Pink2, 16, 16,srr4, 0);
					break;
				}
			}
		}
		timeranime2=1000;  //zmiana wielkosci strzalki co 100ms
	}
}

//Funkcja rysujaca wartosci na wyswietlaczu
void puttimevalue2(uint16_t x, uint16_t y, StructTimeMan *wsk, uint16_t *wsktime)
{
	uint16_t tempcolor=0, temptemp=0;
	char buffor[6];


	if(wsk->onoff) tempcolor=Blue3; else tempcolor=White;
	if((wsk->value)==0) tempcolor=White;

	if(*wsktime!=(wsk->value))
	{
		*wsktime=(wsk->value);

		buffor[0]=*wsktime/1000;
		temptemp=*wsktime-buffor[0]*1000;
		buffor[1]=temptemp/100;
		temptemp=temptemp-buffor[1]*100;
		buffor[2]=temptemp/10;
		buffor[3]=*wsktime%10;
		buffor[4]='s';
		buffor[5]=0x00;
		buffor[0]+=0x30;
		buffor[1]+=0x30;
		buffor[2]+=0x30;
		buffor[3]+=0x30;

		chosefont=2; //ustawienie czcionki W18px H18px
		tft_mputs( x, y, buffor, tempcolor, Pink2,0 );
	}
}

//Funkcja rysujaca stan podswietlenia wyswietlacza
void putbulb(uint16_t x, uint16_t y, uint16_t color, uint8_t *firstdraw, uint8_t power)
{
static uint8_t temppower=0;

	if(*firstdraw)
	{
		*firstdraw=0;
		temppower=255;  //ustawienie flagi zezwalajacej na pierwsze narysowanie oraz zbuforowanie obrazu
		LCD_ReadData(tftbufslider2, tftparamslider2, x-1, y-1, x+98, y+98);  //zbuforowanie pierwszego oszaru grafiki
	}

	if(temppower != power)
	{
		temppower=power;  //tylko jednorazowe narysowanie grafiki na wyswietlaczu
		putfrombufor(tftbufslider2, tftparamslider2, x-1, y-1);  //wyswietlenie zbuforowanego obszaru grafiki

		switch(temppower)
		{
			case 1:
			{
			 putmonograph(x, y, color, Black1, 96, 96,bulb1, 1);
	                 break;
			}
			case 2:
			{
			 putmonograph(x, y, color, Black1, 96, 96,bulb2, 1);
	                 break;
			}
			case 3:
			{
			 putmonograph(x, y, color, Black1, 96, 96,bulb3, 1);
	                 break;
			}
			case 4:
			{
			 putmonograph(x, y, color, Black1, 96, 96,bulb4, 1);
	                 break;
			}
			case 5:
			{
			 putmonograph(x, y, color, Black1, 96, 96,bulb5, 1);
	                 break;
			}
			case 6:
			{
			 putmonograph(x, y, color, Black1, 96, 96,bulb6, 1);
	                 break;
			}
			case 7:
			{
			 putmonograph(x, y, color, Black1, 96, 96,bulb7, 1);
	                 break;
			}
			case 8:
			{
			 putmonograph(x, y, color, Black1, 96, 96,bulb8, 1);
	                 break;
			}
		}
	}
}


//Funkcja rysujaca animowana dyskietke w momencie zapisywania
void putsave(uint16_t x, uint16_t y, uint16_t color, uint8_t *firstdraw, uint8_t *animestart)
{
	uint8_t static numer=1, flaganumer=1, dlugosc=1;

	if(*firstdraw)
	{
	   *firstdraw=0;
	   dlugosc=1;
	   timeranime2=0;
	   *animestart=0;
	   numer=1;
	   LCD_ReadData(tftbufslider1, tftparamslider1, x-1, y-1, x+98, y+98);  //zbuforowanie pierwszego oszaru grafiki
           putmonograph(x, y, color, Black1, 96, 96,save1, 1);

	}

	if(*animestart)
	{
		if(!timeranime2)
		{
			if(flaganumer) numer++; else numer--;
			if(numer==6) flaganumer=0; else if(numer==1) flaganumer=1;

		putfrombufor(tftbufslider1, tftparamslider1, x-1, y-1);  //wyswietlenie zbuforowanego obszaru grafiki
	        switch(numer)
        	{
		case 1:
		{
		putmonograph(x, y, color, Black1, 96, 96,save1, 1);
	        break;
		}
		case 2:
		{
		putmonograph(x, y, color, Black1, 96, 96,save2, 1);
	        break;
		}
		case 3:
		{
		putmonograph(x, y, color, Black1, 96, 96,save3, 1);
	        break;
		}
		case 4:
		{
		putmonograph(x, y, color, Black1, 96, 96,save4, 1);
	        break;
		}
		case 5:
		{
		putmonograph(x, y, color, Black1, 96, 96,save5, 1);
	        break;
		}
		case 6:
		{
		putmonograph(x, y, color, Black1, 96, 96,save6, 1);
	        break;
		}
	        }

			dlugosc++;
			if(dlugosc>24)
			{
				dlugosc=1;
			        *animestart=0;
			}
			else  timeranime2=1000;  //zmiana animacji co 100ms
		}
	}
}


//---------------------------------------------------------------------------------------------------------------------------
//---------------------------- Funkcje obslugi touch panelu dla wszystkich podmenu ------------------------------------------
//Funkcja obslugi touch panelu dla podmenu1
void touchmenu1(void)
{
	uint16_t tempvalue;

	//obsluga sliderbara
	if(Xtouch>180 && Xtouch<620 && Ytouch>130 && Ytouch<190)
					{
						if(Xtouch<=200) tempvalue=0;
						else if(Xtouch>=600) tempvalue=100;
						else
						{
							tempvalue=Xtouch-200;
							tempvalue=tempvalue/4;
						}
						frezarka.value=(uint8_t)tempvalue;
						putsliderbar(200, 150, &firstsliderbar, &frezarka, tftbufslider1, tftparamslider1);  //Narysowanie sliderbara
						putslidervalue(364, 180, &firstvalue, &frezarka, tftbufvalue1, tftparamvalue1);       //narysowanie nowej wartosci
					}
	//Obsluga panelow przyciskow
	if(Xtouch>230 && Xtouch<370 && Ytouch>210 && Ytouch<280)
						{
							frezarka.lrt=1;
						}
	if(Xtouch>430 && Xtouch<570 && Ytouch>210 && Ytouch<280)
						{
		                   frezarka.lrt=0;
						}
	if(Xtouch>330 && Xtouch<470 && Ytouch>290 && Ytouch<360)
							{
								if(!timertouch)
								{
									timertouch=3000; //elm drgan 300ms
									if(frezarka.onoff) frezarka.onoff=0; else frezarka.onoff=1;
									putsliderbar(200, 150, &firstsliderbar, &frezarka, tftbufslider1, tftparamslider1);  //Narysowanie sliderbara
								}

							}
}

//Funkcja obslugi touch panelu dla podmenu2
void touchmenu2(void)
{
	uint16_t tempvalue;

	//obsluga sliderbara dla lampy nr 1
	if(Xtouch>180 && Xtouch<620 && Ytouch>80 && Ytouch<140)
	{
			if(Xtouch<=200) tempvalue=0;
			else if(Xtouch>=600) tempvalue=100;
			else
			{
				tempvalue=Xtouch-200;
				tempvalue=tempvalue/4;
			}
			lampa1.value=(uint8_t)tempvalue;
			putsliderbar(200, 100, &firstsliderbar, &lampa1, tftbufslider1, tftparamslider1);
			putslidervalue(364, 130, &firstvalue, &lampa1, tftbufvalue1, tftparamvalue1);
	}
	//obsluga sliderbara dla lampy nr 2
	if(Xtouch>180 && Xtouch<620 && Ytouch>150 && Ytouch<230)
	{
			if(Xtouch<=200) tempvalue=0;
			else if(Xtouch>=600) tempvalue=100;
			else
			{
				tempvalue=Xtouch-200;
				tempvalue=tempvalue/4;
			}
			lampa2.value=(uint8_t)tempvalue;
			putsliderbar(200, 185, &firstsliderbar, &lampa2, tftbufslider2, tftparamslider2);
			putslidervalue(364, 215, &firstvalue, &lampa2, tftbufvalue2, tftparamvalue2);
	}

	//Obsluga szybkiego wyboru dla lampy 1 -> 5 do 120s
	if(Xtouch>68 && Xtouch<120 && Ytouch>330 && Ytouch<370)
		{
		if(!(lampa1.onoff)) lampa1.lrt=5;
		}
	if(Xtouch>121 && Xtouch<192 && Ytouch>330 && Ytouch<370)
			{
			if(!(lampa1.onoff)) lampa1.lrt=30;
			}
	if(Xtouch>193 && Xtouch<264 && Ytouch>330 && Ytouch<370)
				{
				if(!(lampa1.onoff)) lampa1.lrt=60;
				}
	if(Xtouch>265 && Xtouch<355 && Ytouch>330 && Ytouch<370)
				{
					if(!(lampa1.onoff)) lampa1.lrt=120;
				}

//Obsluga szybkiego wyboru dla lampy 2 -> 5 do 120s
	if(Xtouch>443 && Xtouch<495 && Ytouch>330 && Ytouch<370)
			{
			if(!(lampa2.onoff)) lampa2.lrt=5;
			}
		if(Xtouch>496 && Xtouch<567 && Ytouch>330 && Ytouch<370)
				{
				if(!(lampa2.onoff)) lampa2.lrt=30;
				}
		if(Xtouch>568 && Xtouch<639 && Ytouch>330 && Ytouch<370)
					{
					if(!(lampa2.onoff)) lampa2.lrt=60;
					}
		if(Xtouch>640 && Xtouch<730 && Ytouch>330 && Ytouch<370)
					{
						if(!(lampa2.onoff)) lampa2.lrt=120;
					}

	//Inkrementacja oraz dekrementacja czasu dla lampy nr 1
		if(Xtouch>40 && Xtouch<210 && Ytouch>250 && Ytouch<329)
					{
			            if(!(lampa1.onoff))
			            	{
			            	if(lampa1.lrt) lampa1.lrt--;
			            	if(lampa1.lrt<2) lampa1.lrt=2;
			            	}
					}
		if(Xtouch>220 && Xtouch<385 && Ytouch>250 && Ytouch<329)
							{
					            if(!(lampa1.onoff))
					            	{
					            	lampa1.lrt++;
					            	if(lampa1.lrt>250) lampa1.lrt=250;
					            	}
							}
		//Inkrementacja oraz dekrementacja dla kanalu nr 2
		if(Xtouch>415 && Xtouch<580 && Ytouch>250 && Ytouch<329)
							{
					            if(!(lampa2.onoff))
					            	{
					            	if(lampa2.lrt) lampa2.lrt--;
					            	if(lampa2.lrt<2) lampa2.lrt=2;
					            	}
							}
				if(Xtouch>590 && Xtouch<760 && Ytouch>250 && Ytouch<329)
									{
							            if(!(lampa2.onoff))
							            	{
							            	lampa2.lrt++;
							            	if(lampa2.lrt>250) lampa2.lrt=250;
							            	}
									}

	if(!timertouch)
	{
		timertouch=3000;  //ustawienie elyminacji dragan stykow
	//Obsluga przyciskow zalaczajacych lampy
	if(Xtouch>140 && Xtouch<270 && Ytouch>370 && Ytouch<460)
	{
		if(lampa1.onoff) lampa1.onoff=0; else lampa1.onoff=1;
		temptimer1=255;
	}
	if(Xtouch>520 && Xtouch<670 && Ytouch>370 && Ytouch<460)
	{
		if(lampa2.onoff) lampa2.onoff=0; else lampa2.onoff=1;
		temptimer2=255;
	}
	}


}

//Obsluga panelu dotykowego w podmenu3
void touchmenu3(void)
{

	//Inkrementacja oraz dekrementacja czasomierza1
			if(Xtouch>200 && Xtouch<300 && Ytouch>100 && Ytouch<200)
						{
				            if(!(czasomierz1.onoff))
				            	{
				            	if(czasomierz1.value) czasomierz1.value--;
				            	if(czasomierz1.value<2) czasomierz1.value=2;
				            	}
						}

			if(Xtouch>500 && Xtouch<600 && Ytouch>100 && Ytouch<200)
						{
						    if(!(czasomierz1.onoff))
							     {
							      czasomierz1.value++;
							      if(czasomierz1.value>9999) czasomierz1.value=9999;
							      }
						}
			//Inkrementacja oraz dekrementacja czasomierza 1 oraz 2
			if(Xtouch>200 && Xtouch<300 && Ytouch>275 && Ytouch<375)
									{
							            if(!(czasomierz2.onoff))
							            	{
							            	if(czasomierz2.value) czasomierz2.value--;
							            	if(czasomierz2.value<2) czasomierz2.value=2;
							            	}
									}

						if(Xtouch>500 && Xtouch<600 && Ytouch>275 && Ytouch<375)
									{
									    if(!(czasomierz2.onoff))
										     {
										      czasomierz2.value++;
										      if(czasomierz2.value>9999) czasomierz2.value=9999;
										      }
									}

	if(!timertouch)
		{
		timertouch=3000;  //ustawienie elyminacji dragan stykow
		//Obsluga przyciskow zalaczajacych lampy
		if(Xtouch>330 && Xtouch<470 && Ytouch>180 && Ytouch<270)
		        {
					if(czasomierz1.onoff) czasomierz1.onoff=0; else czasomierz1.onoff=1;
					tempczas1=10000;
		        }
		if(Xtouch>330 && Xtouch<470 && Ytouch>355 && Ytouch<445)
				{
			        if(czasomierz2.onoff) czasomierz2.onoff=0; else czasomierz2.onoff=1;
			        tempczas2=10000;
				}
		}
}

//Funkcja obslugi panelu dotykowego w podmenu 4
void touchmenu4(void)
{
	//Obsluga panelu dotkowego
	if(!timertouch)
			{
			timertouch=3000;  //ustawienie elyminacji dragan stykow
			//Obsluga przyciskow
			//Nacisniecie przycisku SAVE, powoduje zapis ustawien do pamieci
			if(Xtouch>530 && Xtouch<650 && Ytouch>100 && Ytouch<225)
			        {
						animesave=1; //zezwolenie na animowanie dyskietki

						//------------------------------------------------------------
						//------------- Zapis do pamieci flash -----------------------
						flagazapiszustawienia=1;
						Flash_zapis2();
						//------------------------------------------------------------
						//------------------------------------------------------------
			        }
			if(Xtouch>530 && Xtouch<650 && Ytouch>240 && Ytouch<365)
					{
				    	powerbacklight++;   //zwiekszenie intensywnosci podswietlenia
				    	if(powerbacklight>8) powerbacklight=1;
					}
			}
}

//------------------------------------------------------------------------------------------
//Funkcje obslugi pamieci FLASH

//---------------------------------------------------------------------------------------------------------------
//---------------------- Funkcje obslugujace pamiec flash uC-----------------------------------------------------

//Funkcja odczytujaca wspolczynniki dla kalibracji touchpanelu
void Flash_odczyt2(void)
{
	uint32_t *p;
	uint32_t  t;
	unsigned int wspolczynnikkalibracji[6];

	 union
	    {
	     unsigned int i;
	     float f;
	     }var1,var2, var3, var4, var5, var6;


	p=(uint32_t *)(Flash_User_Start+4);

	for(t=0; t<=5; t++)
	{
	 wspolczynnikkalibracji[t]=*p; //przepisanie wartosci z fla
	  p++;
	}

	 frezarka.value=*p;
	 p++;
	 frezarka.lrt=*p;
	 p++;
	 lampa1.value=*p;
	 p++;
	 lampa1.lrt=*p;
	 p++;
	 lampa2.value=*p;
	 p++;
	 lampa2.lrt=*p;
	 p++;
	 czasomierz1.value=*p;
	 p++;
	 czasomierz2.value=*p;
	 p++;
	 powerbacklight=*p;  //Maksymalna moc podswietlenia
	 p++;

	var1.i = wspolczynnikkalibracji[0];
	var2.i = wspolczynnikkalibracji[1];
	var3.i = wspolczynnikkalibracji[2];
	var4.i = wspolczynnikkalibracji[3];
	var5.i = wspolczynnikkalibracji[4];
	var6.i = wspolczynnikkalibracji[5];

	aX=var1.f;
	bX=var2.f;
	dX=var3.f;
	aY=var4.f;
	bY=var5.f;
	dY=var6.f;

}

// Wersje drugie dla wspolczynnikow kalibracji panelu oraz kalibracji pomiaru
void Flash_zapis2(void)
{
	 uint32_t   i;
     volatile uint32_t  j;
     unsigned int wspolczynnikkalibracji[6];
     uint32_t ustawienia[9];
     uint32_t *k;

     union
     {
     unsigned int i;
     float f;
     }var1,var2, var3, var4, var5, var6;

     //zrzutowanie zmiennych przecinkowych na unie aby mozna je bylo potem wpisac do pamieci flash jako unsigned int
     var1.f=aX;
     var2.f=bX;
     var3.f=dX;
     var4.f=aY;
     var5.f=bY;
     var6.f=dY;

     wspolczynnikkalibracji[0]=var1.i;
     wspolczynnikkalibracji[1]=var2.i;
     wspolczynnikkalibracji[2]=var3.i;
     wspolczynnikkalibracji[3]=var4.i;
     wspolczynnikkalibracji[4]=var5.i;
     wspolczynnikkalibracji[5]=var6.i;

     k=(uint32_t *)(Flash_User_Start);  //ustawienie wskaznika na adres komorki ktora jest flaga czy juz byl dokonany zapis i pierwsze uruchonmienie
     //Poczatkowe wartosci ktore nalezy wpisac do pamieci flash po pierwszym wgraniu programu
     if(*k!=0x256faba4)
     {
        frezarka.value=50;
     	frezarka.lrt=0;
     	lampa1.value=50;
        lampa1.lrt=100;
        lampa2.value=50;
        lampa2.lrt=100;
        czasomierz1.value=200;
        czasomierz2.value=200;
        powerbacklight=8;  //Maksymalna moc podswietlenia
     }

     //Wpisanie do tablicy aktualnych ustawien
           ustawienia[0]=frezarka.value;
           ustawienia[1]=frezarka.lrt;
           ustawienia[2]=lampa1.value;
           ustawienia[3]=lampa1.lrt;
           ustawienia[4]=lampa2.value;
           ustawienia[5]=lampa2.lrt;
           ustawienia[6]=czasomierz1.value;
           ustawienia[7]=czasomierz2.value;
           ustawienia[8]=powerbacklight;  //Maksymalna moc podswietlenia

 	if(*k!=0x256faba4  || flagaponownejkalibracji || flagazapiszustawienia) //sprawdzenie po zalaczeniu czy pamiec juz byla uzywana i nie jest to pierwszy raz po zapisie
 	{

	//Odblokowanie flash
	FLASH_Unlock();

	//Wyczyszczenie flag
	FLASH_ClearFlag(FLASH_FLAG_EOP | FLASH_FLAG_OPERR | FLASH_FLAG_WRPERR | FLASH_FLAG_PGAERR | FLASH_FLAG_PGPERR|FLASH_FLAG_PGSERR);

	  //Wyczyszczenie ostatniego sektora w pamieci flash
	 if(FLASH_EraseSector(FLASH_Sector_11, VoltageRange_3) != FLASH_COMPLETE)
	 {
	   while (1) {}  //Petla nieskonczona w przypadku wystapienia bledu przy kasowaniu
	 }

	 while(FLASH_COMPLETE!=FLASH_ProgramWord(Flash_User_Start, 0x256faba4))   //zmienna blokujaca nadpisanie przy uruchomieniu
	 {
	 }
	 j=(Flash_User_Start+4);

		//W tym miejscu nastepuje wpisanie zmiennych kalibracyjnych touchpanelu
	 for(i=0; i<=5; i++)
	 {
		 while(FLASH_COMPLETE!=FLASH_ProgramWord(j, wspolczynnikkalibracji[i]))
		 {
		 }
		 j=j+4;
	  }

	 //Zapisanie we flash aktualnych ustawien stacji
	 for(i=0; i<=8; i++)
	 	 {
	 		 while(FLASH_COMPLETE!=FLASH_ProgramWord(j, ustawienia[i]))
	 		 {
	 		 }
	 		 j=j+4;
	 	  }

	flagazapiszustawienia=0;  //Wykasowanie flagi zezwalajacej na zapis ustaiwen
	flagaponownejkalibracji=0;  //Wykasowanie flagi zezwalajacej na zapis nowych wspolczynnikow kalibracji

	FLASH_Lock();  //zablokowanie dostepu do pamieci flash
 	}
}

//----------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------
//Funkcja kontrolujaca stany wyjsc
void ControlOutputs(void)
{
static StructParamMan tempfrezarka, templampa1, templampa2;
static StructTimeMan  tempczasomierz1, tempczasomierz2;
static uint8_t flagaczasomierz1=0, flagaczasomierz2=0, ffcz1=0, ffcz2=0;
static uint8_t temppowerbacklight=0, firstcontrol=1;
static uint8_t pomocnicza1=0;

	if(firstcontrol)  //Pierwsze wpisani wartosci do zmiennych lokalnych
	{
		firstcontrol=0;  //Wykasowanie flagi zezwalajacje na jednorazowe przepisanie wartosci

		temppowerbacklight=powerbacklight;

		tempfrezarka.value=frezarka.value;
		tempfrezarka.onoff=frezarka.onoff;
		tempfrezarka.lrt=frezarka.lrt;

		templampa1.value=lampa1.value;
		templampa1.onoff=lampa1.onoff;
		templampa1.lrt=lampa1.lrt;

		templampa2.value=lampa2.value;
		templampa2.onoff=lampa2.onoff;
		templampa2.lrt=lampa2.lrt;

		tempczasomierz1.onoff=czasomierz1.onoff;
		tempczasomierz2.onoff=czasomierz2.onoff;

		//Poczatkowe ustawienie wyjsc
		TIM4->CCR4=powerbacklight*1250;
		if(frezarka.onoff)
		{
			TIM4->CCR1=(frezarka.value)*100;
			if(frezarka.lrt)
						{
							PD1off;
							PD0on;
						}
						else
						{
							PD0off;
							PD1on;
						}
		}
		else
		{
			TIM4->CCR1=0;
			PD0on;
			PD1on;
		}
		if(lampa1.onoff)   TIM4->CCR2=(lampa1.value)*100; else  TIM4->CCR2=0;
		if(lampa2.onoff)   TIM4->CCR3=(lampa2.value)*100; else  TIM4->CCR3=0;

		PD2off;  //Wylaczenie buzzerow dla czasomierz1, czasomierz2
		PD3off;

	if(frezarka.onoff)
	{
		if(frezarka.lrt)
			{
				PD1off;
				PD0on;
			}
			else
			{
				PD0off;
				PD1on;
			}
	}
	else
	{
		PD0on;
		PD1on;
	}
	}

	if(temppowerbacklight!=powerbacklight)
	{
		temppowerbacklight=powerbacklight;
		TIM4->CCR4=powerbacklight*1250;
	}
	if(tempfrezarka.value!=frezarka.value)
	{
		tempfrezarka.value=frezarka.value;
		if(frezarka.onoff)
		    {
			TIM4->CCR1=(frezarka.value)*100;
			if(frezarka.lrt)
						{
							PD1off;
							PD0on;
						}
						else
						{
							PD0off;
							PD1on;
						}
		    } else
			{
			TIM4->CCR1=0;
			PD0on;
			PD1on;
			}
	}
	if(tempfrezarka.onoff!=frezarka.onoff)
	{

		if(frezarka.onoff)
		    {


			if(tempfrezarka.onoff==0 && !timerrozruch && !pomocnicza1)
			{
				timerrozruch=3000;  //100ms rozruchu
				pomocnicza1=1;
				TIM4->CCR1=10000;   //rozruch silnika
				if(frezarka.lrt)
										{
											PD1off;
											PD0on;
										}
										else
										{
											PD0off;
											PD1on;
										}
			}

			if(pomocnicza1 && !timerrozruch)
			{
				pomocnicza1=0;
				tempfrezarka.onoff=frezarka.onoff;
				TIM4->CCR1=(frezarka.value)*100;
				if(frezarka.lrt)
										{
											PD1off;
											PD0on;
										}
										else
										{
											PD0off;
											PD1on;
										}
			}

		    } else
			{
			TIM4->CCR1=0;
			PD0on;
			PD1on;
			tempfrezarka.onoff=frezarka.onoff;
			pomocnicza1=0;
			timerrozruch=0;
			}
	}
	if(tempfrezarka.lrt!=frezarka.lrt)
	{
		tempfrezarka.lrt=frezarka.lrt;
		if(frezarka.onoff)
		{
		if(frezarka.lrt)
			{
				PD1off;
				PD0on;
			}
			else
			{
				PD0off;
				PD1on;
			}
		}
		else
		{
			PD0on;
			PD1on;
		}
	}
	if(templampa1.value!=lampa1.value)
	{
		templampa1.value=lampa1.value;
		if(lampa1.onoff)   TIM4->CCR2=(lampa1.value)*100; else  TIM4->CCR2=0;
	}
	if(templampa1.onoff!=lampa1.onoff)
	{
		templampa1.onoff=lampa1.onoff;
		if(lampa1.onoff)   TIM4->CCR2=(lampa1.value)*100; else  TIM4->CCR2=0;
	}
	if(templampa2.value!=lampa2.value)
	{
		templampa2.value=lampa2.value;
		if(lampa2.onoff)   TIM4->CCR3=(lampa2.value)*100; else  TIM4->CCR3=0;
	}
	if(templampa2.onoff!=lampa2.onoff)
	{
		templampa2.onoff=lampa2.onoff;
		if(lampa2.onoff)   TIM4->CCR3=(lampa2.value)*100; else  TIM4->CCR3=0;
	}

	if(tempczasomierz1.onoff!=czasomierz1.onoff)
	{
		tempczasomierz1.onoff=czasomierz1.onoff;
		if(czasomierz1.onoff && (czasomierz1.value)) flagaczasomierz1=1;
	}
	if(tempczasomierz2.onoff!=czasomierz2.onoff)
	{
		tempczasomierz2.onoff=czasomierz2.onoff;
		if(czasomierz2.onoff && (czasomierz2.value)) flagaczasomierz2=1;
	}

	if(!(czasomierz1.value) && flagaczasomierz1)
	{
		ffcz1=1;   //zezwolenie na aktywowanie buczka
		flagaczasomierz1=0;   //wykasowanie flagi
	}

	if(ffcz1)    //aktywowanie buczka nr 1
	{
		if(!timerontime1)
		{
			timerontime1=10000;  //odliczenie 1s
			ffcz1++;  //inkrementacja flagi

			PD2on;  //zalaczenie buzzer 1

			if(ffcz1>4)
			{
				PD2off; //wylaczenie buzzera
				ffcz1=0;  //wykasowanie zezwolenia na powtorne wejscie
			}
		}
	}

	if(!(czasomierz2.value) && flagaczasomierz2)
	{
		ffcz2=1;   //zezwolenie na aktywowanie buczka
		flagaczasomierz2=0;   //wykasowanie flagi
	}

	if(ffcz2)    //aktywowanie buczka nr 1
	{
		if(!timerontime2)
		{
			timerontime2=10000;  //odliczenie 1s
			ffcz2++;  //inkrementacja flagi

			PD3on;  //zalaczenie buzzer 1

			if(ffcz2>4)
			{
				PD3off;   //wylaczenie buzzera
				ffcz2=0;  //wykasowanie zezwolenia na powtorne wejscie
			}
		}
	}

}
