#include "stm32f4xx.h"

//-------------------------------------------------------------------------------
//Definicje kolorow
#define Yellow1 0xEFC0
#define Yellow2 0xCEA0
#define Yellow3 0xF785
#define Orange1 0xFB42
#define Orange2 0xFC26
#define Orange3 0xFAE0
#define Red1    0xF800
#define Red2    0xE000
#define Red3    0xB800
#define Green1  0x4DC0
#define Green2  0x1521
#define Green3  0x0B82
#define Gray1   0x6B4D
#define Gray2   0x8C71
#define Gray3   0xAD54
#define Blue1   0x085D
#define Blue2   0x3A1E
#define Blue3   0x16BD
#define Blue4   0x1334
#define Pink1   0xE999
#define Pink2   0xF41C
#define Pink3   0x8830
#define Black1  0x0000
#define Black2  0x3186
#define Black3  0x4A69
#define White   0xFFFF
#define alphagray1  0xCE18
#define alphagray2  0xBD96
#define alphared1   0xFC30


//Podstawowe definicje konfiguracyjen
#define DISPLAY_PANEL TY700TFT800480
#define COLOR_DEPTH 16
#define nopt  2

//-------------------------------------------------------------------------------
//Definicja dla portow sterujacych dla kontroler SSD1963

#define Set_Cs  GPIOB->BSRRL=GPIO_Pin_7;
#define Clr_Cs  GPIOB->BSRRH=GPIO_Pin_7;

#define Set_Rs  GPIOB->BSRRL=GPIO_Pin_8;
#define Clr_Rs  GPIOB->BSRRH=GPIO_Pin_8;

#define Set_nWr GPIOB->BSRRL=GPIO_Pin_0;
#define Clr_nWr GPIOB->BSRRH=GPIO_Pin_0;

#define Set_nRd GPIOB->BSRRL=GPIO_Pin_1;
#define Clr_nRd GPIOB->BSRRH=GPIO_Pin_1;


#define Set_Rst GPIOB->BSRRL=GPIO_Pin_11;
#define Clr_Rst GPIOB->BSRRH=GPIO_Pin_11;



//--------------------------------------------------------------------------
//Ustawienia ktore nalezy wpisac do wyswietlacza w zalezonosci od uzytkowanego
//wyswietlacza tft

#if (DISPLAY_PANEL == TY700TFT800480)
    #define DISP_ORIENTATION            0  //mozna wpisac 0, 90, 180, 270 - rotacja obrazu
    #define DISP_DATA_WIDTH             16    //konwersja kolorow 565, 888 (24) 666 (18)
    #define DISP_HOR_RESOLUTION 800         //rozdzielczosc horyzontalna - pozioma
    #define DISP_VER_RESOLUTION 480        // rozdzielczosc wertykalna - pionowa
																					//Ustawienia horyzontalne dla danego wyswietlacza z interferjsem Parrael RGB24
    #define DISP_HOR_PULSE_WIDTH        1
    #define DISP_HOR_BACK_PORCH         210
    #define DISP_HOR_FRONT_PORCH        45
																					//ustawienie vertyaklne dla danego wyswietlacza
    #define DISP_VER_PULSE_WIDTH        1
    #define DISP_VER_BACK_PORCH         34
    #define DISP_VER_FRONT_PORCH        10
#endif



//wpisanie danych do wyswietlacza
#define LCD_SetData Set_Rs
#define LCD_SetCommand Clr_Rs

//----------------------------------------------------------------------------
//Lista komend 
//----------------------------------------------------------------------------
// SSD1963 lista komend - command
#define CMD_NOP					0x00	//NOP brak instukcji
#define CMD_SOFT_RESET			0x01	//Reset programowy
#define CMD_GET_PWR_MODE		0x0A	//Odczytanie jaka jest opcja zasilania
#define CMD_GET_ADDR_MODE		0x0B	
#define CMD_GET_PIXEL_FORMAT	0x0C	//odczytanie aktualnie uzywanego formatu np 565
#define CMD_GET_DISPLAY_MODE	0x0D	
#define CMD_GET_SIGNAL_MODE		0x0E	
#define CMD_GET_DIAGNOSTIC		0x0F
#define CMD_ENT_SLEEP			0x10
#define CMD_EXIT_SLEEP			0x11
#define CMD_ENT_PARTIAL_MODE	0x12
#define CMD_ENT_NORMAL_MODE		0x13
#define CMD_EXIT_INVERT_MODE	0x20
#define CMD_ENT_INVERT_MODE		0x21
#define CMD_SET_GAMMA			0x26
#define CMD_BLANK_DISPLAY		0x28
#define CMD_ON_DISPLAY			0x29
#define CMD_SET_COLUMN			0x2A
#define CMD_SET_PAGE			0x2B
#define CMD_WR_MEMSTART			0x2C
#define CMD_RD_MEMSTART			0x2E
#define CMD_SET_PARTIAL_AREA	0x30
#define CMD_SET_SCROLL_AREA		0x33
#define CMD_SET_TEAR_OFF		0x34	//wylaczenie sygnalu synchronizujacego TE
#define CMD_SET_TEAR_ON			0x35	//synchronizajca infrmacji za pomoca sygnalu TEAR TE
#define CMD_SET_ADDR_MODE		0x36	//set fram buffer read order to the display panel
#define CMD_SET_SCROLL_START	0x37
#define CMD_EXIT_IDLE_MODE		0x38
#define CMD_ENT_IDLE_MODE		0x39
#define CMD_SET_PIXEL_FORMAT	0x3A	//zdefiniowanie ile butow na pixel przypada
#define CMD_WR_MEM_AUTO			0x3C
#define CMD_RD_MEM_AUTO			0x3E
#define CMD_SET_TEAR_SCANLINE	0x44
#define CMD_GET_SCANLINE		0x45
#define CMD_RD_DDB_START		0xA1
#define CMD_RD_DDB_AUTO			0xA8
#define CMD_SET_PANEL_MODE		0xB0
#define CMD_GET_PANEL_MODE		0xB1
#define CMD_SET_HOR_PERIOD		0xB4
#define CMD_GET_HOR_PERIOD		0xB5
#define CMD_SET_VER_PERIOD		0xB6
#define CMD_GET_VER_PERIOD		0xB7
#define CMD_SET_GPIO_CONF		0xB8
#define CMD_GET_GPIO_CONF		0xB9
#define CMD_SET_GPIO_VAL		0xBA
#define CMD_GET_GPIO_STATUS		0xBB
#define CMD_SET_POST_PROC		0xBC
#define CMD_GET_POST_PROC		0xBD
#define CMD_SET_PWM_CONF		0xBE
#define CMD_GET_PWM_CONF		0xBF
#define CMD_SET_LCD_GEN0		0xC0
#define CMD_GET_LCD_GEN0		0xC1
#define CMD_SET_LCD_GEN1		0xC2
#define CMD_GET_LCD_GEN1		0xC3
#define CMD_SET_LCD_GEN2		0xC4
#define CMD_GET_LCD_GEN2		0xC5
#define CMD_SET_LCD_GEN3		0xC6
#define CMD_GET_LCD_GEN3		0xC7
#define CMD_SET_GPIO0_ROP		0xC8
#define CMD_GET_GPIO0_ROP		0xC9
#define CMD_SET_GPIO1_ROP		0xCA
#define CMD_GET_GPIO1_ROP		0xCB
#define CMD_SET_GPIO2_ROP		0xCC
#define CMD_GET_GPIO2_ROP		0xCD
#define CMD_SET_GPIO3_ROP		0xCE
#define CMD_GET_GPIO3_ROP		0xCF
#define CMD_SET_ABC_DBC_CONF	0xD0
#define CMD_GET_ABC_DBC_CONF	0xD1
#define CMD_SET_DBC_HISTO_PTR	0xD2
#define CMD_GET_DBC_HISTO_PTR	0xD3
#define CMD_SET_DBC_THRES		0xD4
#define CMD_GET_DBC_THRES		0xD5
#define CMD_SET_ABM_TMR			0xD6
#define CMD_GET_ABM_TMR			0xD7
#define CMD_SET_AMB_LVL0		0xD8
#define CMD_GET_AMB_LVL0		0xD9
#define CMD_SET_AMB_LVL1		0xDA
#define CMD_GET_AMB_LVL1		0xDB
#define CMD_SET_AMB_LVL2		0xDC
#define CMD_GET_AMB_LVL2		0xDD
#define CMD_SET_AMB_LVL3		0xDE
#define CMD_GET_AMB_LVL3		0xDF
#define CMD_PLL_START			0xE0	//start petli PLL
#define CMD_PLL_STOP			0xE1	//disable - wylaczenie petli PLL
#define CMD_SET_PLL_MN			0xE2
#define CMD_GET_PLL_MN			0xE3
#define CMD_GET_PLL_STATUS		0xE4	//aktualny status petli  PLL status
#define CMD_ENT_DEEP_SLEEP		0xE5
#define CMD_SET_PCLK			0xE6	//set pixel clock - sygnal zegarowy dla panelu wyswietlacza
																//(LSHIFT signal) frequency 
#define CMD_GET_PCLK			0xE7	//aktualna wartoc sygnalu segarowego panelu 
																	// sygnalu przemiatajacego (LSHIFT signal) freq. settings
#define CMD_SET_DATA_INTERFACE	0xF0
#define CMD_GET_DATA_INTERFACE	0xF1

//-----------------------------------------------------------------------------




/*********************************************************************
* Sprawdzenie parametrow przez preprocesor
*********************************************************************/

#if COLOR_DEPTH != 16
#error This driver supports 16 BPP only.     //Mozliwe tylko 16 bitow na pixel
#endif


#if (DISP_HOR_RESOLUTION % 8) != 0                     //Rozdzielczosc musi byc podzielna przez 8
#error Horizontal resolution must be divisible by 8.
#endif

#if (DISP_ORIENTATION != 0) && (DISP_ORIENTATION != 180) && (DISP_ORIENTATION != 90) && (DISP_ORIENTATION != 270)
#error The display orientation selected is not supported. It can be only 0,90,180 or 270.
#endif





//Defunicje w zaleznosci od orientacji obrazu - maksymalna wartosci wspolrzednej X oraz Y
#if (DISP_ORIENTATION == 90) || (DISP_ORIENTATION == 270)
#define	GetMaxX() 			(DISP_VER_RESOLUTION-1)
#elif (DISP_ORIENTATION == 0) || (DISP_ORIENTATION == 180)
#define	GetMaxX() 			(DISP_HOR_RESOLUTION-1)
#endif

#if (DISP_ORIENTATION == 90) || (DISP_ORIENTATION == 270)
#define	GetMaxY() 			(DISP_HOR_RESOLUTION-1)
#elif (DISP_ORIENTATION == 0) || (DISP_ORIENTATION == 180)
#define	GetMaxY() 			(DISP_VER_RESOLUTION-1)
#endif

// Zdefiniowanie ilosci pamieci ram w bajtach przypadajaca na jedna strone wyswietlacza
#ifndef PAGE_MEM_SIZE
#define PAGE_MEM_SIZE 	(GetMaxX()+1)*(GetMaxY()+1)*COLOR_DEPTH/8
#endif


#if PAGE_MEM_SIZE > 1215000ul	//wypisanie blednu jezeli wyswietlacz ma wiecej rozdzielczosci
															//niz mozliwa pamiec ram sterownika. Tzn wielkosc bufora ramki sterownika
															//nie moze byc mniejsza niz rozdzielczosc raz ilosc bajtow na piksel przypadajaca
#error MEMORY ALLOCATION FAILED. CHECK SSD1963.h
#endif

//definicja zajetosci
#define LCD_IsDeviceBusy()  0
uint8_t Lo(uint16_t X);  //(uint8_t)(X&0x00ff)   //mlodsza czesc bajtu X
uint8_t Hi(uint16_t X);  //(uint8_t)((X>>8)&0x00ff)  //starsza czesc bajtu X


void LCD_EnterSleepMode (void);  //wejscie w tryb uspienia
void LCD_ExitSleepMode (void);   //wyjscie z trybu uspienia
void tft_line(int X1, int Y1,int X2,int Y2,int Color);  //funkcja rysujaca linie na wyswietlaczu
void LCD_SetArea(u16 start_x, u16 start_y, u16 end_x, u16 end_y); //funkcja okreslajaca aktywny obszar do rysowania
void LCD_PutPixel(u16 x, u16 y, u16 color); // funkcja rysujaca pixel na danej wspolrzednej xy
void LCD_Clear(u16 color);   //funkcja czyszczaca wyswietlacz danym kolorem
void LCD_ResetDevice(void); //funkcja inicjalizujaca wyswietlacz
void full_rect( int X1, int Y1, int X2, int Y2, uint16_t color);  //funkcja rysujaca wypelniony kwadrat
void LCD_GPIOInit(void);
void tft_round_rect(int x, int y, int width, int height, uint8_t radius, uint16_t color1, uint16_t color2);
void tft_round_rect1(int x, int y, int width, int height, uint8_t radius, uint8_t fill, uint16_t color);
void full_rect3( int X1, int Y1, int X2, int Y2, uint16_t color);
uint8_t putmonograph(uint16_t x, uint16_t y, uint16_t color, uint16_t bkcolor, uint16_t width, uint16_t height,const uint8_t *s, uint8_t alpha);
void tft_line2(int X1, int Y1,int X2,int Y2,int Color);
void putpictures(u16 x, u16 y, u16 width, u16 height, unsigned char const *grafika, uint8_t scale, uint8_t alpha);
void nop(uint32_t nop);
void LCD_WriteCommand(uint8_t cmd);
void LCD_WriteCommandCont(uint8_t cmd);
void LCD_WriteData(uint16_t data);
void LCD_WriteDataCont(uint16_t data);
void putfrombufor(uint16_t *ts, uint32_t *k, uint16_t x, uint16_t y);
void LCD_ReadData(uint16_t *buffor, uint32_t *k, uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2);
void putfastpicture(u16 x, u16 y, u16 width, u16 height, unsigned char const *grafika);
void full_rectalpha( int X1, int Y1, int X2, int Y2, uint16_t color);
void putrectanglefromtable(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2, unsigned char const *tab);
