#include "stm32f4xx.h"
#include "xpt2046.h"

volatile unsigned char flagaTP=0, flagaTP2=0;
extern volatile uint32_t ms2;

void EXTI1_IRQHandler(void) /* TouchScreen - panel dotykowy  - przerwanie zewnetrzne*/
{
    if(EXTI_GetITStatus(EXTI_Line1) != RESET) //zerowanie licznika
    {
        flagaTP=1;
    }

   
    EXTI_ClearITPendingBit(EXTI_Line1); //kasowanie flagi przerwnia
}

//Uwaga - na linia sygnalowej IRQ z touch panelu wystepuja bardzo duze drgania ktore nalezy wyelyminowac programowo
void EXTI_config(void)
{
	 EXTI_InitTypeDef   EXTI_InitStructure;
  GPIO_InitTypeDef   GPIO_InitStructure;
  NVIC_InitTypeDef   NVIC_InitStructure;

	//konfiguracja przerwania od zmiany stanu na porcie PA1. Jezeli panel dotykowy jest gotowy nastapi zmiana na port PA0 (sygnal)
	//a nastepnie w przerwaniu nastapi ustawienie flagi 1.
    /* podlaczenie przerwnia na linie PA0 EXTI1 Line to PA1 pin tzn zrodlo przerwania */
	
	//ustawienie portu dla przerwania zewnetrznego
	 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
  GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	GPIOA->BSRRL = GPIO_Pin_1;
  
    //Ustawienie zrodla przerwania na linie1  - np. PA1
	SYSCFG_EXTILineConfig(EXTI_PortSourceGPIOA, EXTI_PinSource1);
	
  //Konfiguracja przerwania EXTI1 na linie PA1

  EXTI_InitStructure.EXTI_Line = EXTI_Line1;                     //Wybor linii 
  EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;            //Ustawienie generowania przerwania (a nie zdarzenia)
  EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;        //Wyzwalanie zboczem opadajacym (wcisniecie przycisku)
  EXTI_InitStructure.EXTI_LineCmd = ENABLE;                      //Wlaczenie przerwania
  EXTI_Init(&EXTI_InitStructure);
	
	//RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG, ENABLE);  w glownej funkcji RCC nalezy wywolac funkcje
	
	//ustawienie wektor przerwan - priortytet i podpiriorytet
	
	NVIC_InitStructure.NVIC_IRQChannel = EXTI1_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
	
}


void XPT2046_SPI_Init(void) //inicjalizacja interfejsu SPI 
{
  GPIO_InitTypeDef  GPIO_InitStructure;
  SPI_InitTypeDef   SPI_InitStructure;
	
			//RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1, ENABLE);


      SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex; //okreslienie wyboru trybu transmisji 
		//(lilcza lini i kierunek wymiany danych)
      SPI_InitStructure.SPI_Mode = SPI_Mode_Master; //okreslenie trybu pracy ukladu SPI (master)
		  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b; //okreslenie wielkosci wysylanych danych -> 8 bitow
      SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low; //okreslenie stnu lini SCK przy braku transmiji -> niski
      SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge; //okreslenie aktywne zbocze sygnalu SCK
																										//dane brane z noty XPT2046
      SPI_InitStructure.SPI_NSS = SPI_NSS_Soft; //sposob sterowania linia CS - programowy
      SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_256; //okreslenie wartosci dzielnika czestotliwosci ->128
      SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB; //okresla kolejnosc transmisji bitow slowa danych -> najbardziej znaczacy bit wysylany w pierwszej kolejnosci
      SPI_InitStructure.SPI_CRCPolynomial = 0; // okreslenie rzadu wielomianu sumy CRC  - normalnie nie wykorzystujemy
      SPI_Init(SPI1, &SPI_InitStructure); //wpsianie konfiguracji do struktury
			SPI_Cmd(SPI1, ENABLE); // Zalaczenie interfejsu SPI
	

 
			//porty pod ktore bedzie podlaczony interfejs SPI
      /*   SPI_CS_GPIO = PA4,
       *   SPI_MOSI_GPIO = PA7,
       *   SPI_MISO_GPIO = PA6,
       *   SPI_SCK_GPIO = PA5 *
		//jezeli SPI1 nie jest zalaczony to zalaczmy porty GPIOA oraz interfejs SPI */
      //  SPI1 Periph clock - zalaczenie sygnalu zegarowego dla SPI
      

			GPIO_PinAFConfig(GPIOA,GPIO_PinSource4, GPIO_AF_SPI1); //zalaczenie funkcji alternatywnych
			GPIO_PinAFConfig(GPIOA,GPIO_PinSource5, GPIO_AF_SPI1); //zalaczenie funkcji alternatywnych
			GPIO_PinAFConfig(GPIOA,GPIO_PinSource6, GPIO_AF_SPI1); //zalaczenie funkcji alternatywnych
			GPIO_PinAFConfig(GPIOA,GPIO_PinSource7, GPIO_AF_SPI1); //zalaczenie funkcji alternatywnych
		
      //< Konfiguracja SPI1 pinow: SCK, MISO, MOSI 
      GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7;
      GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
			GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
      GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
      GPIO_Init(GPIOA, &GPIO_InitStructure);

	
   
  /*!< Configure SPI1 pin: TouchScreen CS pin */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;          //Port uzywany jako wyjsciowy
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;         //Port uzywany jako zwykly port typu Pull Push
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;     //Czestotliwosc taktowania ustawiona na 100Mhz
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;       //Pull up pull down wstepnie jako no pull
  GPIO_Init(GPIOA, &GPIO_InitStructure);

  CS_L;
	

  
 XPT2046_SendByte(0x00);//wyzerowanie danych poprzez wyslanie zerowych bitow
 XPT2046_SendByte(0x00);
 XPT2046_SendByte(0x00);


 CS_H;
}


 


uint8_t XPT2046_SendByte(uint8_t byte)
{
  /* petla nieskonczona jesli rejest DR register nie jest pusty */
  while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET)
	  {
	  }

  /* wyslij bajt */
	SPI_I2S_SendData(SPI1, (uint16_t)byte);

  /*czekaj na dane*/
  while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET);

  /* zwroc bajt odczytany z interfejsi SPI */
  return (uint8_t)SPI_I2S_ReceiveData(SPI1);
}


uint8_t XPT2046_ReadByte(void)
	//odczytaj bajt
{
	//odczytaj bajt w odpowiedzi na wyslanie zerowego bajtu
  return (XPT2046_SendByte(0x00));
}

uint16_t ADS_Read_AD(uint8_t CMD)
{
  uint16_t temp,Addata;
  
	CS_L;
  XPT2046_SendByte(CMD);
  temp=0;
	//
 //XPT2046_ReadByte();
	//
  temp= XPT2046_ReadByte();
  Addata =temp<<8;
	temp=0;
  temp= XPT2046_ReadByte();
  Addata |=temp;
  Addata >>=3;    //>>=3    -- nalezy przesunac trzy bity w prawo poniewaz jeden bit zarezerwowany jest na zajetosc
  Addata &=0xFFF;  //usuniecie smieci i wartosci odczytanej z bitu zajetosci
  CS_H;
  return Addata;  
}


