#include "stm32f4xx.h"
#include "fonts.h"




const uint8_t font1[];				//Tahoma 16 bold
const uint16_t font1desc[];
const uint8_t fontinfo1[];
const uint8_t font2[];			//Verdena 12 Bold
const uint16_t font2desc[];
const uint8_t fontinfo2[];

const uint8_t font4[];     //Time New Roman 11 Bold
const uint16_t font4desc[];
const uint8_t fontinfo4[];

const uint8_t font6[];     //Arial Black 8pt pogrubienie kursywa
const uint16_t font6desc[];
const uint8_t fontinfo6[];

const uint8_t font7[];     // //Gabriola 24 bold
const uint16_t font7desc[];
const uint8_t fontinfo7[];


extern int chosefont, rotate;



 void send_glyph_byte(uint8_t bajt, uint8_t width, uint16_t COLOR, uint16_t BK_COLOR, int X, int Y,uint8_t alpha)
 {
	uint8_t i;
	for(i=0; i<width; i++ )
	{
		if(bajt&0x80)
		{
			    if(!rotate) LCD_PutPixel( X+i, Y, COLOR); else  if(!rotate) LCD_PutPixel( Y, X+i, COLOR);
		}
		else if(!alpha)
		{
			    if(!rotate) LCD_PutPixel( X+i, Y, BK_COLOR); else LCD_PutPixel( Y, X+i, BK_COLOR);
		}

		bajt<<=1;
	}
}



 void send_font_bitmap(int xPixel, int yPixel, uint16_t OFFSET, int glyphHeight, int glyphWidth, uint16_t C, uint16_t BK_C, uint8_t alpha ) {

	uint8_t i, j, k, bajt=0;
	uint16_t p=OFFSET;

	

	
	//**************************************************************************
	//==========================================================================
	//**************************************************************************
	

	for(i=0; i<glyphHeight; i++ ) {
		
		for(j=0, k=0; j<glyphWidth; j+=8, k++) {
			if(chosefont==1)
				{
					bajt = font1[p++];
				}
			if(chosefont==2)
				{
					bajt = font2[p++];
				}	
			if(chosefont==4)
				{
					bajt = font4[p++];
				}
			if(chosefont==6)
				{
					bajt = font6[p++];
				}
			if(chosefont==7)
				{
					bajt = font7[p++];
				}


			if( ((k+1)*8)<=glyphWidth ) send_glyph_byte(bajt, 8, C, BK_C, xPixel+j, yPixel+i, alpha);
			else send_glyph_byte(bajt, glyphWidth-(k*8), C, BK_C, xPixel+j, yPixel+i, alpha);


		}
	}
}






void tft_mputs( int x, int y, char * s, uint16_t color, uint16_t bk_color, uint8_t alpha ) {

	uint8_t gH, gW, gS, gIS;
	uint16_t offset;
	uint8_t startChar;

	if(chosefont==1)
	{
	startChar = fontinfo1[1];
	gH = fontinfo1[0];
	gIS = fontinfo1[2];
	gS = fontinfo1[3];
	}
	if(chosefont==2)
	{
	startChar = fontinfo2[1];
	gH = fontinfo2[0];
	gIS = fontinfo2[2];
	gS = fontinfo2[3];
	}
	if(chosefont==4)
	{
	startChar = fontinfo4[1];
	gH = fontinfo4[0];
	gIS = fontinfo4[2];
	gS = fontinfo4[3];
	}
	if(chosefont==6)
	{
	startChar = fontinfo6[1];
	gH = fontinfo6[0];
	gIS = fontinfo6[2];
	gS = fontinfo6[3];
	}
	if(chosefont==7)
	{
	startChar = fontinfo7[1];
	gH = fontinfo7[0];
	gIS = fontinfo7[2];
	gS = fontinfo7[3];
	}

	while( *s ) {
		if( *s > ' ') {
			//jezeli zostala wybrana pierwsza czcionka , druga itd
							if(chosefont==1)
											{
													gW=23;
													offset=font1desc[*s - startChar];
													send_font_bitmap(x, y, offset, gH, gW, color, bk_color, alpha );
													x = x + gW + gIS;
											}
							if(chosefont==2)
											{
													gW=18;
													offset=font2desc[*s - startChar];
													send_font_bitmap(x, y, offset, gH, gW, color, bk_color, alpha );
													x = x + gW + gIS;					
											}
							if(chosefont==4)
											{
													gW=14;
													offset=font4desc[*s - startChar];
													send_font_bitmap(x, y, offset, gH, gW, color, bk_color, alpha );
													x = x + gW + gIS;
											}
							if(chosefont==6)
											{
													gW=12;
													offset=font6desc[*s - startChar];
													send_font_bitmap(x, y, offset, gH, gW, color, bk_color, alpha );
													x = x + gW + gIS;
											}
							if(chosefont==7)
											{
													gW=30;
													offset=font7desc[*s - startChar];
													send_font_bitmap(x, y, offset, gH, gW, color, bk_color, alpha );
													x = x + gW + gIS;
											}
			
			
		} else 
	{
			x+=gS;
		}
		s++;
	}
}	

	
	


const uint8_t font1[] = 
{
	     // @0   [!]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @75   ["]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0xEE, 0x00,  //           ### ###            //
	     0x00, 0x44, 0x00,  //            #   #             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @150   [#]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x31, 0x80,  //             ##   ##          //
	     0x00, 0x31, 0x80,  //             ##   ##          //
	     0x00, 0x63, 0x00,  //            ##   ##           //
	     0x00, 0x63, 0x00,  //            ##   ##           //
	     0x07, 0xFF, 0xE0,  //        ##############        //
	     0x07, 0xFF, 0xE0,  //        ##############        //
	     0x00, 0xC6, 0x00,  //           ##   ##            //
	     0x00, 0xC6, 0x00,  //           ##   ##            //
	     0x00, 0xC6, 0x00,  //           ##   ##            //
	     0x00, 0xC6, 0x00,  //           ##   ##            //
	     0x0F, 0xFF, 0x80,  //       #############          //
	     0x0F, 0xFF, 0x80,  //       #############          //
	     0x01, 0x8C, 0x00,  //          ##   ##             //
	     0x01, 0x8C, 0x00,  //          ##   ##             //
	     0x03, 0x18, 0x00,  //         ##   ##              //
	     0x03, 0x18, 0x00,  //         ##   ##              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @225   [$]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x18, 0x00,  //              ##              //
	     0x00, 0x18, 0x00,  //              ##              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xD9, 0x00,  //         #### ##  #           //
	     0x03, 0xD8, 0x00,  //         #### ##              //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFF, 0x80,  //           #########          //
	     0x00, 0x3F, 0x80,  //             #######          //
	     0x00, 0x37, 0x80,  //             ## ####          //
	     0x02, 0x37, 0x80,  //         #   ## ####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x00, 0x30, 0x00,  //             ##               //
	     0x00, 0x30, 0x00,  //             ##               //
	     0x00, 0x30, 0x00,  //             ##               //
	     0x00, 0x30, 0x00,  //             ##               //

	     // @300   [%]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x3E, 0x01, 0x80,  //     #####        ##          //
	     0x7F, 0x03, 0x00,  //    #######      ##           //
	     0xE3, 0x87, 0x00,  //   ###   ###    ###           //
	     0xE3, 0x86, 0x00,  //   ###   ###    ##            //
	     0xE3, 0x8E, 0x00,  //   ###   ###   ###            //
	     0xE3, 0x8C, 0x00,  //   ###   ###   ##             //
	     0xE3, 0x98, 0xF8,  //   ###   ###  ##   #####      //
	     0xE3, 0x99, 0xFC,  //   ###   ###  ##  #######     //
	     0x7F, 0x33, 0x8E,  //    #######  ##  ###   ###    //
	     0x3E, 0x33, 0x8E,  //     #####   ##  ###   ###    //
	     0x00, 0x63, 0x8E,  //            ##   ###   ###    //
	     0x00, 0xE3, 0x8E,  //           ###   ###   ###    //
	     0x00, 0xC3, 0x8E,  //           ##    ###   ###    //
	     0x01, 0xC3, 0x8E,  //          ###    ###   ###    //
	     0x01, 0x81, 0xFC,  //          ##      #######     //
	     0x03, 0x00, 0xF8,  //         ##        #####      //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @375   [&]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xF0, 0x00,  //         ######               //
	     0x07, 0xF8, 0x00,  //        ########              //
	     0x0F, 0xFC, 0x00,  //       ##########             //
	     0x0F, 0x3C, 0x00,  //       ####  ####             //
	     0x0F, 0x3C, 0x00,  //       ####  ####             //
	     0x0F, 0xB8, 0x00,  //       ##### ###              //
	     0x07, 0xF0, 0x00,  //        #######               //
	     0x07, 0xE7, 0x80,  //        ######  ####          //
	     0x0F, 0xF7, 0x80,  //       ######## ####          //
	     0x1E, 0xFF, 0x80,  //      #### #########          //
	     0x1E, 0x7F, 0x80,  //      ####  ########          //
	     0x1E, 0x3F, 0x00,  //      ####   ######           //
	     0x1F, 0x1F, 0x00,  //      #####   #####           //
	     0x0F, 0xFF, 0x80,  //       #############          //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x03, 0xF3, 0xE0,  //         ######  #####        //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @450   [']   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x10, 0x00,  //              #               //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @525   [(]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x1E, 0x00,  //              ####            //

	     // @600   [)]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xE0, 0x00,  //          ####                //

	     // @675   [*]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x30, 0x00,  //             ##               //
	     0x01, 0x32, 0x00,  //          #  ##  #            //
	     0x03, 0xB7, 0x00,  //         ### ## ###           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x03, 0xB7, 0x00,  //         ### ## ###           //
	     0x01, 0x32, 0x00,  //          #  ##  #            //
	     0x00, 0x30, 0x00,  //             ##               //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @750   [+]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @825   [,]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x60, 0x00,  //            ##                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xC0, 0x00,  //           ##                 //

	     // @900   [-]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @975   [.]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1050   [/]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x00, 0x00, 0x00,  //                              //

	     // @1125   [0]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xEF, 0x00,  //          #### ####           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x01, 0xEF, 0x00,  //          #### ####           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1200   [1]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1275   [2]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xF8, 0x00,  //          ######              //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x02, 0x1F, 0x00,  //         #    #####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1350   [3]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0x07, 0x80,  //         ##     ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x03, 0x0F, 0x80,  //         ##    #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1425   [4]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0xDE, 0x00,  //           ## ####            //
	     0x01, 0x9E, 0x00,  //          ##  ####            //
	     0x01, 0x9E, 0x00,  //          ##  ####            //
	     0x03, 0x1E, 0x00,  //         ##   ####            //
	     0x06, 0x1E, 0x00,  //        ##    ####            //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1500   [5]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x02, 0x0F, 0x80,  //         #     #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1575   [6]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3F, 0x00,  //             ######           //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x03, 0xDE, 0x00,  //         #### ####            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xCF, 0x80,  //         ####  #####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x01, 0xEF, 0x80,  //          #### #####          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1650   [7]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1F, 0x00,  //              #####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1725   [8]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xCF, 0x80,  //          ###  #####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1800   [9]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xEF, 0x00,  //         ##### ####           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF7, 0x80,  //           #### ####          //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1F, 0x00,  //              #####           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x01, 0xF8, 0x00,  //          ######              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1875   [:]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @1950   [;]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x60, 0x00,  //            ##                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xC0, 0x00,  //           ##                 //

	     // @2025   [<]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x40,  //                    #         //
	     0x00, 0x03, 0xC0,  //                 ####         //
	     0x00, 0x0F, 0xC0,  //               ######         //
	     0x00, 0x3F, 0x80,  //             #######          //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x07, 0xF0, 0x00,  //        #######               //
	     0x07, 0xC0, 0x00,  //        #####                 //
	     0x07, 0xF0, 0x00,  //        #######               //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x00, 0x3F, 0x80,  //             #######          //
	     0x00, 0x0F, 0xC0,  //               ######         //
	     0x00, 0x03, 0xC0,  //                 ####         //
	     0x00, 0x00, 0x40,  //                    #         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2100   [=]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2175   [>]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x04, 0x00, 0x00,  //        #                     //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0xE0, 0x00,  //        ######                //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0x1F, 0xC0,  //              #######         //
	     0x00, 0x07, 0xC0,  //                #####         //
	     0x00, 0x1F, 0xC0,  //              #######         //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x07, 0xE0, 0x00,  //        ######                //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x04, 0x00, 0x00,  //        #                     //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2250   [?]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xF8, 0x00,  //          ######              //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x02, 0x1F, 0x00,  //         #    #####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2325   [@]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0x83, 0xC0,  //         ###     ####         //
	     0x06, 0x00, 0xC0,  //        ##         ##         //
	     0x0C, 0x7E, 0x60,  //       ##   ######  ##        //
	     0x0C, 0xFE, 0x70,  //       ##  #######  ###       //
	     0x18, 0xC6, 0x30,  //      ##   ##   ##   ##       //
	     0x19, 0x86, 0x30,  //      ##  ##    ##   ##       //
	     0x19, 0x86, 0x30,  //      ##  ##    ##   ##       //
	     0x19, 0x86, 0x30,  //      ##  ##    ##   ##       //
	     0x19, 0x86, 0x30,  //      ##  ##    ##   ##       //
	     0x19, 0xC6, 0x70,  //      ##  ###   ##  ###       //
	     0x0C, 0xFF, 0xE0,  //       ##  ###########        //
	     0x0C, 0x7F, 0xE0,  //       ##   ##########        //
	     0x06, 0x00, 0x00,  //        ##                    //
	     0x07, 0x82, 0x00,  //        ####     #            //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2400   [A]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2475   [B]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFC, 0x00,  //         ########             //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFC, 0x00,  //         ########             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2550   [C]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0xFF, 0x80,  //           #########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xE1, 0x80,  //         #####    ##          //
	     0x03, 0xC0, 0x80,  //         ####      #          //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x03, 0xC0, 0x80,  //         ####      #          //
	     0x03, 0xE1, 0x80,  //         #####    ##          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xFF, 0x80,  //           #########          //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2625   [D]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xF8, 0x00,  //        ########              //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0xF8, 0x00,  //        ########              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2700   [E]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2775   [F]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2850   [G]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x01, 0xFF, 0xC0,  //          ###########         //
	     0x03, 0xFF, 0xC0,  //         ############         //
	     0x07, 0xC1, 0xC0,  //        #####     ###         //
	     0x07, 0x80, 0x40,  //        ####        #         //
	     0x0F, 0x00, 0x00,  //       ####                   //
	     0x0F, 0x00, 0x00,  //       ####                   //
	     0x0F, 0x1F, 0xC0,  //       ####   #######         //
	     0x0F, 0x1F, 0xC0,  //       ####   #######         //
	     0x0F, 0x1F, 0xC0,  //       ####   #######         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x07, 0x83, 0xC0,  //        ####     ####         //
	     0x07, 0xC3, 0xC0,  //        #####    ####         //
	     0x03, 0xFF, 0xC0,  //         ############         //
	     0x01, 0xFF, 0xC0,  //          ###########         //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @2925   [H]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3000   [I]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3075   [J]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x02, 0x1F, 0x00,  //         #    #####           //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xF8, 0x00,  //         #######              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3150   [K]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x87, 0xC0,  //        ####    #####         //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x9F, 0x00,  //        ####  #####           //
	     0x07, 0x9F, 0x00,  //        ####  #####           //
	     0x07, 0xBE, 0x00,  //        #### #####            //
	     0x07, 0xBC, 0x00,  //        #### ####             //
	     0x07, 0xF8, 0x00,  //        ########              //
	     0x07, 0xF8, 0x00,  //        ########              //
	     0x07, 0xF8, 0x00,  //        ########              //
	     0x07, 0xFC, 0x00,  //        #########             //
	     0x07, 0xBE, 0x00,  //        #### #####            //
	     0x07, 0x9E, 0x00,  //        ####  ####            //
	     0x07, 0x9F, 0x00,  //        ####  #####           //
	     0x07, 0x8F, 0x00,  //        ####   ####           //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x87, 0xC0,  //        ####    #####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3225   [L]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3300   [M]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x0F, 0x83, 0xE0,  //       #####     #####        //
	     0x0F, 0x83, 0xE0,  //       #####     #####        //
	     0x0F, 0xC3, 0xE0,  //       ######    #####        //
	     0x0F, 0xC7, 0xE0,  //       ######   ######        //
	     0x0F, 0xC7, 0xE0,  //       ######   ######        //
	     0x0F, 0xEF, 0xE0,  //       ####### #######        //
	     0x0F, 0xEF, 0xE0,  //       ####### #######        //
	     0x0F, 0x7D, 0xE0,  //       #### ##### ####        //
	     0x0F, 0x7D, 0xE0,  //       #### ##### ####        //
	     0x0F, 0x7D, 0xE0,  //       #### ##### ####        //
	     0x0F, 0x39, 0xE0,  //       ####  ###  ####        //
	     0x0F, 0x39, 0xE0,  //       ####  ###  ####        //
	     0x0F, 0x01, 0xE0,  //       ####       ####        //
	     0x0F, 0x01, 0xE0,  //       ####       ####        //
	     0x0F, 0x01, 0xE0,  //       ####       ####        //
	     0x0F, 0x01, 0xE0,  //       ####       ####        //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3375   [N]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xC7, 0x80,  //        #####   ####          //
	     0x07, 0xC7, 0x80,  //        #####   ####          //
	     0x07, 0xE7, 0x80,  //        ######  ####          //
	     0x07, 0xE7, 0x80,  //        ######  ####          //
	     0x07, 0xE7, 0x80,  //        ######  ####          //
	     0x07, 0xF7, 0x80,  //        ####### ####          //
	     0x07, 0xB7, 0x80,  //        #### ## ####          //
	     0x07, 0xB7, 0x80,  //        #### ## ####          //
	     0x07, 0xBF, 0x80,  //        #### #######          //
	     0x07, 0x9F, 0x80,  //        ####  ######          //
	     0x07, 0x9F, 0x80,  //        ####  ######          //
	     0x07, 0x9F, 0x80,  //        ####  ######          //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3450   [O]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3525   [P]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFC, 0x00,  //        #########             //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0xFC, 0x00,  //        #########             //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3600   [Q]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1F, 0xC0,  //              #######         //
	     0x00, 0x0F, 0xC0,  //               ######         //
	     0x00, 0x07, 0xC0,  //                #####         //

	     // @3675   [R]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFC, 0x00,  //        #########             //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0xFF, 0x00,  //        ###########           //
	     0x07, 0x8F, 0x00,  //        ####   ####           //
	     0x07, 0x8F, 0x00,  //        ####   ####           //
	     0x07, 0x8F, 0x00,  //        ####   ####           //
	     0x07, 0x9F, 0x00,  //        ####  #####           //
	     0x07, 0xFE, 0x00,  //        ##########            //
	     0x07, 0xFC, 0x00,  //        #########             //
	     0x07, 0xFC, 0x00,  //        #########             //
	     0x07, 0xBC, 0x00,  //        #### ####             //
	     0x07, 0xBE, 0x00,  //        #### #####            //
	     0x07, 0x9F, 0x00,  //        ####  #####           //
	     0x07, 0x9F, 0x00,  //        ####  #####           //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x87, 0xC0,  //        ####    #####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3750   [S]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xC3, 0x00,  //         ####    ##           //
	     0x03, 0xC1, 0x00,  //         ####     #           //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x03, 0xFC, 0x00,  //         ########             //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x3F, 0x80,  //             #######          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x02, 0x07, 0x80,  //         #      ####          //
	     0x03, 0x07, 0x80,  //         ##     ####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3825   [T]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x0F, 0xFF, 0xC0,  //       ##############         //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3900   [U]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @3975   [V]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4050   [W]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0xF0, 0x78, 0x3C,  //   ####     ####     ####     //
	     0xF0, 0x78, 0x3C,  //   ####     ####     ####     //
	     0x78, 0xFC, 0x78,  //    ####   ######   ####      //
	     0x78, 0xFC, 0x78,  //    ####   ######   ####      //
	     0x78, 0xFC, 0x78,  //    ####   ######   ####      //
	     0x78, 0xFC, 0x78,  //    ####   ######   ####      //
	     0x39, 0xFE, 0xF0,  //     ###  ######## ####       //
	     0x3D, 0xFE, 0xF0,  //     #### ######## ####       //
	     0x3D, 0xCE, 0xF0,  //     #### ###  ### ####       //
	     0x3D, 0xCE, 0xF0,  //     #### ###  ### ####       //
	     0x1F, 0xCF, 0xE0,  //      #######  #######        //
	     0x1F, 0xCF, 0xE0,  //      #######  #######        //
	     0x1F, 0x87, 0xE0,  //      ######    ######        //
	     0x1F, 0x87, 0xE0,  //      ######    ######        //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4125   [X]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4200   [Y]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4275   [Z]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x1F, 0x00,  //              #####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4350   [[]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //

	     // @4425   [\]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x01, 0xC0, 0x00,  //          ###                 //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0xE0, 0x00,  //           ###                //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x00, 0x00,  //                              //

	     // @4500   []]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //

	     // @4575   [^]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x03, 0x8E, 0x00,  //         ###   ###            //
	     0x03, 0x87, 0x00,  //         ###    ###           //
	     0x07, 0x03, 0x80,  //        ###      ###          //
	     0x0E, 0x01, 0xC0,  //       ###        ###         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4650   [_]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x07, 0xFF, 0xC0,  //        #############         //
	     0x00, 0x00, 0x00,  //                              //

	     // @4725   [`]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4800   [a]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x7F, 0x80,  //            ########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF7, 0x80,  //           #### ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4875   [b]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xDE, 0x00,  //         #### ####            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xCF, 0x80,  //         ####  #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFC, 0x00,  //         ########             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @4950   [c]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x01, 0xF1, 0x00,  //          #####   #           //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xF1, 0x00,  //          #####   #           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5025   [d]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x77, 0x80,  //            ### ####          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF7, 0x80,  //           #### ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5100   [e]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xE1, 0x00,  //         #####    #           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5175   [f]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5250   [g]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7F, 0x80,  //            ########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF7, 0x80,  //           #### ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFC, 0x00,  //          #######             //

	     // @5325   [h]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xCE, 0x00,  //         ####  ###            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5400   [i]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5475   [j]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xF8, 0x00,  //           #####              //

	     // @5550   [k]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x9F, 0x00,  //        ####  #####           //
	     0x07, 0x9E, 0x00,  //        ####  ####            //
	     0x07, 0xBC, 0x00,  //        #### ####             //
	     0x07, 0xF8, 0x00,  //        ########              //
	     0x07, 0xF8, 0x00,  //        ########              //
	     0x07, 0xFC, 0x00,  //        #########             //
	     0x07, 0xBC, 0x00,  //        #### ####             //
	     0x07, 0xBE, 0x00,  //        #### #####            //
	     0x07, 0x9E, 0x00,  //        ####  ####            //
	     0x07, 0x9F, 0x00,  //        ####  #####           //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5625   [l]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5700   [m]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x3C, 0xE1, 0xC0,  //     ####  ###    ###         //
	     0x3F, 0xF7, 0xE0,  //     ########## ######        //
	     0x3F, 0xFF, 0xF0,  //     ##################       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x3C, 0x78, 0xF0,  //     ####   ####   ####       //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5775   [n]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xCE, 0x00,  //         ####  ###            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5850   [o]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xEF, 0x80,  //         ##### #####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xEF, 0x80,  //         ##### #####          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @5925   [p]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xDE, 0x00,  //         #### ####            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xCF, 0x80,  //         ####  #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xDC, 0x00,  //         #### ###             //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //

	     // @6000   [q]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x77, 0x80,  //            ### ####          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF7, 0x80,  //           #### ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x07, 0x80,  //                ####          //

	     // @6075   [r]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xE6, 0x00,  //          ####  ##            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6150   [s]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xE1, 0x00,  //          ####    #           //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x1F, 0x00,  //              #####           //
	     0x01, 0x0F, 0x00,  //          #    ####           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6225   [t]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6300   [u]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF7, 0x80,  //           #### ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6375   [v]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x01, 0xEE, 0x00,  //          #### ###            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6450   [w]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x3C, 0x38, 0x78,  //     ####    ###    ####      //
	     0x3C, 0x3C, 0x78,  //     ####    ####   ####      //
	     0x1E, 0x7C, 0xF0,  //      ####  #####  ####       //
	     0x1E, 0x7C, 0xF0,  //      ####  #####  ####       //
	     0x1E, 0x6C, 0xF0,  //      ####  ## ##  ####       //
	     0x0E, 0xEE, 0xE0,  //       ### ### ### ###        //
	     0x0E, 0xEE, 0xE0,  //       ### ### ### ###        //
	     0x0F, 0xEF, 0xE0,  //       ####### #######        //
	     0x0F, 0xC7, 0xE0,  //       ######   ######        //
	     0x07, 0xC7, 0xC0,  //        #####   #####         //
	     0x07, 0xC7, 0xC0,  //        #####   #####         //
	     0x07, 0xC7, 0xC0,  //        #####   #####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6525   [x]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xC7, 0xC0,  //        #####   #####         //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x01, 0xEF, 0x00,  //          #### ####           //
	     0x01, 0xEF, 0x00,  //          #### ####           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xEF, 0x00,  //          #### ####           //
	     0x01, 0xEF, 0x00,  //          #### ####           //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x07, 0xC7, 0xC0,  //        #####   #####         //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6600   [y]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x01, 0xE0, 0x00,  //          ####                //

	     // @6675   [z]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @6750   [{]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x1F, 0x80,  //              ######          //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x1F, 0x80,  //              ######          //
	     0x00, 0x0F, 0x80,  //               #####          //

	     // @6825   [|]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //

	     // @6900   [}]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x03, 0xF0, 0x00,  //         ######               //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x03, 0xF0, 0x00,  //         ######               //
	     0x03, 0xE0, 0x00,  //         #####                //

	     // @6975   [~]   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xC0, 0xE0,  //         ####      ###        //
	     0x07, 0xF0, 0xE0,  //        #######    ###        //
	     0x07, 0xF8, 0xE0,  //        ########   ###        //
	     0x0F, 0x3D, 0xE0,  //       ####  #### ####        //
	     0x0E, 0x3F, 0xC0,  //       ###   ########         //
	     0x0E, 0x1F, 0xC0,  //       ###    #######         //
	     0x0E, 0x0F, 0x80,  //       ###     #####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7050   []   (23 px wide)
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xC3, 0x00,  //         ####    ##           //
	     0x03, 0xC1, 0x00,  //         ####     #           //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x03, 0xFC, 0x00,  //         ########             //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x3F, 0x80,  //             #######          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x02, 0x07, 0x80,  //         #      ####          //
	     0x03, 0x07, 0x80,  //         ##     ####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7125   []   (23 px wide)
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x1F, 0x00,  //              #####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7200   []   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xE1, 0x00,  //          ####    #           //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x1F, 0x00,  //              #####           //
	     0x01, 0x0F, 0x00,  //          #    ####           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7275   []   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7350   []   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE4, 0x00,  //          ####  #             //
	     0x01, 0xEC, 0x00,  //          #### ##             //
	     0x01, 0xFC, 0x00,  //          #######             //
	     0x01, 0xF8, 0x00,  //          ######              //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x07, 0xE0, 0x00,  //        ######                //
	     0x07, 0xE0, 0x00,  //        ######                //
	     0x05, 0xE0, 0x00,  //        # ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7425   []   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0xFF, 0x80,  //        ############          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x0F, 0x87, 0xC0,  //       #####    #####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x03, 0x80,  //                 ###          //

	     // @7500   []   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x0F, 0x80,  //               #####          //
	     0x00, 0x1F, 0x00,  //              #####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xF0, 0x00,  //          #####               //
	     0x03, 0xE0, 0x00,  //         #####                //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7575   []   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x7A, 0x00,  //            #### #            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x01, 0xF8, 0x00,  //          ######              //
	     0x01, 0xF8, 0x00,  //          ######              //
	     0x01, 0x78, 0x00,  //          # ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x78, 0x00,  //            ####              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7650   []   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x7F, 0x80,  //            ########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xE7, 0x80,  //         #####  ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xF7, 0x80,  //           #### ####          //
	     0x00, 0x03, 0x80,  //                 ###          //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x07, 0x80,  //                ####          //
	     0x00, 0x03, 0x80,  //                 ###          //

	     // @7725   []   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xF8, 0x00,  //           #####              //
	     0x00, 0xF0, 0x00,  //           ####               //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7800   []   (23 px wide)
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0xFF, 0x80,  //           #########          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x03, 0xE1, 0x80,  //         #####    ##          //
	     0x03, 0xC0, 0x80,  //         ####      #          //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x07, 0x80, 0x00,  //        ####                  //
	     0x03, 0xC0, 0x80,  //         ####      #          //
	     0x03, 0xE1, 0x80,  //         #####    ##          //
	     0x01, 0xFF, 0x80,  //          ##########          //
	     0x00, 0xFF, 0x80,  //           #########          //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @7875   []   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xFE, 0x00,  //         #########            //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x00, 0x07, 0x00,  //                ###           //
	     0x00, 0x0E, 0x00,  //               ###            //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x07, 0x00,  //                ###           //

	     // @7950   []   (23 px wide)
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x07, 0xC7, 0x80,  //        #####   ####          //
	     0x07, 0xC7, 0x80,  //        #####   ####          //
	     0x07, 0xE7, 0x80,  //        ######  ####          //
	     0x07, 0xE7, 0x80,  //        ######  ####          //
	     0x07, 0xE7, 0x80,  //        ######  ####          //
	     0x07, 0xF7, 0x80,  //        ####### ####          //
	     0x07, 0xB7, 0x80,  //        #### ## ####          //
	     0x07, 0xB7, 0x80,  //        #### ## ####          //
	     0x07, 0xBF, 0x80,  //        #### #######          //
	     0x07, 0x9F, 0x80,  //        ####  ######          //
	     0x07, 0x9F, 0x80,  //        ####  ######          //
	     0x07, 0x9F, 0x80,  //        ####  ######          //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x8F, 0x80,  //        ####   #####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8025   []   (23 px wide)
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x3C, 0x00,  //             ####             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x70, 0x00,  //            ###               //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x0F, 0x03, 0xC0,  //       ####      ####         //
	     0x07, 0x87, 0x80,  //        ####    ####          //
	     0x07, 0xCF, 0x80,  //        #####  #####          //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x01, 0xFE, 0x00,  //          ########            //
	     0x00, 0xFC, 0x00,  //           ######             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8100   []   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x01, 0xF1, 0x00,  //          #####   #           //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xE0, 0x00,  //          ####                //
	     0x01, 0xF1, 0x00,  //          #####   #           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x7F, 0x00,  //            #######           //
	     0x00, 0x3E, 0x00,  //             #####            //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8175   []   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xCE, 0x00,  //          ###  ###            //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xCF, 0x00,  //         ####  ####           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xC0, 0x00,  //         ####                 //
	     0x03, 0xE1, 0x00,  //         #####    #           //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFF, 0x00,  //           ########           //
	     0x00, 0x7E, 0x00,  //            ######            //
	     0x00, 0x0C, 0x00,  //               ##             //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x0E, 0x00,  //               ###            //

	     // @8250   []   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x03, 0xCE, 0x00,  //         ####  ###            //
	     0x03, 0xFF, 0x00,  //         ##########           //
	     0x03, 0xFF, 0x80,  //         ###########          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //

	     // @8325   []   (23 px wide)
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x0F, 0x00,  //               ####           //
	     0x00, 0x1E, 0x00,  //              ####            //
	     0x00, 0x1C, 0x00,  //              ###             //
	     0x00, 0x38, 0x00,  //             ###              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x03, 0xEF, 0x80,  //         ##### #####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xC7, 0x80,  //         ####   ####          //
	     0x03, 0xEF, 0x80,  //         ##### #####          //
	     0x01, 0xFF, 0x00,  //          #########           //
	     0x00, 0xFE, 0x00,  //           #######            //
	     0x00, 0x7C, 0x00,  //            #####             //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
	     0x00, 0x00, 0x00,  //                              //
};
 

const uint16_t font1desc[]=
{
		   0 ,		// !  (33)
		   75 ,		// "  (34)
		   150 ,		// #  (35)
		   225 ,		// $  (36)
		   300 ,		// %  (37)
		   375 ,		// &  (38)
		   450 ,		// '  (39)
		   525 ,		// (  (40)
		   600 ,		// )  (41)
		   675 ,		// *  (42)
		   750 ,		// +  (43)
		   825 ,		// ,  (44)
		   900 ,		// -  (45)
		   975 ,		// .  (46)
		   1050 ,		// /  (47)
		   1125 ,		// 0  (48)
		   1200 ,		// 1  (49)
		   1275 ,		// 2  (50)
		   1350 ,		// 3  (51)
		   1425 ,		// 4  (52)
		   1500 ,		// 5  (53)
		   1575 ,		// 6  (54)
		   1650 ,		// 7  (55)
		   1725 ,		// 8  (56)
		   1800 ,		// 9  (57)
		   1875 ,		// :  (58)
		   1950 ,		// ;  (59)
		   2025 ,		// <  (60)
		   2100 ,		// =  (61)
		   2175 ,		// >  (62)
		   2250 ,		// ?  (63)
		   2325 ,		// @  (64)
		   2400 ,		// A  (65)
		   2475 ,		// B  (66)
		   2550 ,		// C  (67)
		   2625 ,		// D  (68)
		   2700 ,		// E  (69)
		   2775 ,		// F  (70)
		   2850 ,		// G  (71)
		   2925 ,		// H  (72)
		   3000 ,		// I  (73)
		   3075 ,		// J  (74)
		   3150 ,		// K  (75)
		   3225 ,		// L  (76)
		   3300 ,		// M  (77)
		   3375 ,		// N  (78)
		   3450 ,		// O  (79)
		   3525 ,		// P  (80)
		   3600 ,		// Q  (81)
		   3675 ,		// R  (82)
		   3750 ,		// S  (83)
		   3825 ,		// T  (84)
		   3900 ,		// U  (85)
		   3975 ,		// V  (86)
		   4050 ,		// W  (87)
		   4125 ,		// X  (88)
		   4200 ,		// Y  (89)
		   4275 ,		// Z  (90)
		   4350 ,		// [  (91)
		   4425 ,		// //  (92)
		   4500 ,		// ]  (93)
		   4575 ,		// ^  (94)
		   4650 ,		// _  (95)
		   4725 ,		// `  (96)
		   4800 ,		// a  (97)
		   4875 ,		// b  (98)
		   4950 ,		// c  (99)
		   5025 ,		// d  (100)
		   5100 ,		// e  (101)
		   5175 ,		// f  (102)
		   5250 ,		// g  (103)
		   5325 ,		// h  (104)
		   5400 ,		// i  (105)
		   5475 ,		// j  (106)
		   5550 ,		// k  (107)
		   5625 ,		// l  (108)
		   5700 ,		// m  (109)
		   5775 ,		// n  (110)
		   5850 ,		// o  (111)
		   5925 ,		// p  (112)
		   6000 ,		// q  (113)
		   6075 ,		// r  (114)
		   6150 ,		// s  (115)
		   6225 ,		// t  (116)
		   6300 ,		// u  (117)
		   6375 ,		// v  (118)
		   6450 ,		// w  (119)
		   6525 ,		// x  (120)
		   6600 ,		// y  (121)
		   6675 ,		// z  (122)
		   6750 ,		// {  (123)
		   6825 ,		// |  (124)
		   6900 ,		// }  (125)
		   6975 ,		// ~  (126)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7050 ,		//   (140)
		   0 ,		//
		   0 ,		//
		   7125 ,		//   (143)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7200 ,		//   (156)
		   0 ,		//
		   0 ,		//
		   7275 ,		//   (159)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7350 ,		//   (163)
		   0 ,		//
		   7425 ,		//   (165)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7500 ,		//   (175)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7575 ,		//   (179)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7650 ,		//   (185)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7725 ,		//   (191)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7800 ,		//   (198)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    7875 ,		//   (202)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    7950 ,		//   (209)
		    0 ,		//
		    8025 ,		//   (211)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    8100 ,		//   (230)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    8175 ,		//   (234)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    8250 ,		//   (241)
		    0 ,		//
		    8325 		//   (243)
};
 


 


// informacje Arial Black 72
const uint8_t fontinfo1[] =
{
	    25,  // Character height
	    '!',  //  Start character
	    0,  //  number of pixels of interspace between characters
	    23,  // number of pixels of space character


};
//*************************************************************************************
//druga czcionka
const uint8_t font2[] = 
{
		  // @0   [!]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @54   ["]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0x60, 0x00,  //         ## ##           //
		     0x03, 0x60, 0x00,  //         ## ##           //
		     0x03, 0x60, 0x00,  //         ## ##           //
		     0x03, 0x60, 0x00,  //         ## ##           //
		     0x03, 0x60, 0x00,  //         ## ##           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @108   [#]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0x08, 0x00,  //          #    #         //
		     0x01, 0x08, 0x00,  //          #    #         //
		     0x02, 0x10, 0x00,  //         #    #          //
		     0x0F, 0xFC, 0x00,  //       ##########        //
		     0x0F, 0xFC, 0x00,  //       ##########        //
		     0x02, 0x10, 0x00,  //         #    #          //
		     0x04, 0x20, 0x00,  //        #    #           //
		     0x1F, 0xF8, 0x00,  //      ##########         //
		     0x1F, 0xF8, 0x00,  //      ##########         //
		     0x04, 0x20, 0x00,  //        #    #           //
		     0x08, 0x40, 0x00,  //       #    #            //
		     0x08, 0x40, 0x00,  //       #    #            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @162   [$]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x80, 0x00,  //           #             //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x06, 0x98, 0x00,  //        ## #  ##         //
		     0x0C, 0x98, 0x00,  //       ##  #  ##         //
		     0x0C, 0x80, 0x00,  //       ##  #             //
		     0x0C, 0x80, 0x00,  //       ##  #             //
		     0x07, 0xF0, 0x00,  //        #######          //
		     0x00, 0x98, 0x00,  //           #  ##         //
		     0x00, 0x98, 0x00,  //           #  ##         //
		     0x0C, 0x98, 0x00,  //       ##  #  ##         //
		     0x0C, 0xB0, 0x00,  //       ##  # ##          //
		     0x07, 0xE0, 0x00,  //        ######           //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x00, 0x00,  //                         //

		     // @216   [%]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x7C, 0x10, 0x00,  //    #####     #          //
		     0xC6, 0x10, 0x00,  //   ##   ##    #          //
		     0xC6, 0x20, 0x00,  //   ##   ##   #           //
		     0xC6, 0x20, 0x00,  //   ##   ##   #           //
		     0xC6, 0x40, 0x00,  //   ##   ##  #            //
		     0xC6, 0x4F, 0x80,  //   ##   ##  #  #####     //
		     0x7C, 0x98, 0xC0,  //    #####  #  ##   ##    //
		     0x00, 0x98, 0xC0,  //           #  ##   ##    //
		     0x01, 0x18, 0xC0,  //          #   ##   ##    //
		     0x01, 0x18, 0xC0,  //          #   ##   ##    //
		     0x02, 0x18, 0xC0,  //         #    ##   ##    //
		     0x02, 0x0F, 0x80,  //         #     #####     //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @270   [&]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xC0, 0x00,  //        #####            //
		     0x0C, 0x60, 0x00,  //       ##   ##           //
		     0x0C, 0x60, 0x00,  //       ##   ##           //
		     0x0C, 0x60, 0x00,  //       ##   ##           //
		     0x06, 0xCC, 0x00,  //        ## ##  ##        //
		     0x07, 0x8C, 0x00,  //        ####   ##        //
		     0x0C, 0xCC, 0x00,  //       ##  ##  ##        //
		     0x18, 0x68, 0x00,  //      ##    ## #         //
		     0x18, 0x38, 0x00,  //      ##     ###         //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x0C, 0x2C, 0x00,  //       ##    # ##        //
		     0x07, 0xC6, 0x00,  //        #####   ##       //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @324   [']   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @378   [(]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x30, 0x00,  //             ##          //

		     // @432   [)]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //

		     // @486   [*]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x80, 0x00,  //           #             //
		     0x04, 0x90, 0x00,  //        #  #  #          //
		     0x02, 0xA0, 0x00,  //         # # #           //
		     0x01, 0xC0, 0x00,  //          ###            //
		     0x01, 0xC0, 0x00,  //          ###            //
		     0x02, 0xA0, 0x00,  //         # # #           //
		     0x04, 0x90, 0x00,  //        #  #  #          //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @540   [+]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x80, 0x00,  //           #             //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x80, 0x00,  //           #             //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @594   [,]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xE0, 0x00,  //           ###           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //

		     // @648   [-]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @702   [.]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @756   [/]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //

		     // @810   [0]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @864   [1]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x03, 0xC0, 0x00,  //         ####            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @918   [2]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xE0, 0x00,  //        ######           //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @972   [3]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xE0, 0x00,  //        ######           //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x07, 0xE0, 0x00,  //        ######           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1026   [4]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x70, 0x00,  //            ###          //
		     0x00, 0xB0, 0x00,  //           # ##          //
		     0x01, 0x30, 0x00,  //          #  ##          //
		     0x02, 0x30, 0x00,  //         #   ##          //
		     0x04, 0x30, 0x00,  //        #    ##          //
		     0x08, 0x30, 0x00,  //       #     ##          //
		     0x0F, 0xFC, 0x00,  //       ##########        //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1080   [5]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0xE0, 0x00,  //        ######           //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x07, 0xE0, 0x00,  //        ######           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1134   [6]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xF0, 0x00,  //           ####          //
		     0x03, 0x80, 0x00,  //         ###             //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x0D, 0xE0, 0x00,  //       ## ####           //
		     0x0E, 0x30, 0x00,  //       ###   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1188   [7]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1242   [8]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1296   [9]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x38, 0x00,  //        ##   ###         //
		     0x03, 0xD8, 0x00,  //         #### ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0xE0, 0x00,  //           ###           //
		     0x07, 0x80, 0x00,  //        ####             //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1350   [:]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1404   [;]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xE0, 0x00,  //           ###           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //

		     // @1458   [<]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x08, 0x00,  //               #         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x08, 0x00,  //               #         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1512   [=]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1566   [>]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x08, 0x00, 0x00,  //       #                 //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x08, 0x00, 0x00,  //       #                 //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1620   [?]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1674   [@]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x10, 0x04, 0x00,  //      #         #        //
		     0x11, 0xF4, 0x00,  //      #   ##### #        //
		     0x23, 0x32, 0x00,  //     #   ##  ##  #       //
		     0x26, 0x32, 0x00,  //     #  ##   ##  #       //
		     0x26, 0x32, 0x00,  //     #  ##   ##  #       //
		     0x26, 0x32, 0x00,  //     #  ##   ##  #       //
		     0x26, 0x32, 0x00,  //     #  ##   ##  #       //
		     0x26, 0x72, 0x00,  //     #  ##  ###  #       //
		     0x13, 0xBC, 0x00,  //      #  ### ####        //
		     0x10, 0x00, 0x00,  //      #                  //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x00, 0x00,  //                         //

		     // @1728   [A]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1782   [B]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xE0, 0x00,  //       #######           //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x10, 0x00,  //       ##     #          //
		     0x0F, 0xF0, 0x00,  //       ########          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0F, 0xF0, 0x00,  //       ########          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1836   [C]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0xF8, 0x00,  //          ######         //
		     0x07, 0x0C, 0x00,  //        ###    ##        //
		     0x06, 0x0C, 0x00,  //        ##     ##        //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x06, 0x0C, 0x00,  //        ##     ##        //
		     0x07, 0x0C, 0x00,  //        ###    ##        //
		     0x01, 0xF8, 0x00,  //          ######         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1890   [D]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x1F, 0xE0, 0x00,  //      ########           //
		     0x18, 0x38, 0x00,  //      ##     ###         //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x18, 0x38, 0x00,  //      ##     ###         //
		     0x1F, 0xE0, 0x00,  //      ########           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1944   [E]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0F, 0xF0, 0x00,  //       ########          //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @1998   [F]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2052   [G]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xF8, 0x00,  //         #######         //
		     0x0E, 0x0C, 0x00,  //       ###     ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x18, 0x00, 0x00,  //      ##                 //
		     0x18, 0x00, 0x00,  //      ##                 //
		     0x18, 0x00, 0x00,  //      ##                 //
		     0x18, 0x7C, 0x00,  //      ##    #####        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0E, 0x0C, 0x00,  //       ###     ##        //
		     0x03, 0xF8, 0x00,  //         #######         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2106   [H]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x1F, 0xFC, 0x00,  //      ###########        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2160   [I]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2214   [J]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0xF0, 0x00,  //          #####          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x07, 0xC0, 0x00,  //        #####            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2268   [K]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0C, 0x60, 0x00,  //       ##   ##           //
		     0x0C, 0xC0, 0x00,  //       ##  ##            //
		     0x0D, 0x80, 0x00,  //       ## ##             //
		     0x0F, 0x80, 0x00,  //       #####             //
		     0x0E, 0xC0, 0x00,  //       ### ##            //
		     0x0C, 0x60, 0x00,  //       ##   ##           //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2322   [L]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2376   [M]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x30, 0x0E, 0x00,  //     ##        ###       //
		     0x38, 0x0E, 0x00,  //     ###       ###       //
		     0x38, 0x1E, 0x00,  //     ###      ####       //
		     0x2C, 0x16, 0x00,  //     # ##     # ##       //
		     0x2C, 0x36, 0x00,  //     # ##    ## ##       //
		     0x26, 0x26, 0x00,  //     #  ##   #  ##       //
		     0x26, 0x66, 0x00,  //     #  ##  ##  ##       //
		     0x23, 0x46, 0x00,  //     #   ## #   ##       //
		     0x23, 0xC6, 0x00,  //     #   ####   ##       //
		     0x21, 0x86, 0x00,  //     #    ##    ##       //
		     0x21, 0x86, 0x00,  //     #    ##    ##       //
		     0x20, 0x06, 0x00,  //     #          ##       //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2430   [N]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x1C, 0x04, 0x00,  //      ###       #        //
		     0x1C, 0x04, 0x00,  //      ###       #        //
		     0x16, 0x04, 0x00,  //      # ##      #        //
		     0x13, 0x04, 0x00,  //      #  ##     #        //
		     0x11, 0x84, 0x00,  //      #   ##    #        //
		     0x11, 0x84, 0x00,  //      #   ##    #        //
		     0x10, 0xC4, 0x00,  //      #    ##   #        //
		     0x10, 0x64, 0x00,  //      #     ##  #        //
		     0x10, 0x64, 0x00,  //      #     ##  #        //
		     0x10, 0x34, 0x00,  //      #      ## #        //
		     0x10, 0x1C, 0x00,  //      #       ###        //
		     0x10, 0x1C, 0x00,  //      #       ###        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2484   [O]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x0E, 0x1C, 0x00,  //       ###    ###        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0E, 0x1C, 0x00,  //       ###    ###        //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2538   [P]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF0, 0x00,  //       ########          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0F, 0xF0, 0x00,  //       ########          //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2592   [Q]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x0E, 0x1C, 0x00,  //       ###    ###        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0E, 0x1C, 0x00,  //       ###    ###        //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x70, 0x00,  //            ###          //
		     0x00, 0x3E, 0x00,  //             #####       //

		     // @2646   [R]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x1F, 0xE0, 0x00,  //      ########           //
		     0x18, 0x30, 0x00,  //      ##     ##          //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x18, 0x30, 0x00,  //      ##     ##          //
		     0x1F, 0xE0, 0x00,  //      ########           //
		     0x18, 0xC0, 0x00,  //      ##   ##            //
		     0x18, 0x60, 0x00,  //      ##    ##           //
		     0x18, 0x30, 0x00,  //      ##     ##          //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2700   [S]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0E, 0x00, 0x00,  //       ###               //
		     0x07, 0xC0, 0x00,  //        #####            //
		     0x01, 0xF0, 0x00,  //          #####          //
		     0x00, 0x38, 0x00,  //             ###         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x07, 0xE0, 0x00,  //        ######           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2754   [T]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xFC, 0x00,  //       ##########        //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2808   [U]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x07, 0xF0, 0x00,  //        #######          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2862   [V]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2916   [W]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x60, 0xC1, 0x80,  //    ##     ##     ##     //
		     0x60, 0xC1, 0x80,  //    ##     ##     ##     //
		     0x60, 0xC1, 0x80,  //    ##     ##     ##     //
		     0x31, 0xE3, 0x00,  //     ##   ####   ##      //
		     0x31, 0x23, 0x00,  //     ##   #  #   ##      //
		     0x33, 0x33, 0x00,  //     ##  ##  ##  ##      //
		     0x1B, 0x36, 0x00,  //      ## ##  ## ##       //
		     0x1A, 0x16, 0x00,  //      ## #    # ##       //
		     0x1E, 0x1E, 0x00,  //      ####    ####       //
		     0x0E, 0x1C, 0x00,  //       ###    ###        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @2970   [X]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3024   [Y]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3078   [Z]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3132   [[]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0xE0, 0x00,  //         #####           //

		     // @3186   [\]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //

		     // @3240   []]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x03, 0xE0, 0x00,  //         #####           //

		     // @3294   [^]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x80, 0x00,  //           #             //
		     0x01, 0xC0, 0x00,  //          ###            //
		     0x03, 0x60, 0x00,  //         ## ##           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x18, 0x0C, 0x00,  //      ##       ##        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3348   [_]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x1F, 0xFC, 0x00,  //      ###########        //
		     0x00, 0x00, 0x00,  //                         //

		     // @3402   [`]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3456   [a]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x01, 0xF8, 0x00,  //          ######         //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x38, 0x00,  //       ##    ###         //
		     0x07, 0xD8, 0x00,  //        ##### ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3510   [b]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0D, 0xE0, 0x00,  //       ## ####           //
		     0x0E, 0x30, 0x00,  //       ###   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0E, 0x30, 0x00,  //       ###   ##          //
		     0x0D, 0xE0, 0x00,  //       ## ####           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3564   [c]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0xF0, 0x00,  //          #####          //
		     0x03, 0x18, 0x00,  //         ##   ##         //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x03, 0x18, 0x00,  //         ##   ##         //
		     0x01, 0xF0, 0x00,  //          #####          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3618   [d]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x03, 0xD8, 0x00,  //         #### ##         //
		     0x06, 0x38, 0x00,  //        ##   ###         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x38, 0x00,  //        ##   ###         //
		     0x03, 0xD8, 0x00,  //         #### ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3672   [e]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3726   [f]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xF0, 0x00,  //           ####          //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3780   [g]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xD8, 0x00,  //         #### ##         //
		     0x06, 0x38, 0x00,  //        ##   ###         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x38, 0x00,  //        ##   ###         //
		     0x03, 0xD8, 0x00,  //         #### ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //

		     // @3834   [h]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0D, 0xE0, 0x00,  //       ## ####           //
		     0x0E, 0x30, 0x00,  //       ###   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3888   [i]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @3942   [j]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x03, 0xC0, 0x00,  //         ####            //

		     // @3996   [k]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0C, 0x60, 0x00,  //       ##   ##           //
		     0x0C, 0xC0, 0x00,  //       ##  ##            //
		     0x0D, 0x80, 0x00,  //       ## ##             //
		     0x0F, 0x80, 0x00,  //       #####             //
		     0x0E, 0xC0, 0x00,  //       ### ##            //
		     0x0C, 0x60, 0x00,  //       ##   ##           //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4050   [l]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4104   [m]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x37, 0x9E, 0x00,  //     ## ####  ####       //
		     0x38, 0xE3, 0x00,  //     ###   ###   ##      //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4158   [n]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0D, 0xE0, 0x00,  //       ## ####           //
		     0x0E, 0x30, 0x00,  //       ###   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4212   [o]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4266   [p]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0D, 0xE0, 0x00,  //       ## ####           //
		     0x0E, 0x30, 0x00,  //       ###   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0E, 0x30, 0x00,  //       ###   ##          //
		     0x0D, 0xE0, 0x00,  //       ## ####           //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //

		     // @4320   [q]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xD8, 0x00,  //         #### ##         //
		     0x06, 0x38, 0x00,  //        ##   ###         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x38, 0x00,  //        ##   ###         //
		     0x03, 0xD8, 0x00,  //         #### ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x18, 0x00,  //              ##         //

		     // @4374   [r]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x06, 0x70, 0x00,  //        ##  ###          //
		     0x06, 0xF0, 0x00,  //        ## ####          //
		     0x07, 0x00, 0x00,  //        ###              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4428   [s]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0x80, 0x00,  //        ####             //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0xF0, 0x00,  //           ####          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4482   [t]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0xF0, 0x00,  //           ####          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4536   [u]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x38, 0x00,  //        ##   ###         //
		     0x03, 0xD8, 0x00,  //         #### ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4590   [v]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4644   [w]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x30, 0xC3, 0x00,  //     ##    ##    ##      //
		     0x18, 0xC6, 0x00,  //      ##   ##   ##       //
		     0x19, 0xE6, 0x00,  //      ##  ####  ##       //
		     0x19, 0x26, 0x00,  //      ##  #  #  ##       //
		     0x0F, 0x3C, 0x00,  //       ####  ####        //
		     0x0F, 0x3C, 0x00,  //       ####  ####        //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4698   [x]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0x60, 0x00,  //         ## ##           //
		     0x01, 0xC0, 0x00,  //          ###            //
		     0x03, 0x60, 0x00,  //         ## ##           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4752   [y]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x03, 0x30, 0x00,  //         ##  ##          //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x01, 0xE0, 0x00,  //          ####           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //

		     // @4806   [z]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @4860   [{]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x78, 0x00,  //            ####         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x07, 0x00, 0x00,  //        ###              //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x78, 0x00,  //            ####         //

		     // @4914   [|]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //

		     // @4968   [}]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0x80, 0x00,  //        ####             //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x38, 0x00,  //             ###         //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x07, 0x80, 0x00,  //        ####             //

		     // @5022   [~]   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x06, 0x04, 0x00,  //        ##      #        //
		     0x09, 0x04, 0x00,  //       #  #     #        //
		     0x10, 0x84, 0x00,  //      #    #    #        //
		     0x10, 0x48, 0x00,  //      #     #  #         //
		     0x10, 0x30, 0x00,  //      #      ##          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5076   []   (18 px wide)
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0E, 0x00, 0x00,  //       ###               //
		     0x07, 0xC0, 0x00,  //        #####            //
		     0x01, 0xF0, 0x00,  //          #####          //
		     0x00, 0x38, 0x00,  //             ###         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x07, 0xE0, 0x00,  //        ######           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5130   []   (18 px wide)
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5184   []   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0x80, 0x00,  //        ####             //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0xF0, 0x00,  //           ####          //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5238   []   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5292   []   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x40, 0x00,  //        ##  #            //
		     0x06, 0x80, 0x00,  //        ## #             //
		     0x07, 0x00, 0x00,  //        ###              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x0E, 0x00, 0x00,  //       ###               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5346   []   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0xC0, 0x00,  //         ####            //
		     0x03, 0xC0, 0x00,  //         ####            //
		     0x06, 0x60, 0x00,  //        ##  ##           //
		     0x06, 0x60, 0x00,  //        ##  ##           //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x0F, 0xF0, 0x00,  //       ########          //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x18, 0x18, 0x00,  //      ##      ##         //
		     0x00, 0x20, 0x00,  //             #           //
		     0x00, 0x20, 0x00,  //             #           //
		     0x00, 0x1C, 0x00,  //              ###        //

		     // @5400   []   (18 px wide)
		     0x01, 0x80, 0x00,  //          ##             //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5454   []   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xE0, 0x00,  //           ###           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0xC0, 0x00,  //          ###            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5508   []   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xC0, 0x00,  //        #####            //
		     0x0C, 0x60, 0x00,  //       ##   ##           //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x0C, 0x30, 0x00,  //       ##    ##          //
		     0x18, 0x30, 0x00,  //      ##     ##          //
		     0x18, 0x30, 0x00,  //      ##     ##          //
		     0x18, 0x70, 0x00,  //      ##    ###          //
		     0x0F, 0xB0, 0x00,  //       ##### ##          //
		     0x00, 0x20, 0x00,  //             #           //
		     0x00, 0x20, 0x00,  //             #           //
		     0x00, 0x1C, 0x00,  //              ###        //

		     // @5562   []   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x00, 0x18, 0x00,  //              ##         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x03, 0x00, 0x00,  //         ##              //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x07, 0xF8, 0x00,  //        ########         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5616   []   (18 px wide)
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0xF8, 0x00,  //          ######         //
		     0x07, 0x0C, 0x00,  //        ###    ##        //
		     0x06, 0x0C, 0x00,  //        ##     ##        //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x06, 0x0C, 0x00,  //        ##     ##        //
		     0x07, 0x0C, 0x00,  //        ###    ##        //
		     0x01, 0xF8, 0x00,  //          ######         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5670   []   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0F, 0xF0, 0x00,  //       ########          //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x00, 0x40, 0x00,  //            #            //
		     0x00, 0x40, 0x00,  //            #            //
		     0x00, 0x38, 0x00,  //             ###         //

		     // @5724   []   (18 px wide)
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x1C, 0x04, 0x00,  //      ###       #        //
		     0x1C, 0x04, 0x00,  //      ###       #        //
		     0x16, 0x04, 0x00,  //      # ##      #        //
		     0x13, 0x04, 0x00,  //      #  ##     #        //
		     0x11, 0x84, 0x00,  //      #   ##    #        //
		     0x11, 0x84, 0x00,  //      #   ##    #        //
		     0x10, 0xC4, 0x00,  //      #    ##   #        //
		     0x10, 0x64, 0x00,  //      #     ##  #        //
		     0x10, 0x64, 0x00,  //      #     ##  #        //
		     0x10, 0x34, 0x00,  //      #      ## #        //
		     0x10, 0x1C, 0x00,  //      #       ###        //
		     0x10, 0x1C, 0x00,  //      #       ###        //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5778   []   (18 px wide)
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x0E, 0x1C, 0x00,  //       ###    ###        //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x18, 0x06, 0x00,  //      ##        ##       //
		     0x0C, 0x0C, 0x00,  //       ##      ##        //
		     0x0E, 0x1C, 0x00,  //       ###    ###        //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5832   []   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x30, 0x00,  //             ##          //
		     0x00, 0x60, 0x00,  //            ##           //
		     0x00, 0x00, 0x00,  //                         //
		     0x01, 0xF0, 0x00,  //          #####          //
		     0x03, 0x18, 0x00,  //         ##   ##         //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x06, 0x00, 0x00,  //        ##               //
		     0x03, 0x18, 0x00,  //         ##   ##         //
		     0x01, 0xF0, 0x00,  //          #####          //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5886   []   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0F, 0xF8, 0x00,  //       #########         //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x0C, 0x00, 0x00,  //       ##                //
		     0x06, 0x18, 0x00,  //        ##    ##         //
		     0x03, 0xF0, 0x00,  //         ######          //
		     0x00, 0x40, 0x00,  //            #            //
		     0x00, 0x40, 0x00,  //            #            //
		     0x00, 0x38, 0x00,  //             ###         //

		     // @5940   []   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0x00, 0x00,  //                         //
		     0x0D, 0xE0, 0x00,  //       ## ####           //
		     0x0E, 0x30, 0x00,  //       ###   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //

		     // @5994   []   (18 px wide)
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0xC0, 0x00,  //           ##            //
		     0x01, 0x80, 0x00,  //          ##             //
		     0x00, 0x00, 0x00,  //                         //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x0C, 0x18, 0x00,  //       ##     ##         //
		     0x06, 0x30, 0x00,  //        ##   ##          //
		     0x03, 0xE0, 0x00,  //         #####           //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
		     0x00, 0x00, 0x00,  //                         //
	 };
//szerokosc 22
	const uint16_t font2desc[]=
{
		     0 ,		// !  (33)
		    54 ,		// "  (34)
		    108 ,		// #  (35)
		    162 ,		// $  (36)
		    216 ,		// %  (37)
		    270 ,		// &  (38)
		    324 ,		// '  (39)
		    378 ,		// (  (40)
		    432 ,		// )  (41)
		    486 ,		// *  (42)
		    540 ,		// +  (43)
		    594 ,		// ,  (44)
		    648 ,		// -  (45)
		    702 ,		// .  (46)
		    756 ,		// /  (47)
		    810 ,		// 0  (48)
		    864 ,		// 1  (49)
		    918 ,		// 2  (50)
		    972 ,		// 3  (51)
		    1026 ,		// 4  (52)
		    1080 ,		// 5  (53)
		    1134 ,		// 6  (54)
		    1188 ,		// 7  (55)
		    1242 ,		// 8  (56)
		    1296 ,		// 9  (57)
		    1350 ,		// :  (58)
		    1404 ,		// ;  (59)
		    1458 ,		// <  (60)
		    1512 ,		// =  (61)
		    1566 ,		// >  (62)
		    1620 ,		// ?  (63)
		    1674 ,		// @  (64)
		    1728 ,		// A  (65)
		    1782 ,		// B  (66)
		    1836 ,		// C  (67)
		    1890 ,		// D  (68)
		    1944 ,		// E  (69)
		    1998 ,		// F  (70)
		    2052 ,		// G  (71)
		    2106 ,		// H  (72)
		    2160 ,		// I  (73)
		    2214 ,		// J  (74)
		    2268 ,		// K  (75)
		    2322 ,		// L  (76)
		    2376 ,		// M  (77)
		    2430 ,		// N  (78)
		    2484 ,		// O  (79)
		    2538 ,		// P  (80)
		    2592 ,		// Q  (81)
		    2646 ,		// R  (82)
		    2700 ,		// S  (83)
		    2754 ,		// T  (84)
		    2808 ,		// U  (85)
		    2862 ,		// V  (86)
		    2916 ,		// W  (87)
		    2970 ,		// X  (88)
		    3024 ,		// Y  (89)
		    3078 ,		// Z  (90)
		    3132 ,		// [  (91)
		    3186 ,		// //  (92)
		    3240 ,		// ]  (93)
		    3294 ,		// ^  (94)
		    3348 ,		// _  (95)
		    3402 ,		// `  (96)
		    3456 ,		// a  (97)
		    3510 ,		// b  (98)
		    3564 ,		// c  (99)
		    3618 ,		// d  (100)
		    3672 ,		// e  (101)
		    3726 ,		// f  (102)
		    3780 ,		// g  (103)
		    3834 ,		// h  (104)
		    3888 ,		// i  (105)
		    3942 ,		// j  (106)
		    3996 ,		// k  (107)
		    4050 ,		// l  (108)
		    4104 ,		// m  (109)
		    4158 ,		// n  (110)
		    4212 ,		// o  (111)
		    4266 ,		// p  (112)
		    4320 ,		// q  (113)
		    4374 ,		// r  (114)
		    4428 ,		// s  (115)
		    4482 ,		// t  (116)
		    4536 ,		// u  (117)
		    4590 ,		// v  (118)
		    4644 ,		// w  (119)
		    4698 ,		// x  (120)
		    4752 ,		// y  (121)
		    4806 ,		// z  (122)
		    4860 ,		// {  (123)
		    4914 ,		// |  (124)
		    4968 ,		// }  (125)
		    5022 ,		// ~  (126)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5076 ,		//   (140)
		    0 ,		//
		    0 ,		//
		    5130 ,		//   (143)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5184 ,		//   (156)
		    0 ,		//
		    0 ,		//
		    5238 ,		//   (159)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5292 ,		//   (163)
		    0 ,		//
		    5346 ,		//   (165)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5400 ,		//   (175)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5454 ,		//   (179)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5508 ,		//   (185)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5562 ,		//   (191)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5616 ,		//   (198)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5670 ,		//   (202)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5724 ,		//   (209)
		    0 ,		//
		    5778 ,		//   (211)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5832 ,		//   (230)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5886 ,		//   (234)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    5940 ,		//   (241)
		    0 ,		//
		    5994 		//   (243)
};

const uint8_t fontinfo2[] =
{
		 18,  // Character height
		    '!',  //  Start character
		    0,  //  number of pixels of interspace between characters
		    18,  // number of pixels of space character

};


const uint8_t font4[]=
{
		 // @0   [!]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x01, 0x00,  //          #          //
		     0x01, 0x00,  //          #          //
		     0x01, 0x00,  //          #          //
		     0x00, 0x00,  //                     //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @32   ["]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @64   [#]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x02, 0x40,  //         #  #        //
		     0x02, 0x40,  //         #  #        //
		     0x04, 0x40,  //        #   #        //
		     0x1F, 0xE0,  //      ########       //
		     0x04, 0x80,  //        #  #         //
		     0x04, 0x80,  //        #  #         //
		     0x1F, 0xE0,  //      ########       //
		     0x09, 0x00,  //       #  #          //
		     0x09, 0x00,  //       #  #          //
		     0x09, 0x00,  //       #  #          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @96   [$]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x02, 0x00,  //         #           //
		     0x0F, 0x80,  //       #####         //
		     0x1A, 0xC0,  //      ## # ##        //
		     0x1A, 0x40,  //      ## #  #        //
		     0x1E, 0x00,  //      ####           //
		     0x0E, 0x00,  //       ###           //
		     0x07, 0x80,  //        ####         //
		     0x03, 0xC0,  //         ####        //
		     0x12, 0xC0,  //      #  # ##        //
		     0x1A, 0xC0,  //      ## # ##        //
		     0x0F, 0x80,  //       #####         //
		     0x02, 0x00,  //         #           //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @128   [%]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x70, 0x40,  //    ###     #        //
		     0xD8, 0x80,  //   ## ##   #         //
		     0xD9, 0x00,  //   ## ##  #          //
		     0xD9, 0x00,  //   ## ##  #          //
		     0xDA, 0x70,  //   ## ## #  ###      //
		     0x72, 0xD8,  //    ###  # ## ##     //
		     0x04, 0xD8,  //        #  ## ##     //
		     0x08, 0xD8,  //       #   ## ##     //
		     0x08, 0xD8,  //       #   ## ##     //
		     0x10, 0x70,  //      #     ###      //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @160   [&]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x80,  //        ####         //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0x80,  //       ##  #         //
		     0x0F, 0x70,  //       #### ###      //
		     0x36, 0x20,  //     ## ##   #       //
		     0x67, 0x40,  //    ##  ### #        //
		     0x63, 0x90,  //    ##   ###  #      //
		     0x71, 0xE0,  //    ###   ####       //
		     0x3E, 0xC0,  //     ##### ##        //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @192   [']   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @224   [(]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x80,  //           #         //
		     0x01, 0x00,  //          #          //
		     0x03, 0x00,  //         ##          //
		     0x02, 0x00,  //         #           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x02, 0x00,  //         #           //
		     0x03, 0x00,  //         ##          //
		     0x01, 0x00,  //          #          //
		     0x00, 0x80,  //           #         //

		     // @256   [)]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x04, 0x00,  //        #            //
		     0x02, 0x00,  //         #           //
		     0x03, 0x00,  //         ##          //
		     0x01, 0x00,  //          #          //
		     0x01, 0x80,  //          ##         //
		     0x01, 0x80,  //          ##         //
		     0x01, 0x80,  //          ##         //
		     0x01, 0x80,  //          ##         //
		     0x01, 0x80,  //          ##         //
		     0x01, 0x00,  //          #          //
		     0x03, 0x00,  //         ##          //
		     0x02, 0x00,  //         #           //
		     0x04, 0x00,  //        #            //

		     // @288   [*]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x0F, 0x80,  //       #####         //
		     0x07, 0x00,  //        ###          //
		     0x0D, 0x80,  //       ## ##         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @320   [+]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x1F, 0xC0,  //      #######        //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @352   [,]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x01, 0x00,  //          #          //
		     0x02, 0x00,  //         #           //
		     0x00, 0x00,  //                     //

		     // @384   [-]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x80,  //        ####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @416   [.]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @448   [/]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x80,  //           #         //
		     0x00, 0x80,  //           #         //
		     0x01, 0x00,  //          #          //
		     0x01, 0x00,  //          #          //
		     0x01, 0x00,  //          #          //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x04, 0x00,  //        #            //
		     0x04, 0x00,  //        #            //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @480   [0]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x0F, 0x80,  //       #####         //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x0F, 0x80,  //       #####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @512   [1]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x0F, 0x00,  //       ####          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x0F, 0xC0,  //       ######        //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @544   [2]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x00,  //        ###          //
		     0x0F, 0x80,  //       #####         //
		     0x19, 0x80,  //      ##  ##         //
		     0x01, 0x80,  //          ##         //
		     0x01, 0x00,  //          #          //
		     0x01, 0x00,  //          #          //
		     0x02, 0x00,  //         #           //
		     0x04, 0x40,  //        #   #        //
		     0x0F, 0x80,  //       #####         //
		     0x1F, 0x80,  //      ######         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @576   [3]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x00,  //        ###          //
		     0x0F, 0x80,  //       #####         //
		     0x11, 0x80,  //      #   ##         //
		     0x01, 0x00,  //          #          //
		     0x07, 0x00,  //        ###          //
		     0x01, 0xC0,  //          ###        //
		     0x00, 0xC0,  //           ##        //
		     0x00, 0xC0,  //           ##        //
		     0x18, 0x80,  //      ##   #         //
		     0x1F, 0x00,  //      #####          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @608   [4]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x80,  //           #         //
		     0x01, 0x80,  //          ##         //
		     0x03, 0x80,  //         ###         //
		     0x05, 0x80,  //        # ##         //
		     0x09, 0x80,  //       #  ##         //
		     0x11, 0x80,  //      #   ##         //
		     0x1F, 0xC0,  //      #######        //
		     0x1F, 0xC0,  //      #######        //
		     0x01, 0x80,  //          ##         //
		     0x01, 0x80,  //          ##         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @640   [5]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0xC0,  //        #####        //
		     0x0F, 0x80,  //       #####         //
		     0x08, 0x00,  //       #             //
		     0x0F, 0x00,  //       ####          //
		     0x1F, 0x80,  //      ######         //
		     0x01, 0xC0,  //          ###        //
		     0x00, 0x40,  //            #        //
		     0x00, 0x40,  //            #        //
		     0x1C, 0x80,  //      ###  #         //
		     0x1F, 0x00,  //      #####          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @672   [6]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x01, 0xC0,  //          ###        //
		     0x07, 0x00,  //        ###          //
		     0x0C, 0x00,  //       ##            //
		     0x0F, 0x80,  //       #####         //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x0F, 0x80,  //       #####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @704   [7]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x0F, 0xC0,  //       ######        //
		     0x1F, 0x80,  //      ######         //
		     0x10, 0x80,  //      #    #         //
		     0x00, 0x80,  //           #         //
		     0x01, 0x00,  //          #          //
		     0x01, 0x00,  //          #          //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x04, 0x00,  //        #            //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @736   [8]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x0F, 0x80,  //       #####         //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x1C, 0x80,  //      ###  #         //
		     0x0F, 0x00,  //       ####          //
		     0x07, 0x80,  //        ####         //
		     0x09, 0xC0,  //       #  ###        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x0F, 0x80,  //       #####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @768   [9]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x0F, 0x80,  //       #####         //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x0F, 0x80,  //       #####         //
		     0x01, 0x80,  //          ##         //
		     0x07, 0x00,  //        ###          //
		     0x1C, 0x00,  //      ###            //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @800   [:]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @832   [;]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x01, 0x00,  //          #          //
		     0x02, 0x00,  //         #           //
		     0x00, 0x00,  //                     //

		     // @864   [<]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x20,  //             #       //
		     0x01, 0xC0,  //          ###        //
		     0x0E, 0x00,  //       ###           //
		     0x10, 0x00,  //      #              //
		     0x0E, 0x00,  //       ###           //
		     0x01, 0xC0,  //          ###        //
		     0x00, 0x20,  //             #       //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @896   [=]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1F, 0xE0,  //      ########       //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1F, 0xE0,  //      ########       //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @928   [>]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x10, 0x00,  //      #              //
		     0x0E, 0x00,  //       ###           //
		     0x01, 0xC0,  //          ###        //
		     0x00, 0x20,  //             #       //
		     0x01, 0xC0,  //          ###        //
		     0x0E, 0x00,  //       ###           //
		     0x10, 0x00,  //      #              //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @960   [?]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x80,  //        ####         //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x00, 0xC0,  //           ##        //
		     0x00, 0x80,  //           #         //
		     0x01, 0x00,  //          #          //
		     0x01, 0x00,  //          #          //
		     0x00, 0x00,  //                     //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @992   [@]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0xC0,  //        #####        //
		     0x08, 0x20,  //       #     #       //
		     0x10, 0x10,  //      #       #      //
		     0x23, 0x68,  //     #   ## ## #     //
		     0x46, 0xC8,  //    #   ## ##  #     //
		     0x4C, 0xC8,  //    #  ##  ##  #     //
		     0x4C, 0x88,  //    #  ##  #   #     //
		     0x4C, 0x90,  //    #  ##  #  #      //
		     0x4D, 0xA0,  //    #  ## ## #       //
		     0x26, 0xC8,  //     #  ## ##  #     //
		     0x10, 0x10,  //      #       #      //
		     0x08, 0x20,  //       #     #       //
		     0x07, 0xC0,  //        #####        //

		     // @1024   [A]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x02, 0x00,  //         #           //
		     0x06, 0x00,  //        ##           //
		     0x07, 0x00,  //        ###          //
		     0x0B, 0x00,  //       # ##          //
		     0x09, 0x80,  //       #  ##         //
		     0x09, 0x80,  //       #  ##         //
		     0x1F, 0xC0,  //      #######        //
		     0x10, 0xC0,  //      #    ##        //
		     0x20, 0x60,  //     #      ##       //
		     0x79, 0xF0,  //    ####  #####      //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1056   [B]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x3F, 0xC0,  //     ########        //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0xC0,  //      ##   ##        //
		     0x1F, 0x80,  //      ######         //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x3F, 0xC0,  //     ########        //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1088   [C]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0xA0,  //        #### #       //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x20,  //      ##     #       //
		     0x30, 0x00,  //     ##              //
		     0x30, 0x00,  //     ##              //
		     0x30, 0x00,  //     ##              //
		     0x30, 0x00,  //     ##              //
		     0x18, 0x20,  //      ##     #       //
		     0x18, 0x40,  //      ##    #        //
		     0x07, 0x80,  //        ####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1120   [D]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x3F, 0x00,  //     ######          //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x3F, 0x00,  //     ######          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1152   [E]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1F, 0xE0,  //      ########       //
		     0x0C, 0x20,  //       ##    #       //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x80,  //       ##  #         //
		     0x0F, 0x80,  //       #####         //
		     0x0C, 0x80,  //       ##  #         //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x20,  //       ##    #       //
		     0x1F, 0xE0,  //      ########       //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1184   [F]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1F, 0xE0,  //      ########       //
		     0x0C, 0x20,  //       ##    #       //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x80,  //       ##  #         //
		     0x0F, 0x80,  //       #####         //
		     0x0C, 0x80,  //       ##  #         //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x00,  //       ##            //
		     0x1E, 0x00,  //      ####           //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1216   [G]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x20,  //        ###  #       //
		     0x18, 0xE0,  //      ##   ###       //
		     0x18, 0x20,  //      ##     #       //
		     0x30, 0x00,  //     ##              //
		     0x30, 0x00,  //     ##              //
		     0x30, 0x00,  //     ##              //
		     0x30, 0xF0,  //     ##    ####      //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x07, 0xC0,  //        #####        //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1248   [H]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x3C, 0xF0,  //     ####  ####      //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x1F, 0xE0,  //      ########       //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x3C, 0xF0,  //     ####  ####      //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1280   [I]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x80,  //        ####         //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x07, 0x80,  //        ####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1312   [J]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x03, 0xE0,  //         #####       //
		     0x00, 0xC0,  //           ##        //
		     0x00, 0xC0,  //           ##        //
		     0x00, 0xC0,  //           ##        //
		     0x00, 0xC0,  //           ##        //
		     0x00, 0xC0,  //           ##        //
		     0x00, 0xC0,  //           ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x18, 0xC0,  //      ##   ##        //
		     0x0F, 0x80,  //       #####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1344   [K]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x79, 0xF0,  //    ####  #####      //
		     0x30, 0x80,  //     ##    #         //
		     0x31, 0x00,  //     ##   #          //
		     0x32, 0x00,  //     ##  #           //
		     0x3C, 0x00,  //     ####            //
		     0x36, 0x00,  //     ## ##           //
		     0x33, 0x00,  //     ##  ##          //
		     0x31, 0x80,  //     ##   ##         //
		     0x30, 0xC0,  //     ##    ##        //
		     0x79, 0xF0,  //    ####  #####      //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1376   [L]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1E, 0x00,  //      ####           //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x20,  //       ##    #       //
		     0x0C, 0x20,  //       ##    #       //
		     0x0C, 0x60,  //       ##   ##       //
		     0x1F, 0xC0,  //      #######        //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1408   [M]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0xF0, 0x78,  //   ####     ####     //
		     0x70, 0x70,  //    ###     ###      //
		     0x58, 0xB0,  //    # ##   # ##      //
		     0x58, 0xB0,  //    # ##   # ##      //
		     0x59, 0x30,  //    # ##  #  ##      //
		     0x4D, 0x30,  //    #  ## #  ##      //
		     0x4D, 0x30,  //    #  ## #  ##      //
		     0x4E, 0x30,  //    #  ###   ##      //
		     0x46, 0x30,  //    #   ##   ##      //
		     0xE4, 0x78,  //   ###  #   ####     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1440   [N]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x3C, 0xE0,  //     ####  ###       //
		     0x1C, 0x40,  //      ###   #        //
		     0x16, 0x40,  //      # ##  #        //
		     0x16, 0x40,  //      # ##  #        //
		     0x13, 0x40,  //      #  ## #        //
		     0x11, 0xC0,  //      #   ###        //
		     0x11, 0xC0,  //      #   ###        //
		     0x10, 0xC0,  //      #    ##        //
		     0x10, 0x40,  //      #     #        //
		     0x38, 0x40,  //     ###    #        //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1472   [O]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x80,  //        ####         //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x30, 0x30,  //     ##      ##      //
		     0x30, 0x30,  //     ##      ##      //
		     0x30, 0x30,  //     ##      ##      //
		     0x30, 0x30,  //     ##      ##      //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x07, 0x80,  //        ####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1504   [P]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1F, 0xC0,  //      #######        //
		     0x0C, 0x60,  //       ##   ##       //
		     0x0C, 0x60,  //       ##   ##       //
		     0x0C, 0x60,  //       ##   ##       //
		     0x0C, 0x60,  //       ##   ##       //
		     0x0F, 0xC0,  //       ######        //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x00,  //       ##            //
		     0x1E, 0x00,  //      ####           //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1536   [Q]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x80,  //        ####         //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x30, 0x30,  //     ##      ##      //
		     0x30, 0x30,  //     ##      ##      //
		     0x30, 0x30,  //     ##      ##      //
		     0x30, 0x30,  //     ##      ##      //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x07, 0x80,  //        ####         //
		     0x03, 0x00,  //         ##          //
		     0x01, 0x80,  //          ##         //
		     0x00, 0xE0,  //           ###       //

		     // @1568   [R]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x3F, 0xC0,  //     ########        //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x1F, 0xC0,  //      #######        //
		     0x1B, 0x00,  //      ## ##          //
		     0x19, 0x80,  //      ##  ##         //
		     0x19, 0x80,  //      ##  ##         //
		     0x18, 0xC0,  //      ##   ##        //
		     0x3C, 0x70,  //     ####   ###      //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1600   [S]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x40,  //        ### #        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0x40,  //       ##   #        //
		     0x0E, 0x00,  //       ###           //
		     0x07, 0x00,  //        ###          //
		     0x03, 0x80,  //         ###         //
		     0x09, 0xC0,  //       #  ###        //
		     0x08, 0xC0,  //       #   ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0B, 0x80,  //       # ###         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1632   [T]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1F, 0xE0,  //      ########       //
		     0x13, 0x20,  //      #  ##  #       //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x07, 0x80,  //        ####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1664   [U]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x3C, 0xE0,  //     ####  ###       //
		     0x18, 0x40,  //      ##    #        //
		     0x18, 0x40,  //      ##    #        //
		     0x18, 0x40,  //      ##    #        //
		     0x18, 0x40,  //      ##    #        //
		     0x18, 0x40,  //      ##    #        //
		     0x18, 0x40,  //      ##    #        //
		     0x18, 0x40,  //      ##    #        //
		     0x18, 0x40,  //      ##    #        //
		     0x0F, 0x80,  //       #####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1696   [V]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x3C, 0x70,  //     ####   ###      //
		     0x18, 0x20,  //      ##     #       //
		     0x18, 0x20,  //      ##     #       //
		     0x0C, 0x40,  //       ##   #        //
		     0x0C, 0x40,  //       ##   #        //
		     0x06, 0x80,  //        ## #         //
		     0x06, 0x80,  //        ## #         //
		     0x07, 0x00,  //        ###          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1728   [W]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0xF7, 0xDC,  //   #### ##### ###    //
		     0x63, 0x88,  //    ##   ###   #     //
		     0x31, 0x88,  //     ##   ##   #     //
		     0x31, 0x88,  //     ##   ##   #     //
		     0x3A, 0xD0,  //     ### # ## #      //
		     0x1A, 0xD0,  //      ## # ## #      //
		     0x1A, 0xD0,  //      ## # ## #      //
		     0x0C, 0x60,  //       ##   ##       //
		     0x0C, 0x60,  //       ##   ##       //
		     0x0C, 0x60,  //       ##   ##       //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1760   [X]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x3E, 0xF0,  //     ##### ####      //
		     0x18, 0x60,  //      ##    ##       //
		     0x0C, 0x80,  //       ##  #         //
		     0x06, 0x80,  //        ## #         //
		     0x07, 0x00,  //        ###          //
		     0x03, 0x00,  //         ##          //
		     0x05, 0x80,  //        # ##         //
		     0x05, 0x80,  //        # ##         //
		     0x18, 0xC0,  //      ##   ##        //
		     0x3D, 0xF0,  //     #### #####      //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1792   [Y]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x3C, 0x70,  //     ####   ###      //
		     0x18, 0x20,  //      ##     #       //
		     0x0C, 0x40,  //       ##   #        //
		     0x06, 0x40,  //        ##  #        //
		     0x06, 0x80,  //        ## #         //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x07, 0x80,  //        ####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1824   [Z]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1F, 0xE0,  //      ########       //
		     0x18, 0xC0,  //      ##   ##        //
		     0x11, 0x80,  //      #   ##         //
		     0x03, 0x80,  //         ###         //
		     0x03, 0x00,  //         ##          //
		     0x06, 0x00,  //        ##           //
		     0x0E, 0x20,  //       ###   #       //
		     0x0C, 0x20,  //       ##    #       //
		     0x18, 0x60,  //      ##    ##       //
		     0x3F, 0xE0,  //     #########       //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1856   [[]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x00,  //        ###          //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x07, 0x00,  //        ###          //

		     // @1888   [\]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x04, 0x00,  //        #            //
		     0x04, 0x00,  //        #            //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x01, 0x00,  //          #          //
		     0x01, 0x00,  //          #          //
		     0x01, 0x00,  //          #          //
		     0x00, 0x80,  //           #         //
		     0x00, 0x80,  //           #         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1920   []]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x00,  //        ###          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x07, 0x00,  //        ###          //

		     // @1952   [^]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x02, 0x00,  //         #           //
		     0x05, 0x00,  //        # #          //
		     0x08, 0x80,  //       #   #         //
		     0x08, 0x80,  //       #   #         //
		     0x10, 0x40,  //      #     #        //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @1984   [_]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1F, 0xE0,  //      ########       //

		     // @2016   [`]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x02, 0x00,  //         #           //
		     0x01, 0x00,  //          #          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2048   [a]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x0F, 0x00,  //       ####          //
		     0x19, 0x80,  //      ##  ##         //
		     0x03, 0x80,  //         ###         //
		     0x0D, 0x80,  //       ## ##         //
		     0x19, 0x80,  //      ##  ##         //
		     0x19, 0x80,  //      ##  ##         //
		     0x0F, 0xC0,  //       ######        //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2080   [b]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1C, 0x00,  //      ###            //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x00,  //       ##            //
		     0x0F, 0x80,  //       #####         //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0B, 0x80,  //       # ###         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2112   [c]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x80,  //        ####         //
		     0x0D, 0x80,  //       ## ##         //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x80,  //       ##  #         //
		     0x07, 0x00,  //        ###          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2144   [d]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x03, 0x80,  //         ###         //
		     0x01, 0x80,  //          ##         //
		     0x01, 0x80,  //          ##         //
		     0x0F, 0x80,  //       #####         //
		     0x19, 0x80,  //      ##  ##         //
		     0x19, 0x80,  //      ##  ##         //
		     0x19, 0x80,  //      ##  ##         //
		     0x19, 0x80,  //      ##  ##         //
		     0x19, 0x80,  //      ##  ##         //
		     0x0F, 0xC0,  //       ######        //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2176   [e]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x80,  //        ####         //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0F, 0xC0,  //       ######        //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x40,  //       ##   #        //
		     0x07, 0x80,  //        ####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2208   [f]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x03, 0xC0,  //         ####        //
		     0x06, 0xC0,  //        ## ##        //
		     0x06, 0x00,  //        ##           //
		     0x0F, 0x00,  //       ####          //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x0F, 0x00,  //       ####          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2240   [g]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x0F, 0xC0,  //       ######        //
		     0x19, 0x80,  //      ##  ##         //
		     0x19, 0x80,  //      ##  ##         //
		     0x19, 0x80,  //      ##  ##         //
		     0x0F, 0x00,  //       ####          //
		     0x10, 0x00,  //      #              //
		     0x1F, 0x80,  //      ######         //
		     0x1F, 0xC0,  //      #######        //
		     0x10, 0x40,  //      #     #        //
		     0x0F, 0x80,  //       #####         //

		     // @2272   [h]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1C, 0x00,  //      ###            //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x00,  //       ##            //
		     0x0D, 0x80,  //       ## ##         //
		     0x0E, 0xC0,  //       ### ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x1E, 0xE0,  //      #### ###       //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2304   [i]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x00, 0x00,  //                     //
		     0x07, 0x00,  //        ###          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x07, 0x80,  //        ####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2336   [j]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x01, 0x80,  //          ##         //
		     0x01, 0x80,  //          ##         //
		     0x00, 0x00,  //                     //
		     0x03, 0x80,  //         ###         //
		     0x01, 0x80,  //          ##         //
		     0x01, 0x80,  //          ##         //
		     0x01, 0x80,  //          ##         //
		     0x01, 0x80,  //          ##         //
		     0x01, 0x80,  //          ##         //
		     0x01, 0x80,  //          ##         //
		     0x01, 0x80,  //          ##         //
		     0x05, 0x80,  //        # ##         //
		     0x07, 0x00,  //        ###          //

		     // @2368   [k]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x38, 0x00,  //     ###             //
		     0x18, 0x00,  //      ##             //
		     0x18, 0x00,  //      ##             //
		     0x19, 0xC0,  //      ##  ###        //
		     0x19, 0x00,  //      ##  #          //
		     0x1A, 0x00,  //      ## #           //
		     0x1E, 0x00,  //      ####           //
		     0x1B, 0x00,  //      ## ##          //
		     0x19, 0x80,  //      ##  ##         //
		     0x3D, 0xE0,  //     #### ####       //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2400   [l]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x00,  //        ###          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x07, 0x80,  //        ####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2432   [m]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x76, 0xE0,  //    ### ## ###       //
		     0x3B, 0x30,  //     ### ##  ##      //
		     0x33, 0x30,  //     ##  ##  ##      //
		     0x33, 0x30,  //     ##  ##  ##      //
		     0x33, 0x30,  //     ##  ##  ##      //
		     0x33, 0x30,  //     ##  ##  ##      //
		     0x7B, 0xB8,  //    #### ### ###     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2464   [n]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1D, 0x80,  //      ### ##         //
		     0x0E, 0xC0,  //       ### ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x1E, 0xE0,  //      #### ###       //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2496   [o]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x80,  //        ####         //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x07, 0x80,  //        ####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2528   [p]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1F, 0x80,  //      ######         //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0F, 0x80,  //       #####         //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x00,  //       ##            //
		     0x1E, 0x00,  //      ####           //

		     // @2560   [q]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x0E, 0x80,  //       ### #         //
		     0x19, 0x80,  //      ##  ##         //
		     0x19, 0x80,  //      ##  ##         //
		     0x19, 0x80,  //      ##  ##         //
		     0x19, 0x80,  //      ##  ##         //
		     0x19, 0x80,  //      ##  ##         //
		     0x0F, 0x80,  //       #####         //
		     0x01, 0x80,  //          ##         //
		     0x01, 0x80,  //          ##         //
		     0x03, 0xC0,  //         ####        //

		     // @2592   [r]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x0E, 0xC0,  //       ### ##        //
		     0x07, 0x40,  //        ### #        //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x0F, 0x00,  //       ####          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2624   [s]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x80,  //        ####         //
		     0x0C, 0x80,  //       ##  #         //
		     0x0E, 0x00,  //       ###           //
		     0x07, 0x00,  //        ###          //
		     0x03, 0x80,  //         ###         //
		     0x09, 0x80,  //       #  ##         //
		     0x0F, 0x00,  //       ####          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2656   [t]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x02, 0x00,  //         #           //
		     0x06, 0x00,  //        ##           //
		     0x0F, 0x80,  //       #####         //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x00,  //        ##           //
		     0x06, 0x80,  //        ## #         //
		     0x03, 0x00,  //         ##          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2688   [u]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1D, 0xC0,  //      ### ###        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x07, 0xE0,  //        ######       //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2720   [v]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1E, 0xE0,  //      #### ###       //
		     0x0C, 0x40,  //       ##   #        //
		     0x06, 0x80,  //        ## #         //
		     0x06, 0x80,  //        ## #         //
		     0x07, 0x00,  //        ###          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2752   [w]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x3B, 0xB0,  //     ### ### ##      //
		     0x19, 0x20,  //      ##  #  #       //
		     0x1B, 0xA0,  //      ## ### #       //
		     0x1B, 0xA0,  //      ## ### #       //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2784   [x]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1E, 0xE0,  //      #### ###       //
		     0x06, 0x80,  //        ## #         //
		     0x07, 0x00,  //        ###          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x80,  //         ###         //
		     0x05, 0x80,  //        # ##         //
		     0x1D, 0xE0,  //      ### ####       //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2816   [y]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1D, 0xC0,  //      ### ###        //
		     0x0C, 0x80,  //       ##  #         //
		     0x0C, 0x80,  //       ##  #         //
		     0x07, 0x00,  //        ###          //
		     0x07, 0x00,  //        ###          //
		     0x03, 0x00,  //         ##          //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x1A, 0x00,  //      ## #           //
		     0x1C, 0x00,  //      ###            //

		     // @2848   [z]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x0F, 0xC0,  //       ######        //
		     0x09, 0x80,  //       #  ##         //
		     0x01, 0x80,  //          ##         //
		     0x03, 0x00,  //         ##          //
		     0x07, 0x00,  //        ###          //
		     0x06, 0x40,  //        ##  #        //
		     0x0F, 0xC0,  //       ######        //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @2880   [{]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x01, 0x80,  //          ##         //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x02, 0x00,  //         #           //
		     0x04, 0x00,  //        #            //
		     0x02, 0x00,  //         #           //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x01, 0x80,  //          ##         //

		     // @2912   [|]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //
		     0x02, 0x00,  //         #           //

		     // @2944   [}]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x06, 0x00,  //        ##           //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x01, 0x00,  //          #          //
		     0x00, 0x80,  //           #         //
		     0x01, 0x00,  //          #          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x06, 0x00,  //        ##           //

		     // @2976   [~]   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1C, 0x40,  //      ###   #        //
		     0x13, 0xC0,  //      #  ####        //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @3008   []   (14 px wide)
		     0x01, 0x00,  //          #          //
		     0x02, 0x00,  //         #           //
		     0x00, 0x00,  //                     //
		     0x07, 0x40,  //        ### #        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0x40,  //       ##   #        //
		     0x0E, 0x00,  //       ###           //
		     0x07, 0x00,  //        ###          //
		     0x03, 0x80,  //         ###         //
		     0x09, 0xC0,  //       #  ###        //
		     0x08, 0xC0,  //       #   ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0B, 0x80,  //       # ###         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @3040   []   (14 px wide)
		     0x01, 0x00,  //          #          //
		     0x02, 0x00,  //         #           //
		     0x00, 0x00,  //                     //
		     0x1F, 0xE0,  //      ########       //
		     0x18, 0xC0,  //      ##   ##        //
		     0x11, 0x80,  //      #   ##         //
		     0x03, 0x80,  //         ###         //
		     0x03, 0x00,  //         ##          //
		     0x06, 0x00,  //        ##           //
		     0x0E, 0x20,  //       ###   #       //
		     0x0C, 0x20,  //       ##    #       //
		     0x18, 0x60,  //      ##    ##       //
		     0x3F, 0xE0,  //     #########       //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @3072   []   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x01, 0x00,  //          #          //
		     0x02, 0x00,  //         #           //
		     0x00, 0x00,  //                     //
		     0x07, 0x80,  //        ####         //
		     0x0C, 0x80,  //       ##  #         //
		     0x0E, 0x00,  //       ###           //
		     0x07, 0x00,  //        ###          //
		     0x03, 0x80,  //         ###         //
		     0x09, 0x80,  //       #  ##         //
		     0x0F, 0x00,  //       ####          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @3104   []   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x01, 0x00,  //          #          //
		     0x02, 0x00,  //         #           //
		     0x00, 0x00,  //                     //
		     0x0F, 0xC0,  //       ######        //
		     0x09, 0x80,  //       #  ##         //
		     0x01, 0x80,  //          ##         //
		     0x03, 0x00,  //         ##          //
		     0x07, 0x00,  //        ###          //
		     0x06, 0x40,  //        ##  #        //
		     0x0F, 0xC0,  //       ######        //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @3136   []   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1F, 0x00,  //      #####          //
		     0x0C, 0x00,  //       ##            //
		     0x0D, 0x00,  //       ## #          //
		     0x0E, 0x00,  //       ###           //
		     0x0C, 0x00,  //       ##            //
		     0x1C, 0x00,  //      ###            //
		     0x0C, 0x20,  //       ##    #       //
		     0x0C, 0x20,  //       ##    #       //
		     0x0C, 0x60,  //       ##   ##       //
		     0x1F, 0xE0,  //      ########       //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @3168   []   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x02, 0x00,  //         #           //
		     0x06, 0x00,  //        ##           //
		     0x07, 0x00,  //        ###          //
		     0x0B, 0x00,  //       # ##          //
		     0x09, 0x80,  //       #  ##         //
		     0x09, 0x80,  //       #  ##         //
		     0x1F, 0xC0,  //      #######        //
		     0x10, 0xC0,  //      #    ##        //
		     0x20, 0x60,  //     #      ##       //
		     0x79, 0xF0,  //    ####  #####      //
		     0x00, 0x40,  //            #        //
		     0x00, 0x40,  //            #        //
		     0x00, 0x60,  //            ##       //

		     // @3200   []   (14 px wide)
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x00, 0x00,  //                     //
		     0x1F, 0xE0,  //      ########       //
		     0x18, 0xC0,  //      ##   ##        //
		     0x11, 0x80,  //      #   ##         //
		     0x03, 0x80,  //         ###         //
		     0x03, 0x00,  //         ##          //
		     0x06, 0x00,  //        ##           //
		     0x0E, 0x20,  //       ###   #       //
		     0x0C, 0x20,  //       ##    #       //
		     0x18, 0x60,  //      ##    ##       //
		     0x3F, 0xE0,  //     #########       //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @3232   []   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x00,  //        ###          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x80,  //         ###         //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x07, 0x00,  //        ###          //
		     0x03, 0x00,  //         ##          //
		     0x03, 0x00,  //         ##          //
		     0x07, 0x80,  //        ####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @3264   []   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x0F, 0x00,  //       ####          //
		     0x19, 0x80,  //      ##  ##         //
		     0x03, 0x80,  //         ###         //
		     0x0D, 0x80,  //       ## ##         //
		     0x19, 0x80,  //      ##  ##         //
		     0x19, 0x80,  //      ##  ##         //
		     0x0F, 0xC0,  //       ######        //
		     0x00, 0x80,  //           #         //
		     0x00, 0x80,  //           #         //
		     0x00, 0xC0,  //           ##        //

		     // @3296   []   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x01, 0x80,  //          ##         //
		     0x01, 0x80,  //          ##         //
		     0x00, 0x00,  //                     //
		     0x0F, 0xC0,  //       ######        //
		     0x09, 0x80,  //       #  ##         //
		     0x01, 0x80,  //          ##         //
		     0x03, 0x00,  //         ##          //
		     0x07, 0x00,  //        ###          //
		     0x06, 0x40,  //        ##  #        //
		     0x0F, 0xC0,  //       ######        //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @3328   []   (14 px wide)
		     0x01, 0x00,  //          #          //
		     0x02, 0x00,  //         #           //
		     0x00, 0x00,  //                     //
		     0x07, 0xA0,  //        #### #       //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x20,  //      ##     #       //
		     0x30, 0x00,  //     ##              //
		     0x30, 0x00,  //     ##              //
		     0x30, 0x00,  //     ##              //
		     0x30, 0x00,  //     ##              //
		     0x18, 0x20,  //      ##     #       //
		     0x18, 0x40,  //      ##    #        //
		     0x07, 0x80,  //        ####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @3360   []   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x1F, 0xE0,  //      ########       //
		     0x0C, 0x20,  //       ##    #       //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x80,  //       ##  #         //
		     0x0F, 0x80,  //       #####         //
		     0x0C, 0x80,  //       ##  #         //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x20,  //       ##    #       //
		     0x1F, 0xE0,  //      ########       //
		     0x00, 0x40,  //            #        //
		     0x00, 0x40,  //            #        //
		     0x00, 0x60,  //            ##       //

		     // @3392   []   (14 px wide)
		     0x01, 0x00,  //          #          //
		     0x02, 0x00,  //         #           //
		     0x00, 0x00,  //                     //
		     0x3C, 0xE0,  //     ####  ###       //
		     0x1C, 0x40,  //      ###   #        //
		     0x16, 0x40,  //      # ##  #        //
		     0x16, 0x40,  //      # ##  #        //
		     0x13, 0x40,  //      #  ## #        //
		     0x11, 0xC0,  //      #   ###        //
		     0x11, 0xC0,  //      #   ###        //
		     0x10, 0xC0,  //      #    ##        //
		     0x10, 0x40,  //      #     #        //
		     0x38, 0x40,  //     ###    #        //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @3424   []   (14 px wide)
		     0x01, 0x00,  //          #          //
		     0x02, 0x00,  //         #           //
		     0x00, 0x00,  //                     //
		     0x07, 0x80,  //        ####         //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x30, 0x30,  //     ##      ##      //
		     0x30, 0x30,  //     ##      ##      //
		     0x30, 0x30,  //     ##      ##      //
		     0x30, 0x30,  //     ##      ##      //
		     0x18, 0x60,  //      ##    ##       //
		     0x18, 0x60,  //      ##    ##       //
		     0x07, 0x80,  //        ####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @3456   []   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x01, 0x00,  //          #          //
		     0x02, 0x00,  //         #           //
		     0x00, 0x00,  //                     //
		     0x07, 0x80,  //        ####         //
		     0x0D, 0x80,  //       ## ##         //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x80,  //       ##  #         //
		     0x07, 0x00,  //        ###          //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @3488   []   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x07, 0x80,  //        ####         //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0F, 0xC0,  //       ######        //
		     0x0C, 0x00,  //       ##            //
		     0x0C, 0x40,  //       ##   #        //
		     0x07, 0x80,  //        ####         //
		     0x01, 0x00,  //          #          //
		     0x01, 0x00,  //          #          //
		     0x01, 0x80,  //          ##         //

		     // @3520   []   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x01, 0x00,  //          #          //
		     0x02, 0x00,  //         #           //
		     0x00, 0x00,  //                     //
		     0x1D, 0x80,  //      ### ##         //
		     0x0E, 0xC0,  //       ### ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x1E, 0xE0,  //      #### ###       //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //

		     // @3552   []   (14 px wide)
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x01, 0x00,  //          #          //
		     0x02, 0x00,  //         #           //
		     0x00, 0x00,  //                     //
		     0x07, 0x80,  //        ####         //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x0C, 0xC0,  //       ##  ##        //
		     0x07, 0x80,  //        ####         //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
		     0x00, 0x00,  //                     //
};
const uint16_t font4desc[]=
{
		    0 ,		// !  (33)
		    32 ,		// "  (34)
		    64 ,		// #  (35)
		    96 ,		// $  (36)
		    128 ,		// %  (37)
		    160 ,		// &  (38)
		    192 ,		// '  (39)
		    224 ,		// (  (40)
		    256 ,		// )  (41)
		    288 ,		// *  (42)
		    320 ,		// +  (43)
		    352 ,		// ,  (44)
		    384 ,		// -  (45)
		    416 ,		// .  (46)
		    448 ,		// /  (47)
		    480 ,		// 0  (48)
		    512 ,		// 1  (49)
		    544 ,		// 2  (50)
		    576 ,		// 3  (51)
		    608 ,		// 4  (52)
		    640 ,		// 5  (53)
		    672 ,		// 6  (54)
		    704 ,		// 7  (55)
		    736 ,		// 8  (56)
		    768 ,		// 9  (57)
		    800 ,		// :  (58)
		    832 ,		// ;  (59)
		    864 ,		// <  (60)
		    896 ,		// =  (61)
		    928 ,		// >  (62)
		    960 ,		// ?  (63)
		    992 ,		// @  (64)
		    1024 ,		// A  (65)
		    1056 ,		// B  (66)
		    1088 ,		// C  (67)
		    1120 ,		// D  (68)
		    1152 ,		// E  (69)
		    1184 ,		// F  (70)
		    1216 ,		// G  (71)
		    1248 ,		// H  (72)
		    1280 ,		// I  (73)
		    1312 ,		// J  (74)
		    1344 ,		// K  (75)
		    1376 ,		// L  (76)
		    1408 ,		// M  (77)
		    1440 ,		// N  (78)
		    1472 ,		// O  (79)
		    1504 ,		// P  (80)
		    1536 ,		// Q  (81)
		    1568 ,		// R  (82)
		    1600 ,		// S  (83)
		    1632 ,		// T  (84)
		    1664 ,		// U  (85)
		    1696 ,		// V  (86)
		    1728 ,		// W  (87)
		    1760 ,		// X  (88)
		    1792 ,		// Y  (89)
		    1824 ,		// Z  (90)
		    1856 ,		// [  (91)
		    1888 ,		// //  (92)
		    1920 ,		// ]  (93)
		    1952 ,		// ^  (94)
		    1984 ,		// _  (95)
		    2016 ,		// `  (96)
		    2048 ,		// a  (97)
		    2080 ,		// b  (98)
		    2112 ,		// c  (99)
		    2144 ,		// d  (100)
		    2176 ,		// e  (101)
		    2208 ,		// f  (102)
		    2240 ,		// g  (103)
		    2272 ,		// h  (104)
		    2304 ,		// i  (105)
		    2336 ,		// j  (106)
		    2368 ,		// k  (107)
		    2400 ,		// l  (108)
		    2432 ,		// m  (109)
		    2464 ,		// n  (110)
		    2496 ,		// o  (111)
		    2528 ,		// p  (112)
		    2560 ,		// q  (113)
		    2592 ,		// r  (114)
		    2624 ,		// s  (115)
		    2656 ,		// t  (116)
		    2688 ,		// u  (117)
		    2720 ,		// v  (118)
		    2752 ,		// w  (119)
		    2784 ,		// x  (120)
		    2816 ,		// y  (121)
		    2848 ,		// z  (122)
		    2880 ,		// {  (123)
		    2912 ,		// |  (124)
		    2944 ,		// }  (125)
		    2976 ,		// ~  (126)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    3008 ,		//   (140)
		    0 ,		//
		    0 ,		//
		    3040 ,		//   (143)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    3072 ,		//   (156)
		    0 ,		//
		    0 ,		//
		    3104 ,		//   (159)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    3136 ,		//   (163)
		    0 ,		//
		    3168 ,		//   (165)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    3200 ,		//   (175)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    3232 ,		//   (179)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    3264 ,		//   (185)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    3296 ,		//   (191)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    3328 ,		//   (198)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    3360 ,		//   (202)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    3392 ,		//   (209)
		    0 ,		//
		    3424 ,		//   (211)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    3456 ,		//   (230)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    3488 ,		//   (234)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    3520 ,		//   (241)
		    0 ,		//
		    3552		//   (243)
};


const uint8_t fontinfo4[]=
{
		16,  // Character height
		    '!',  //  Start character
		    0,  //  number of pixels of interspace between characters
		    14,  // number of pixels of space character


};


const uint8_t font6[]=
{

		  // @0   [!]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x04, 0x00,  //        #          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x00, 0x00,  //                   //
		     0x18, 0x00,  //      ##           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @26   ["]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x1B, 0x00,  //      ## ##        //
		     0x12, 0x00,  //      #  #         //
		     0x12, 0x00,  //      #  #         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @52   [#]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x04, 0x80,  //        #  #       //
		     0x04, 0x80,  //        #  #       //
		     0x1F, 0xC0,  //      #######      //
		     0x1F, 0xC0,  //      #######      //
		     0x12, 0x00,  //      #  #         //
		     0x7F, 0x00,  //    #######        //
		     0x7F, 0x00,  //    #######        //
		     0x2C, 0x00,  //     # ##          //
		     0x48, 0x00,  //    #  #           //
		     0x00, 0x00,  //                   //

		     // @78   [$]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x80,  //           #       //
		     0x00, 0x80,  //           #       //
		     0x07, 0x80,  //        ####       //
		     0x0D, 0x40,  //       ## # #      //
		     0x0D, 0x00,  //       ## #        //
		     0x0F, 0x00,  //       ####        //
		     0x07, 0x80,  //        ####       //
		     0x2B, 0x00,  //     # # ##        //
		     0x1E, 0x00,  //      ####         //
		     0x08, 0x00,  //       #           //
		     0x10, 0x00,  //      #            //

		     // @104   [%]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x78, 0x80,  //    ####   #       //
		     0xD9, 0x00,  //   ## ##  #        //
		     0xDA, 0x00,  //   ## ## #         //
		     0xF5, 0xE0,  //   #### # ####     //
		     0xEB, 0x60,  //   ### # ## ##     //
		     0x0B, 0x60,  //       # ## ##     //
		     0x13, 0xC0,  //      #  ####      //
		     0x23, 0x80,  //     #   ###       //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @130   [&]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x1E, 0x00,  //      ####         //
		     0x36, 0x00,  //     ## ##         //
		     0x36, 0x00,  //     ## ##         //
		     0x28, 0xC0,  //     # #   ##      //
		     0x6D, 0x80,  //    ## ## ##       //
		     0x66, 0x00,  //    ##  ##         //
		     0x66, 0x00,  //    ##  ##         //
		     0x7B, 0x00,  //    #### ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @156   [']   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @182   [(]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //

		     // @208   [)]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //

		     // @234   [*]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x0B, 0x80,  //       # ###       //
		     0x0F, 0x00,  //       ####        //
		     0x16, 0x80,  //      # ## #       //
		     0x06, 0x00,  //        ##         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @260   [+]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x02, 0x00,  //         #         //
		     0x02, 0x00,  //         #         //
		     0x02, 0x00,  //         #         //
		     0x3F, 0x80,  //     #######       //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x08, 0x00,  //       #           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @286   [,]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x04, 0x00,  //        #          //
		     0x08, 0x00,  //       #           //
		     0x08, 0x00,  //       #           //

		     // @312   [-]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0x00,  //       ####        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @338   [.]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @364   [/]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x40,  //            #      //
		     0x00, 0x80,  //           #       //
		     0x00, 0x80,  //           #       //
		     0x01, 0x00,  //          #        //
		     0x02, 0x00,  //         #         //
		     0x04, 0x00,  //        #          //
		     0x08, 0x00,  //       #           //
		     0x08, 0x00,  //       #           //
		     0x10, 0x00,  //      #            //
		     0x20, 0x00,  //     #             //
		     0x40, 0x00,  //    #              //

		     // @390   [0]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x00,  //        ###        //
		     0x0D, 0x80,  //       ## ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x36, 0x00,  //     ## ##         //
		     0x3C, 0x00,  //     ####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @416   [1]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x80,  //          ##       //
		     0x07, 0x00,  //        ###        //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x1E, 0x00,  //      ####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @442   [2]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x00, 0xC0,  //           ##      //
		     0x01, 0x00,  //          #        //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x3F, 0x00,  //     ######        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @468   [3]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x08, 0xC0,  //       #   ##      //
		     0x00, 0xC0,  //           ##      //
		     0x03, 0x00,  //         ##        //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x13, 0x00,  //      #  ##        //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @494   [4]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x00,  //         ##        //
		     0x07, 0x00,  //        ###        //
		     0x0B, 0x00,  //       # ##        //
		     0x16, 0x00,  //      # ##         //
		     0x3F, 0x00,  //     ######        //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @520   [5]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0F, 0x00,  //       ####        //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x7C, 0x00,  //    #####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @546   [6]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x1F, 0x00,  //      #####        //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x36, 0x00,  //     ## ##         //
		     0x3C, 0x00,  //     ####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @572   [7]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @598   [8]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1E, 0x00,  //      ####         //
		     0x1B, 0x00,  //      ## ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x36, 0x00,  //     ## ##         //
		     0x3C, 0x00,  //     ####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @624   [9]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x00,  //        ###        //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1F, 0x00,  //      #####        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x3C, 0x00,  //     ####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @650   [:]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @676   [;]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x04, 0x00,  //        #          //
		     0x08, 0x00,  //       #           //
		     0x08, 0x00,  //       #           //

		     // @702   [<]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0xC0,  //           ##      //
		     0x03, 0x00,  //         ##        //
		     0x1C, 0x00,  //      ###          //
		     0x20, 0x00,  //     #             //
		     0x18, 0x00,  //      ##           //
		     0x06, 0x00,  //        ##         //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @728   [=]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x1F, 0xC0,  //      #######      //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x3F, 0x80,  //     #######       //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @754   [>]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0C, 0x00,  //       ##          //
		     0x07, 0x00,  //        ###        //
		     0x01, 0xC0,  //          ###      //
		     0x00, 0x40,  //            #      //
		     0x01, 0x80,  //          ##       //
		     0x0E, 0x00,  //       ###         //
		     0x30, 0x00,  //     ##            //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @780   [?]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x09, 0x80,  //       #  ##       //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x00,  //         ##        //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x00, 0x00,  //                   //
		     0x18, 0x00,  //      ##           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @806   [@]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x18, 0x40,  //      ##    #      //
		     0x27, 0xA0,  //     #  #### #     //
		     0x4D, 0xA0,  //    #  ## ## #     //
		     0x5B, 0x20,  //    # ## ##  #     //
		     0x5B, 0x40,  //    # ## ## #      //
		     0x5F, 0x80,  //    # ######       //
		     0x60, 0x00,  //    ##             //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //

		     // @832   [A]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x80,  //          ##       //
		     0x03, 0xC0,  //         ####      //
		     0x07, 0xC0,  //        #####      //
		     0x07, 0xC0,  //        #####      //
		     0x0D, 0xC0,  //       ## ###      //
		     0x1F, 0xC0,  //      #######      //
		     0x39, 0xC0,  //     ###  ###      //
		     0x31, 0xC0,  //     ##   ###      //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @858   [B]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0F, 0x80,  //       #####       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1B, 0x00,  //      ## ##        //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @884   [C]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x1C, 0x00,  //      ###          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //
		     0x30, 0x00,  //     ##            //
		     0x30, 0x00,  //     ##            //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @910   [D]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x19, 0x80,  //      ##  ##       //
		     0x18, 0xC0,  //      ##   ##      //
		     0x18, 0xC0,  //      ##   ##      //
		     0x31, 0x80,  //     ##   ##       //
		     0x31, 0x80,  //     ##   ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x7C, 0x00,  //    #####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @936   [E]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0F, 0x80,  //       #####       //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @962   [F]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0F, 0x80,  //       #####       //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @988   [G]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0xC0,  //       ######      //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //
		     0x30, 0x00,  //     ##            //
		     0x67, 0x00,  //    ##  ###        //
		     0x63, 0x00,  //    ##   ##        //
		     0x63, 0x00,  //    ##   ##        //
		     0x7E, 0x00,  //    ######         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1014   [H]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0C, 0x60,  //       ##   ##     //
		     0x18, 0xC0,  //      ##   ##      //
		     0x18, 0xC0,  //      ##   ##      //
		     0x1F, 0xC0,  //      #######      //
		     0x31, 0x80,  //     ##   ##       //
		     0x31, 0x80,  //     ##   ##       //
		     0x31, 0x80,  //     ##   ##       //
		     0x63, 0x00,  //    ##   ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1040   [I]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x3C, 0x00,  //     ####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1066   [J]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0xC0,  //         ####      //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x3C, 0x00,  //     ####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1092   [K]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0xC0,  //        ## ##      //
		     0x0D, 0x80,  //       ## ##       //
		     0x0F, 0x00,  //       ####        //
		     0x0C, 0x00,  //       ##          //
		     0x1C, 0x00,  //      ###          //
		     0x1E, 0x00,  //      ####         //
		     0x1E, 0x00,  //      ####         //
		     0x33, 0x00,  //     ##  ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1118   [L]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x1F, 0x00,  //      #####        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1144   [M]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x18, 0x70,  //      ##    ###    //
		     0x38, 0xE0,  //     ###   ###     //
		     0x39, 0xE0,  //     ###  ####     //
		     0x3F, 0x60,  //     ###### ##     //
		     0x4E, 0xC0,  //    #  ### ##      //
		     0x40, 0xC0,  //    #      ##      //
		     0x40, 0xC0,  //    #      ##      //
		     0x81, 0x80,  //   #      ##       //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1170   [N]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0C, 0x40,  //       ##   #      //
		     0x1C, 0x80,  //      ###  #       //
		     0x1E, 0x80,  //      #### #       //
		     0x1E, 0x80,  //      #### #       //
		     0x27, 0x00,  //     #  ###        //
		     0x23, 0x00,  //     #   ##        //
		     0x23, 0x00,  //     #   ##        //
		     0x40, 0x00,  //    #              //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1196   [O]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x18, 0xC0,  //      ##   ##      //
		     0x18, 0xC0,  //      ##   ##      //
		     0x31, 0x80,  //     ##   ##       //
		     0x31, 0x80,  //     ##   ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1222   [P]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0D, 0x80,  //       ## ##       //
		     0x1F, 0x00,  //      #####        //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1248   [Q]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x18, 0xC0,  //      ##   ##      //
		     0x18, 0xC0,  //      ##   ##      //
		     0x31, 0x80,  //     ##   ##       //
		     0x31, 0x80,  //     ##   ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x3E, 0x00,  //     #####         //
		     0x0C, 0x00,  //       ##          //
		     0x0E, 0x00,  //       ###         //

		     // @1274   [R]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0D, 0x80,  //       ## ##       //
		     0x1F, 0x00,  //      #####        //
		     0x1B, 0x00,  //      ## ##        //
		     0x1B, 0x00,  //      ## ##        //
		     0x31, 0x80,  //     ##   ##       //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1300   [S]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x1E, 0x00,  //      ####         //
		     0x0F, 0x00,  //       ####        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x7C, 0x00,  //    #####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1326   [T]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x1F, 0x80,  //      ######       //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1352   [U]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x18, 0xC0,  //      ##   ##      //
		     0x31, 0x80,  //     ##   ##       //
		     0x31, 0x80,  //     ##   ##       //
		     0x31, 0x80,  //     ##   ##       //
		     0x63, 0x00,  //    ##   ##        //
		     0x63, 0x00,  //    ##   ##        //
		     0x66, 0x00,  //    ##  ##         //
		     0x7C, 0x00,  //    #####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1378   [V]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x31, 0x80,  //     ##   ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x36, 0x00,  //     ## ##         //
		     0x3C, 0x00,  //     ####          //
		     0x3C, 0x00,  //     ####          //
		     0x38, 0x00,  //     ###           //
		     0x30, 0x00,  //     ##            //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1404   [W]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0xC6, 0x60,  //   ##   ##  ##     //
		     0xCC, 0xC0,  //   ##  ##  ##      //
		     0xCD, 0xC0,  //   ##  ## ###      //
		     0xD5, 0x80,  //   ## # # ##       //
		     0xDF, 0x00,  //   ## #####        //
		     0xEF, 0x00,  //   ### ####        //
		     0xEE, 0x00,  //   ### ###         //
		     0xCC, 0x00,  //   ##  ##          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1430   [X]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x18, 0xC0,  //      ##   ##      //
		     0x1D, 0x80,  //      ### ##       //
		     0x0F, 0x00,  //       ####        //
		     0x0E, 0x00,  //       ###         //
		     0x0E, 0x00,  //       ###         //
		     0x1E, 0x00,  //      ####         //
		     0x36, 0x00,  //     ## ##         //
		     0x63, 0x00,  //    ##   ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1456   [Y]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x39, 0x80,  //     ###  ##       //
		     0x3B, 0x00,  //     ### ##        //
		     0x1E, 0x00,  //      ####         //
		     0x1C, 0x00,  //      ###          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1482   [Z]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0xC0,  //       ######      //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x80,  //         ###       //
		     0x0F, 0x00,  //       ####        //
		     0x1C, 0x00,  //      ###          //
		     0x38, 0x00,  //     ###           //
		     0x30, 0x00,  //     ##            //
		     0x7E, 0x00,  //    ######         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1508   [[]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0xC0,  //         ####      //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x3C, 0x00,  //     ####          //

		     // @1534   [\]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //
		     0x02, 0x00,  //         #         //
		     0x02, 0x00,  //         #         //

		     // @1560   []]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0xC0,  //         ####      //
		     0x00, 0xC0,  //           ##      //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x3C, 0x00,  //     ####          //

		     // @1586   [^]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x05, 0x00,  //        # #        //
		     0x08, 0x80,  //       #   #       //
		     0x10, 0x80,  //      #    #       //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1612   [_]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x3F, 0x80,  //     #######       //

		     // @1638   [`]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x02, 0x00,  //         #         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1664   [a]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x01, 0x80,  //          ##       //
		     0x0F, 0x80,  //       #####       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1B, 0x80,  //      ## ###       //
		     0x1F, 0x00,  //      #####        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1690   [b]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0F, 0x80,  //       #####       //
		     0x0D, 0x80,  //       ## ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1B, 0x00,  //      ## ##        //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1716   [c]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x0C, 0x80,  //       ##  #       //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x19, 0x00,  //      ##  #        //
		     0x1E, 0x00,  //      ####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1742   [d]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0xC0,  //           ##      //
		     0x00, 0xC0,  //           ##      //
		     0x01, 0x80,  //          ##       //
		     0x0F, 0x80,  //       #####       //
		     0x19, 0x80,  //      ##  ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1768   [e]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x0D, 0x80,  //       ## ##       //
		     0x1F, 0x80,  //      ######       //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x1F, 0x00,  //      #####        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1794   [f]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x80,  //         ###       //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0E, 0x00,  //       ###         //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1820   [g]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1F, 0x00,  //      #####        //
		     0x03, 0x00,  //         ##        //
		     0x3C, 0x00,  //     ####          //

		     // @1846   [h]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0F, 0x80,  //       #####       //
		     0x0D, 0x80,  //       ## ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1872   [i]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1898   [j]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x80,  //          ##       //
		     0x00, 0x00,  //                   //
		     0x07, 0x00,  //        ###        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x38, 0x00,  //     ###           //

		     // @1924   [k]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0D, 0x80,  //       ## ##       //
		     0x0F, 0x00,  //       ####        //
		     0x1E, 0x00,  //      ####         //
		     0x1E, 0x00,  //      ####         //
		     0x1E, 0x00,  //      ####         //
		     0x33, 0x00,  //     ##  ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1950   [l]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @1976   [m]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x3E, 0xE0,  //     ##### ###     //
		     0x37, 0x60,  //     ## ### ##     //
		     0x66, 0x60,  //    ##  ##  ##     //
		     0x66, 0x60,  //    ##  ##  ##     //
		     0x66, 0x60,  //    ##  ##  ##     //
		     0xCC, 0xC0,  //   ##  ##  ##      //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2002   [n]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x0D, 0x80,  //       ## ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2028   [o]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x0D, 0x80,  //       ## ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1B, 0x00,  //      ## ##        //
		     0x1E, 0x00,  //      ####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2054   [p]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x06, 0xC0,  //        ## ##      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0D, 0x80,  //       ## ##       //
		     0x1F, 0x00,  //      #####        //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //

		     // @2080   [q]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x19, 0x80,  //      ##  ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x3E, 0x00,  //     #####         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //

		     // @2106   [r]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x80,  //        ## #       //
		     0x07, 0x80,  //        ####       //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2132   [s]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x0C, 0x00,  //       ##          //
		     0x1E, 0x00,  //      ####         //
		     0x0F, 0x00,  //       ####        //
		     0x06, 0x00,  //        ##         //
		     0x3C, 0x00,  //     ####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2158   [t]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0F, 0x00,  //       ####        //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x1C, 0x00,  //      ###          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2184   [u]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x33, 0x00,  //     ##  ##        //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2210   [v]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x19, 0x80,  //      ##  ##       //
		     0x1B, 0x00,  //      ## ##        //
		     0x1E, 0x00,  //      ####         //
		     0x1E, 0x00,  //      ####         //
		     0x1C, 0x00,  //      ###          //
		     0x18, 0x00,  //      ##           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2236   [w]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x36, 0xC0,  //     ## ## ##      //
		     0x3F, 0x80,  //     #######       //
		     0x2D, 0x80,  //     # ## ##       //
		     0x7D, 0x00,  //    ##### #        //
		     0x77, 0x00,  //    ### ###        //
		     0x66, 0x00,  //    ##  ##         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2262   [x]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0D, 0x80,  //       ## ##       //
		     0x0F, 0x00,  //       ####        //
		     0x0F, 0x00,  //       ####        //
		     0x1B, 0x00,  //      ## ##        //
		     0x31, 0x80,  //     ##   ##       //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2288   [y]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x0D, 0x80,  //       ## ##       //
		     0x0D, 0x00,  //       ## #        //
		     0x0F, 0x00,  //       ####        //
		     0x0E, 0x00,  //       ###         //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //

		     // @2314   [z]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2340   [{]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0xC0,  //          ###      //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x38, 0x00,  //     ###           //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x1C, 0x00,  //      ###          //

		     // @2366   [|]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //

		     // @2392   [}]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x80,  //         ###       //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x01, 0x80,  //          ##       //
		     0x01, 0xC0,  //          ###      //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x00,  //        ##         //
		     0x3C, 0x00,  //     ####          //

		     // @2418   [~]   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x38, 0xC0,  //     ###   ##      //
		     0x4C, 0x80,  //    #  ##  #       //
		     0x47, 0x00,  //    #   ###        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2444   []   (12 px wide)
		     0x01, 0x80,  //          ##       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x1E, 0x00,  //      ####         //
		     0x0F, 0x00,  //       ####        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x7C, 0x00,  //    #####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2470   []   (12 px wide)
		     0x01, 0x80,  //          ##       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x0F, 0xC0,  //       ######      //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x80,  //         ###       //
		     0x0F, 0x00,  //       ####        //
		     0x1C, 0x00,  //      ###          //
		     0x38, 0x00,  //     ###           //
		     0x30, 0x00,  //     ##            //
		     0x7E, 0x00,  //    ######         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2496   []   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x80,  //           #       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x0C, 0x00,  //       ##          //
		     0x1E, 0x00,  //      ####         //
		     0x0F, 0x00,  //       ####        //
		     0x06, 0x00,  //        ##         //
		     0x3C, 0x00,  //     ####          //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2522   []   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x00,  //          #        //
		     0x02, 0x00,  //         #         //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2548   []   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x06, 0x80,  //        ## #       //
		     0x07, 0x00,  //        ###        //
		     0x0C, 0x00,  //       ##          //
		     0x1C, 0x00,  //      ###          //
		     0x0C, 0x00,  //       ##          //
		     0x1E, 0x00,  //      ####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2574   []   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x80,  //          ##       //
		     0x03, 0xC0,  //         ####      //
		     0x07, 0xC0,  //        #####      //
		     0x07, 0xC0,  //        #####      //
		     0x0D, 0xC0,  //       ## ###      //
		     0x1F, 0xC0,  //      #######      //
		     0x39, 0xC0,  //     ###  ###      //
		     0x31, 0xC0,  //     ##   ###      //
		     0x01, 0x00,  //          #        //
		     0x01, 0x00,  //          #        //

		     // @2600   []   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x00, 0x00,  //                   //
		     0x0F, 0xC0,  //       ######      //
		     0x01, 0x80,  //          ##       //
		     0x03, 0x80,  //         ###       //
		     0x0F, 0x00,  //       ####        //
		     0x1C, 0x00,  //      ###          //
		     0x38, 0x00,  //     ###           //
		     0x30, 0x00,  //     ##            //
		     0x7E, 0x00,  //    ######         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2626   []   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x03, 0x00,  //         ##        //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x07, 0x00,  //        ###        //
		     0x0E, 0x00,  //       ###         //
		     0x1C, 0x00,  //      ###          //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2652   []   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x01, 0x80,  //          ##       //
		     0x0F, 0x80,  //       #####       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1B, 0x80,  //      ## ###       //
		     0x1F, 0x00,  //      #####        //
		     0x02, 0x00,  //         #         //
		     0x02, 0x00,  //         #         //

		     // @2678   []   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x01, 0x80,  //          ##       //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x03, 0x00,  //         ##        //
		     0x06, 0x00,  //        ##         //
		     0x0C, 0x00,  //       ##          //
		     0x18, 0x00,  //      ##           //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2704   []   (12 px wide)
		     0x01, 0x80,  //          ##       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x1C, 0x00,  //      ###          //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x30, 0x00,  //     ##            //
		     0x30, 0x00,  //     ##            //
		     0x30, 0x00,  //     ##            //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2730   []   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0x00,  //       ##          //
		     0x0C, 0x00,  //       ##          //
		     0x0F, 0x80,  //       #####       //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x3E, 0x00,  //     #####         //
		     0x04, 0x00,  //        #          //
		     0x04, 0x00,  //        #          //

		     // @2756   []   (12 px wide)
		     0x01, 0x80,  //          ##       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x0C, 0x40,  //       ##   #      //
		     0x1C, 0x80,  //      ###  #       //
		     0x1E, 0x80,  //      #### #       //
		     0x1E, 0x80,  //      #### #       //
		     0x27, 0x00,  //     #  ###        //
		     0x23, 0x00,  //     #   ##        //
		     0x23, 0x00,  //     #   ##        //
		     0x40, 0x00,  //    #              //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2782   []   (12 px wide)
		     0x01, 0x80,  //          ##       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x07, 0xC0,  //        #####      //
		     0x0C, 0xC0,  //       ##  ##      //
		     0x18, 0xC0,  //      ##   ##      //
		     0x18, 0xC0,  //      ##   ##      //
		     0x31, 0x80,  //     ##   ##       //
		     0x31, 0x80,  //     ##   ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x3E, 0x00,  //     #####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2808   []   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x80,  //           #       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x0C, 0x80,  //       ##  #       //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x19, 0x00,  //      ##  #        //
		     0x1E, 0x00,  //      ####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2834   []   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x0D, 0x80,  //       ## ##       //
		     0x1F, 0x80,  //      ######       //
		     0x18, 0x00,  //      ##           //
		     0x18, 0x00,  //      ##           //
		     0x0F, 0x00,  //       ####        //
		     0x02, 0x00,  //         #         //
		     0x02, 0x00,  //         #         //

		     // @2860   []   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x80,  //           #       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x0F, 0x80,  //       #####       //
		     0x0D, 0x80,  //       ## ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x33, 0x00,  //     ##  ##        //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

		     // @2886   []   (12 px wide)
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //
		     0x00, 0x80,  //           #       //
		     0x01, 0x00,  //          #        //
		     0x00, 0x00,  //                   //
		     0x07, 0x80,  //        ####       //
		     0x0D, 0x80,  //       ## ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x19, 0x80,  //      ##  ##       //
		     0x1B, 0x00,  //      ## ##        //
		     0x1E, 0x00,  //      ####         //
		     0x00, 0x00,  //                   //
		     0x00, 0x00,  //                   //

};


const uint16_t font6desc[]=
{

		0 ,		// !  (33)
		    26 ,		// "  (34)
		    52 ,		// #  (35)
		    78 ,		// $  (36)
		    104 ,		// %  (37)
		    130 ,		// &  (38)
		    156 ,		// '  (39)
		    182 ,		// (  (40)
		    208 ,		// )  (41)
		    234 ,		// *  (42)
		   260 ,		// +  (43)
		    286 ,		// ,  (44)
		    312 ,		// -  (45)
		    338 ,		// .  (46)
		    364 ,		// /  (47)
		    390 ,		// 0  (48)
		    416 ,		// 1  (49)
		    442 ,		// 2  (50)
		    468 ,		// 3  (51)
		   494 ,		// 4  (52)
		    520 ,		// 5  (53)
		    546 ,		// 6  (54)
		   572 ,		// 7  (55)
		   598 ,		// 8  (56)
		    624 ,		// 9  (57)
		    650 ,		// :  (58)
		    676 ,		// ;  (59)
		    702 ,		// <  (60)
		    728 ,		// =  (61)
		    754 ,		// >  (62)
		    780 ,		// ?  (63)
		    806 ,		// @  (64)
		    832 ,		// A  (65)
		    858 ,		// B  (66)
		    884 ,		// C  (67)
		    910 ,		// D  (68)
		    936 ,		// E  (69)
		    962 ,		// F  (70)
		    988 ,		// G  (71)
		    1014 ,		// H  (72)
		    1040 ,		// I  (73)
		    1066 ,		// J  (74)
		    1092 ,		// K  (75)
		    1118 ,		// L  (76)
		    1144 ,		// M  (77)
		    1170 ,		// N  (78)
		    1196 ,		// O  (79)
		    1222 ,		// P  (80)
		    1248 ,		// Q  (81)
		    1274 ,		// R  (82)
		    1300 ,		// S  (83)
		    1326 ,		// T  (84)
		    1352 ,		// U  (85)
		    1378 ,		// V  (86)
		    1404 ,		// W  (87)
		    1430 ,		// X  (88)
		    1456 ,		// Y  (89)
		    1482 ,		// Z  (90)
		    1508 ,		// [  (91)
		    1534 ,		// //  (92)
		    1560 ,		// ]  (93)
		    1586 ,		// ^  (94)
		    1612 ,		// _  (95)
		    1638 ,		// `  (96)
		    1664 ,		// a  (97)
		    1690 ,		// b  (98)
		    1716 ,		// c  (99)
		    1742 ,		// d  (100)
		    1768 ,		// e  (101)
		    1794 ,		// f  (102)
		    1820 ,		// g  (103)
		    1846 ,		// h  (104)
		    1872 ,		// i  (105)
		    1898 ,		// j  (106)
		    1924 ,		// k  (107)
		    1950 ,		// l  (108)
		    1976 ,		// m  (109)
		    2002 ,		// n  (110)
		    2028 ,		// o  (111)
		    2054 ,		// p  (112)
		    2080 ,		// q  (113)
		    2106 ,		// r  (114)
		    2132 ,		// s  (115)
		    2158 ,		// t  (116)
		    2184 ,		// u  (117)
		    2210 ,		// v  (118)
		    2236 ,		// w  (119)
		    2262 ,		// x  (120)
		    2288 ,		// y  (121)
		    2314 ,		// z  (122)
		    2340 ,		// {  (123)
		    2366 ,		// |  (124)
		    2392 ,		// }  (125)
		    2418 ,		// ~  (126)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2444 ,		//   (140)
		    0 ,		//
		    0 ,		//
		    2470 ,		//   (143)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2496 ,		//   (156)
		    0 ,		//
		    0 ,		//
		    2522 ,		//   (159)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2548 ,		//   (163)
		    0 ,		//
		    2574 ,		//   (165)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2600 ,	//   (175)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2626 ,		//   (179)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2652 ,		//   (185)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2678 ,		//   (191)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2704 ,		//   (198)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2730 ,		//   (202)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2756 ,		//   (209)
		    0 ,		//
		    2782 ,		//   (211)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2808 ,		//   (230)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2834 ,		//   (234)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    2860 ,		//   (241)
		    0 ,		//
		    2886 		//   (243)
};

const uint8_t fontinfo6[]=
{
		 13,  // Character height
		    '!',  //  Start character
		    0,  //  number of pixels of interspace between characters
		    12,  // number of pixels of space character
};


const uint8_t font7[]=     //Gabriola 24 bold
{
		 // @0   [A]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x07, 0x80, 0x00,  //                ####                 //
		     0x00, 0x07, 0x80, 0x00,  //                ####                 //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x0D, 0xC0, 0x00,  //               ## ###                //
		     0x00, 0x19, 0xC0, 0x00,  //              ##  ###                //
		     0x00, 0x19, 0xC0, 0x00,  //              ##  ###                //
		     0x00, 0x39, 0xC0, 0x00,  //             ###  ###                //
		     0x00, 0x31, 0xC0, 0x00,  //             ##   ###                //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x7F, 0xE0, 0x00,  //            ##########               //
		     0x00, 0x60, 0xE0, 0x00,  //            ##     ###               //
		     0x00, 0xE0, 0xE0, 0x00,  //           ###     ###               //
		     0x00, 0xC0, 0x70, 0x00,  //           ##       ###              //
		     0x01, 0xC0, 0x70, 0x00,  //          ###       ###              //
		     0x01, 0x80, 0x70, 0x00,  //          ##        ###              //
		     0x03, 0x80, 0x38, 0x00,  //         ###         ###             //
		     0x03, 0x80, 0x3E, 0x00,  //         ###         #####           //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @124   [B]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0xFF, 0xC0, 0x00,  //           ##########                //
		     0x00, 0x38, 0xF0, 0x00,  //             ###   ####              //
		     0x00, 0x38, 0x70, 0x00,  //             ###    ###              //
		     0x00, 0x38, 0x70, 0x00,  //             ###    ###              //
		     0x00, 0x38, 0x70, 0x00,  //             ###    ###              //
		     0x00, 0x38, 0x70, 0x00,  //             ###    ###              //
		     0x00, 0x38, 0xE0, 0x00,  //             ###   ###               //
		     0x00, 0x39, 0xC0, 0x00,  //             ###  ###                //
		     0x00, 0x3F, 0x80, 0x00,  //             #######                 //
		     0x00, 0x38, 0xF0, 0x00,  //             ###   ####              //
		     0x00, 0x38, 0x78, 0x00,  //             ###    ####             //
		     0x00, 0x38, 0x38, 0x00,  //             ###     ###             //
		     0x00, 0x38, 0x38, 0x00,  //             ###     ###             //
		     0x00, 0x38, 0x38, 0x00,  //             ###     ###             //
		     0x00, 0x38, 0x38, 0x00,  //             ###     ###             //
		     0x00, 0x30, 0x78, 0x00,  //             ##     ####             //
		     0x00, 0x70, 0xF0, 0x00,  //            ###    ####              //
		     0x00, 0x7F, 0xC0, 0x00,  //            #########                //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @248   [C]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x07, 0xF0, 0x00,  //                #######              //
		     0x00, 0x1C, 0x3C, 0x00,  //              ###    ####            //
		     0x00, 0x38, 0x1C, 0x00,  //             ###      ###            //
		     0x00, 0x70, 0x0C, 0x00,  //            ###        ##            //
		     0x00, 0xE0, 0x0C, 0x00,  //           ###         ##            //
		     0x00, 0xE0, 0x00, 0x00,  //           ###                       //
		     0x01, 0xE0, 0x00, 0x00,  //          ####                       //
		     0x01, 0xC0, 0x00, 0x00,  //          ###                        //
		     0x01, 0xC0, 0x00, 0x00,  //          ###                        //
		     0x01, 0xC0, 0x00, 0x00,  //          ###                        //
		     0x01, 0xC0, 0x00, 0x00,  //          ###                        //
		     0x01, 0xE0, 0x00, 0x00,  //          ####                       //
		     0x01, 0xE0, 0x00, 0x00,  //          ####                       //
		     0x00, 0xE0, 0x00, 0x00,  //           ###                       //
		     0x00, 0xF0, 0x00, 0x00,  //           ####                      //
		     0x00, 0x78, 0x18, 0x00,  //            ####      ##             //
		     0x00, 0x3C, 0x70, 0x00,  //             ####   ###              //
		     0x00, 0x0F, 0xC0, 0x00,  //               ######                //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @372   [D]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x01, 0xFF, 0xC0, 0x00,  //          ###########                //
		     0x00, 0x70, 0xF8, 0x00,  //            ###    #####             //
		     0x00, 0x70, 0x3C, 0x00,  //            ###      ####            //
		     0x00, 0x70, 0x1C, 0x00,  //            ###       ###            //
		     0x00, 0x70, 0x1E, 0x00,  //            ###       ####           //
		     0x00, 0x70, 0x0E, 0x00,  //            ###        ###           //
		     0x00, 0x70, 0x0E, 0x00,  //            ###        ###           //
		     0x00, 0x70, 0x0E, 0x00,  //            ###        ###           //
		     0x00, 0x70, 0x0E, 0x00,  //            ###        ###           //
		     0x00, 0x70, 0x0E, 0x00,  //            ###        ###           //
		     0x00, 0x70, 0x0E, 0x00,  //            ###        ###           //
		     0x00, 0x70, 0x0E, 0x00,  //            ###        ###           //
		     0x00, 0x70, 0x0C, 0x00,  //            ###        ##            //
		     0x00, 0x70, 0x1C, 0x00,  //            ###       ###            //
		     0x00, 0x70, 0x18, 0x00,  //            ###       ##             //
		     0x00, 0x60, 0x30, 0x00,  //            ##       ##              //
		     0x00, 0xE0, 0xE0, 0x00,  //           ###     ###               //
		     0x00, 0xFF, 0x80, 0x00,  //           #########                 //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @496   [E]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0xFF, 0xF0, 0x00,  //           ############              //
		     0x00, 0x38, 0x30, 0x00,  //             ###     ##              //
		     0x00, 0x38, 0x30, 0x00,  //             ###     ##              //
		     0x00, 0x38, 0x30, 0x00,  //             ###     ##              //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x3F, 0xE0, 0x00,  //             #########               //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x30, 0x18, 0x00,  //             ##       ##             //
		     0x00, 0x30, 0x18, 0x00,  //             ##       ##             //
		     0x00, 0x7F, 0xF8, 0x00,  //            ############             //
		     0x00, 0x71, 0xF0, 0x00,  //            ###   #####              //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @620   [F]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x7F, 0xF8, 0x00,  //            ############             //
		     0x00, 0x1C, 0x18, 0x00,  //              ###     ##             //
		     0x00, 0x1C, 0x18, 0x00,  //              ###     ##             //
		     0x00, 0x1C, 0x18, 0x00,  //              ###     ##             //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1F, 0xF0, 0x00,  //              #########              //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @744   [G]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x07, 0xF0, 0x00,  //                #######              //
		     0x00, 0x1C, 0x3C, 0x00,  //              ###    ####            //
		     0x00, 0x38, 0x1C, 0x00,  //             ###      ###            //
		     0x00, 0x70, 0x0C, 0x00,  //            ###        ##            //
		     0x00, 0xE0, 0x0C, 0x00,  //           ###         ##            //
		     0x00, 0xE0, 0x00, 0x00,  //           ###                       //
		     0x00, 0xE0, 0x00, 0x00,  //           ###                       //
		     0x01, 0xC0, 0x00, 0x00,  //          ###                        //
		     0x01, 0xC0, 0x00, 0x00,  //          ###                        //
		     0x01, 0xC0, 0x00, 0x00,  //          ###                        //
		     0x01, 0xC0, 0x00, 0x00,  //          ###                        //
		     0x01, 0xC0, 0xFC, 0x00,  //          ###      ######            //
		     0x01, 0xE0, 0x3C, 0x00,  //          ####       ####            //
		     0x00, 0xE0, 0x1C, 0x00,  //           ###        ###            //
		     0x00, 0xF0, 0x1C, 0x00,  //           ####       ###            //
		     0x00, 0x78, 0x38, 0x00,  //            ####     ###             //
		     0x00, 0x3C, 0x38, 0x00,  //             ####    ###             //
		     0x00, 0x0F, 0xF0, 0x00,  //               ########              //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @868   [H]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x07, 0xE0, 0x1C, 0x00,  //        ######        ###            //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xFF, 0xF8, 0x00,  //           #############             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xE0, 0x1F, 0x00,  //           ###        #####          //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @992   [I]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x0F, 0xC0, 0x00,  //               ######                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @1116   [J]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x03, 0xF0, 0x00,  //                 ######              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x31, 0xC0, 0x00,  //             ##   ###                //
		     0x00, 0x79, 0x80, 0x00,  //            ####  ##                 //
		     0x00, 0x3F, 0x00, 0x00,  //             ######                  //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @1240   [K]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x01, 0xF8, 0x1E, 0x00,  //          ######      ####           //
		     0x00, 0x38, 0x3E, 0x00,  //             ###     #####           //
		     0x00, 0x38, 0x76, 0x00,  //             ###    ### ##           //
		     0x00, 0x38, 0xC0, 0x00,  //             ###   ##                //
		     0x00, 0x39, 0x80, 0x00,  //             ###  ##                 //
		     0x00, 0x3B, 0x80, 0x00,  //             ### ###                 //
		     0x00, 0x3B, 0x00, 0x00,  //             ### ##                  //
		     0x00, 0x3E, 0x00, 0x00,  //             #####                   //
		     0x00, 0x3E, 0x00, 0x00,  //             #####                   //
		     0x00, 0x3F, 0x00, 0x00,  //             ######                  //
		     0x00, 0x3F, 0x00, 0x00,  //             ######                  //
		     0x00, 0x3B, 0x80, 0x00,  //             ### ###                 //
		     0x00, 0x3B, 0xC0, 0x00,  //             ### ####                //
		     0x00, 0x39, 0xC0, 0x00,  //             ###  ###                //
		     0x00, 0x38, 0xE0, 0x00,  //             ###   ###               //
		     0x00, 0x38, 0xF0, 0x00,  //             ###   ####              //
		     0x00, 0x38, 0x78, 0x00,  //             ###    ####             //
		     0x00, 0x38, 0x3E, 0x00,  //             ###     #####           //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @1364   [L]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0xFC, 0x00, 0x00,  //           ######                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x0C, 0x00,  //              ###      ##            //
		     0x00, 0x18, 0x1C, 0x00,  //              ##      ###            //
		     0x00, 0x3F, 0xF8, 0x00,  //             ###########             //
		     0x00, 0x3F, 0xF8, 0x00,  //             ###########             //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @1488   [M]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x0F, 0xC0, 0x0E, 0x00,  //       ######          ###           //
		     0x01, 0xE0, 0x0E, 0x00,  //          ####         ###           //
		     0x01, 0xE0, 0x1E, 0x00,  //          ####        ####           //
		     0x01, 0xE0, 0x1E, 0x00,  //          ####        ####           //
		     0x01, 0xF0, 0x1E, 0x00,  //          #####       ####           //
		     0x01, 0xF0, 0x3E, 0x00,  //          #####      #####           //
		     0x01, 0xF0, 0x3E, 0x00,  //          #####      #####           //
		     0x01, 0xB8, 0x6E, 0x00,  //          ## ###    ## ###           //
		     0x01, 0xB8, 0x6E, 0x00,  //          ## ###    ## ###           //
		     0x01, 0xBC, 0xCE, 0x00,  //          ## ####  ##  ###           //
		     0x01, 0x9C, 0xCE, 0x00,  //          ##  ###  ##  ###           //
		     0x03, 0x9D, 0x8E, 0x00,  //         ###  ### ##   ###           //
		     0x03, 0x9F, 0x8E, 0x00,  //         ###  ######   ###           //
		     0x03, 0x8F, 0x8E, 0x00,  //         ###   #####   ###           //
		     0x03, 0x0F, 0x0E, 0x00,  //         ##    ####    ###           //
		     0x03, 0x0F, 0x0E, 0x00,  //         ##    ####    ###           //
		     0x07, 0x06, 0x0E, 0x00,  //        ###     ##     ###           //
		     0x07, 0x06, 0x07, 0x80,  //        ###     ##      ####         //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @1612   [N]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x03, 0xF0, 0x0E, 0x00,  //         ######        ###           //
		     0x00, 0x78, 0x0E, 0x00,  //            ####       ###           //
		     0x00, 0x78, 0x0C, 0x00,  //            ####       ##            //
		     0x00, 0x7C, 0x0C, 0x00,  //            #####      ##            //
		     0x00, 0x7C, 0x0C, 0x00,  //            #####      ##            //
		     0x00, 0x7E, 0x0C, 0x00,  //            ######     ##            //
		     0x00, 0x6F, 0x0C, 0x00,  //            ## ####    ##            //
		     0x00, 0x67, 0x0C, 0x00,  //            ##  ###    ##            //
		     0x00, 0x67, 0x8C, 0x00,  //            ##  ####   ##            //
		     0x00, 0x63, 0x8C, 0x00,  //            ##   ###   ##            //
		     0x00, 0x61, 0xCC, 0x00,  //            ##    ###  ##            //
		     0x00, 0xE1, 0xEC, 0x00,  //           ###    #### ##            //
		     0x00, 0xE0, 0xEC, 0x00,  //           ###     ### ##            //
		     0x00, 0xE0, 0xF8, 0x00,  //           ###     #####             //
		     0x00, 0xC0, 0x78, 0x00,  //           ##       ####             //
		     0x00, 0xC0, 0x38, 0x00,  //           ##        ###             //
		     0x01, 0xC0, 0x38, 0x00,  //          ###        ###             //
		     0x01, 0xC0, 0x18, 0x00,  //          ###         ##             //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @1736   [O]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x0F, 0xE0, 0x00,  //               #######               //
		     0x00, 0x38, 0x70, 0x00,  //             ###    ###              //
		     0x00, 0x70, 0x38, 0x00,  //            ###      ###             //
		     0x00, 0x60, 0x1C, 0x00,  //            ##        ###            //
		     0x00, 0xE0, 0x1C, 0x00,  //           ###        ###            //
		     0x00, 0xE0, 0x1E, 0x00,  //           ###        ####           //
		     0x01, 0xC0, 0x0E, 0x00,  //          ###          ###           //
		     0x01, 0xC0, 0x0E, 0x00,  //          ###          ###           //
		     0x01, 0xC0, 0x0E, 0x00,  //          ###          ###           //
		     0x01, 0xC0, 0x0E, 0x00,  //          ###          ###           //
		     0x01, 0xC0, 0x0E, 0x00,  //          ###          ###           //
		     0x01, 0xC0, 0x0E, 0x00,  //          ###          ###           //
		     0x01, 0xE0, 0x1C, 0x00,  //          ####        ###            //
		     0x00, 0xE0, 0x1C, 0x00,  //           ###        ###            //
		     0x00, 0xE0, 0x18, 0x00,  //           ###        ##             //
		     0x00, 0x70, 0x38, 0x00,  //            ###      ###             //
		     0x00, 0x38, 0x70, 0x00,  //             ###    ###              //
		     0x00, 0x1F, 0xC0, 0x00,  //              #######                //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @1860   [P]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0xFF, 0xC0, 0x00,  //           ##########                //
		     0x00, 0x38, 0xF0, 0x00,  //             ###   ####              //
		     0x00, 0x38, 0x70, 0x00,  //             ###    ###              //
		     0x00, 0x38, 0x78, 0x00,  //             ###    ####             //
		     0x00, 0x38, 0x38, 0x00,  //             ###     ###             //
		     0x00, 0x38, 0x38, 0x00,  //             ###     ###             //
		     0x00, 0x38, 0x70, 0x00,  //             ###    ###              //
		     0x00, 0x38, 0x70, 0x00,  //             ###    ###              //
		     0x00, 0x39, 0xE0, 0x00,  //             ###  ####               //
		     0x00, 0x3F, 0x80, 0x00,  //             #######                 //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @1984   [Q]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x07, 0xF0, 0x00, 0x00,  //        #######                      //
		     0x1C, 0x38, 0x00, 0x00,  //      ###    ###                     //
		     0x38, 0x1C, 0x00, 0x00,  //     ###      ###                    //
		     0x30, 0x0E, 0x00, 0x00,  //     ##        ###                   //
		     0x70, 0x0E, 0x00, 0x00,  //    ###        ###                   //
		     0x70, 0x0F, 0x00, 0x00,  //    ###        ####                  //
		     0xE0, 0x07, 0x00, 0x00,  //   ###          ###                  //
		     0xE0, 0x07, 0x00, 0x00,  //   ###          ###                  //
		     0xE0, 0x07, 0x00, 0x00,  //   ###          ###                  //
		     0xE0, 0x07, 0x00, 0x00,  //   ###          ###                  //
		     0xE0, 0x07, 0x00, 0x00,  //   ###          ###                  //
		     0xE0, 0x07, 0x00, 0x00,  //   ###          ###                  //
		     0xF0, 0x0E, 0x00, 0x00,  //   ####        ###                   //
		     0x70, 0x0E, 0x00, 0x00,  //    ###        ###                   //
		     0x70, 0x0C, 0x00, 0x00,  //    ###        ##                    //
		     0x38, 0x1C, 0x00, 0x00,  //     ###      ###                    //
		     0x3C, 0x38, 0x00, 0x00,  //     ####    ###                     //
		     0x0F, 0xE0, 0x00, 0x00,  //       #######                       //
		     0x00, 0xF0, 0x00, 0x00,  //           ####                      //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x0F, 0x00, 0x00,  //               ####                  //
		     0x00, 0x03, 0xE0, 0x0C,  //                 #####         ##    //
		     0x00, 0x00, 0xF8, 0x38,  //                   #####     ###     //
		     0x00, 0x00, 0x3F, 0xF0,  //                     ##########      //
		     0x00, 0x00, 0x0F, 0xC0,  //                       ######        //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @2108   [R]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x01, 0xFF, 0x80, 0x00,  //          ##########                 //
		     0x00, 0x71, 0xE0, 0x00,  //            ###   ####               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0xF0, 0x00,  //            ###    ####              //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x71, 0xC0, 0x00,  //            ###   ###                //
		     0x00, 0x7F, 0x00, 0x00,  //            #######                  //
		     0x00, 0x7E, 0x00, 0x00,  //            ######                   //
		     0x00, 0x7F, 0x00, 0x00,  //            #######                  //
		     0x00, 0x77, 0x00, 0x00,  //            ### ###                  //
		     0x00, 0x73, 0x80, 0x00,  //            ###  ###                 //
		     0x00, 0x73, 0x80, 0x00,  //            ###  ###                 //
		     0x00, 0x71, 0xC0, 0x00,  //            ###   ###                //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0x70, 0x00,  //            ###     ###              //
		     0x00, 0x70, 0x3C, 0x00,  //            ###      ####            //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @2232   [S]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x0F, 0xC0, 0x00,  //               ######                //
		     0x00, 0x18, 0xE0, 0x00,  //              ##   ###               //
		     0x00, 0x30, 0x60, 0x00,  //             ##     ##               //
		     0x00, 0x70, 0x60, 0x00,  //            ###     ##               //
		     0x00, 0x70, 0x60, 0x00,  //            ###     ##               //
		     0x00, 0x70, 0x00, 0x00,  //            ###                      //
		     0x00, 0x78, 0x00, 0x00,  //            ####                     //
		     0x00, 0x3C, 0x00, 0x00,  //             ####                    //
		     0x00, 0x1F, 0x00, 0x00,  //              #####                  //
		     0x00, 0x07, 0xC0, 0x00,  //                #####                //
		     0x00, 0x03, 0xE0, 0x00,  //                 #####               //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x60, 0x70, 0x00,  //            ##      ###              //
		     0x00, 0x60, 0x60, 0x00,  //            ##      ##               //
		     0x00, 0x60, 0xE0, 0x00,  //            ##     ###               //
		     0x00, 0x71, 0xC0, 0x00,  //            ###   ###                //
		     0x00, 0x7F, 0x00, 0x00,  //            #######                  //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @2356   [T]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0xFF, 0xFC, 0x00,  //           ##############            //
		     0x01, 0xC7, 0x00, 0x00,  //          ###   ###                  //
		     0x01, 0x87, 0x00, 0x00,  //          ##    ###                  //
		     0x01, 0x87, 0x00, 0x00,  //          ##    ###                  //
		     0x01, 0x87, 0x00, 0x00,  //          ##    ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @2480   [U]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x03, 0xE0, 0x1C, 0x00,  //         #####        ###            //
		     0x00, 0xE0, 0x1C, 0x00,  //           ###        ###            //
		     0x00, 0xE0, 0x1C, 0x00,  //           ###        ###            //
		     0x00, 0xE0, 0x1C, 0x00,  //           ###        ###            //
		     0x00, 0xE0, 0x18, 0x00,  //           ###        ##             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xE0, 0x38, 0x00,  //           ###       ###             //
		     0x00, 0xC0, 0x38, 0x00,  //           ##        ###             //
		     0x01, 0xC0, 0x38, 0x00,  //          ###        ###             //
		     0x01, 0xC0, 0x78, 0x00,  //          ###       ####             //
		     0x01, 0xE0, 0x78, 0x00,  //          ####      ####             //
		     0x00, 0xE0, 0xF8, 0x00,  //           ###     #####             //
		     0x00, 0xE0, 0xF8, 0x00,  //           ###     #####             //
		     0x00, 0xF3, 0xB8, 0x00,  //           ####  ### ###             //
		     0x00, 0x7F, 0x3C, 0x00,  //            #######  ####            //
		     0x00, 0x3E, 0x1F, 0x00,  //             #####    #####          //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @2604   [V]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x03, 0xF0, 0x1C, 0x00,  //         ######       ###            //
		     0x00, 0x70, 0x0E, 0x00,  //            ###        ###           //
		     0x00, 0x70, 0x0E, 0x00,  //            ###        ###           //
		     0x00, 0x38, 0x0C, 0x00,  //             ###       ##            //
		     0x00, 0x38, 0x0C, 0x00,  //             ###       ##            //
		     0x00, 0x38, 0x1C, 0x00,  //             ###      ###            //
		     0x00, 0x38, 0x18, 0x00,  //             ###      ##             //
		     0x00, 0x1C, 0x38, 0x00,  //              ###    ###             //
		     0x00, 0x1C, 0x30, 0x00,  //              ###    ##              //
		     0x00, 0x1C, 0x30, 0x00,  //              ###    ##              //
		     0x00, 0x1C, 0x60, 0x00,  //              ###   ##               //
		     0x00, 0x1C, 0x60, 0x00,  //              ###   ##               //
		     0x00, 0x0E, 0xC0, 0x00,  //               ### ##                //
		     0x00, 0x0E, 0xC0, 0x00,  //               ### ##                //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @2728   [W]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x3F, 0x00, 0x01, 0xC0,  //     ######               ###        //
		     0x07, 0x01, 0x80, 0xE0,  //        ###       ##       ###       //
		     0x07, 0x01, 0x80, 0xE0,  //        ###       ##       ###       //
		     0x03, 0x83, 0xC0, 0xC0,  //         ###     ####      ##        //
		     0x03, 0x83, 0xC0, 0xC0,  //         ###     ####      ##        //
		     0x03, 0x83, 0xC1, 0xC0,  //         ###     ####     ###        //
		     0x03, 0x87, 0xC1, 0x80,  //         ###    #####     ##         //
		     0x01, 0xC6, 0xE1, 0x80,  //          ###   ## ###    ##         //
		     0x01, 0xC6, 0xE3, 0x80,  //          ###   ## ###   ###         //
		     0x01, 0xCC, 0xE3, 0x00,  //          ###  ##  ###   ##          //
		     0x01, 0xCC, 0xE3, 0x00,  //          ###  ##  ###   ##          //
		     0x01, 0xCC, 0xE6, 0x00,  //          ###  ##  ###  ##           //
		     0x00, 0xF8, 0x76, 0x00,  //           #####    ### ##           //
		     0x00, 0xF8, 0x7C, 0x00,  //           #####    #####            //
		     0x00, 0xF8, 0x7C, 0x00,  //           #####    #####            //
		     0x00, 0xF0, 0x78, 0x00,  //           ####     ####             //
		     0x00, 0xF0, 0x78, 0x00,  //           ####     ####             //
		     0x00, 0x60, 0x30, 0x00,  //            ##       ##              //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @2852   [X]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x01, 0xF0, 0x3C, 0x00,  //          #####      ####            //
		     0x00, 0x70, 0x38, 0x00,  //            ###      ###             //
		     0x00, 0x38, 0x70, 0x00,  //             ###    ###              //
		     0x00, 0x38, 0xE0, 0x00,  //             ###   ###               //
		     0x00, 0x1C, 0xC0, 0x00,  //              ###  ##                //
		     0x00, 0x1D, 0xC0, 0x00,  //              ### ###                //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x0F, 0x00, 0x00,  //               ####                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x0F, 0x00, 0x00,  //               ####                  //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x1B, 0x80, 0x00,  //              ## ###                 //
		     0x00, 0x3B, 0x80, 0x00,  //             ### ###                 //
		     0x00, 0x31, 0xC0, 0x00,  //             ##   ###                //
		     0x00, 0x71, 0xC0, 0x00,  //            ###   ###                //
		     0x00, 0xE0, 0xE0, 0x00,  //           ###     ###               //
		     0x01, 0xC0, 0xE0, 0x00,  //          ###      ###               //
		     0x01, 0xC0, 0x7C, 0x00,  //          ###       #####            //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @2976   [Y]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x01, 0xF0, 0x1C, 0x00,  //          #####       ###            //
		     0x00, 0x38, 0x1C, 0x00,  //             ###      ###            //
		     0x00, 0x38, 0x38, 0x00,  //             ###     ###             //
		     0x00, 0x1C, 0x30, 0x00,  //              ###    ##              //
		     0x00, 0x1C, 0x70, 0x00,  //              ###   ###              //
		     0x00, 0x0E, 0x60, 0x00,  //               ###  ##               //
		     0x00, 0x0E, 0xE0, 0x00,  //               ### ###               //
		     0x00, 0x0E, 0xC0, 0x00,  //               ### ##                //
		     0x00, 0x07, 0xC0, 0x00,  //                #####                //
		     0x00, 0x07, 0x80, 0x00,  //                ####                 //
		     0x00, 0x07, 0x80, 0x00,  //                ####                 //
		     0x00, 0x07, 0x80, 0x00,  //                ####                 //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @3100   [Z]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x7F, 0xF8, 0x00,  //            ############             //
		     0x00, 0x60, 0x78, 0x00,  //            ##      ####             //
		     0x00, 0x60, 0x70, 0x00,  //            ##      ###              //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x70, 0x0C, 0x00,  //            ###        ##            //
		     0x00, 0x70, 0x1C, 0x00,  //            ###       ###            //
		     0x00, 0xFF, 0xF8, 0x00,  //           #############             //
		     0x01, 0xE1, 0xF8, 0x00,  //          ####    ######             //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @3224   [[]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x0F, 0xC0, 0x00,  //               ######                //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @3348   [\]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x01, 0x80, 0x00,  //                  ##                 //
		     0x00, 0x01, 0x80, 0x00,  //                  ##                 //
		     0x00, 0x01, 0x80, 0x00,  //                  ##                 //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @3472   []]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x0F, 0xC0, 0x00,  //               ######                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x0F, 0xC0, 0x00,  //               ######                //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @3596   [^]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x07, 0xC0, 0x00,  //                #####                //
		     0x00, 0x06, 0xC0, 0x00,  //                ## ##                //
		     0x00, 0x0E, 0xC0, 0x00,  //               ### ##                //
		     0x00, 0x0C, 0xE0, 0x00,  //               ##  ###               //
		     0x00, 0x1C, 0x60, 0x00,  //              ###   ##               //
		     0x00, 0x18, 0x70, 0x00,  //              ##    ###              //
		     0x00, 0x38, 0x30, 0x00,  //             ###     ##              //
		     0x00, 0x70, 0x38, 0x00,  //            ###      ###             //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @3720   [_]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x3F, 0xE0, 0x00,  //             #########               //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @3844   [`]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x01, 0x80, 0x00,  //                  ##                 //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @3968   [a]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x39, 0xC0, 0x00,  //             ###  ###                //
		     0x00, 0x31, 0xC0, 0x00,  //             ##   ###                //
		     0x00, 0x31, 0xC0, 0x00,  //             ##   ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x0F, 0xC0, 0x00,  //               ######                //
		     0x00, 0x39, 0xC0, 0x00,  //             ###  ###                //
		     0x00, 0x71, 0xC0, 0x00,  //            ###   ###                //
		     0x00, 0x77, 0xC0, 0x00,  //            ### #####                //
		     0x00, 0x7F, 0xC0, 0x00,  //            #########                //
		     0x00, 0x3C, 0xF0, 0x00,  //             ####  ####              //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @4092   [b]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0xF0, 0x00,  //             ###   ####              //
		     0x00, 0x3B, 0xF0, 0x00,  //             ### ######              //
		     0x00, 0x3F, 0x78, 0x00,  //             ###### ####             //
		     0x00, 0x3E, 0x38, 0x00,  //             #####   ###             //
		     0x00, 0x3C, 0x38, 0x00,  //             ####    ###             //
		     0x00, 0x3C, 0x38, 0x00,  //             ####    ###             //
		     0x00, 0x38, 0x30, 0x00,  //             ###     ##              //
		     0x00, 0x38, 0x70, 0x00,  //             ###    ###              //
		     0x00, 0x38, 0x70, 0x00,  //             ###    ###              //
		     0x00, 0x7C, 0xE0, 0x00,  //            #####  ###               //
		     0x00, 0x6F, 0x80, 0x00,  //            ## #####                 //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @4216   [c]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x07, 0xE0, 0x00,  //                ######               //
		     0x00, 0x0C, 0xE0, 0x00,  //               ##  ###               //
		     0x00, 0x18, 0x60, 0x00,  //              ##    ##               //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x1C, 0xE0, 0x00,  //              ###  ###               //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @4340   [d]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x0F, 0xE0, 0x00,  //               #######               //
		     0x00, 0x38, 0xE0, 0x00,  //             ###   ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x60, 0xE0, 0x00,  //            ##     ###               //
		     0x00, 0xE0, 0xE0, 0x00,  //           ###     ###               //
		     0x00, 0xE1, 0xE0, 0x00,  //           ###    ####               //
		     0x00, 0xE3, 0xE0, 0x00,  //           ###   #####               //
		     0x00, 0xE3, 0xE0, 0x00,  //           ###   #####               //
		     0x00, 0xE6, 0xE0, 0x00,  //           ###  ## ###               //
		     0x00, 0xFC, 0xE0, 0x00,  //           ######  ###               //
		     0x00, 0x78, 0x78, 0x00,  //            ####    ####             //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @4464   [e]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x07, 0xE0, 0x00,  //                ######               //
		     0x00, 0x0C, 0xE0, 0x00,  //               ##  ###               //
		     0x00, 0x18, 0xE0, 0x00,  //              ##   ###               //
		     0x00, 0x39, 0xE0, 0x00,  //             ###  ####               //
		     0x00, 0x3F, 0x00, 0x00,  //             ######                  //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x3C, 0x00, 0x00,  //             ####                    //
		     0x00, 0x1C, 0xE0, 0x00,  //              ###  ###               //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @4588   [f]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x7C, 0x00,  //                    #####            //
		     0x00, 0x00, 0xCE, 0x00,  //                   ##  ###           //
		     0x00, 0x01, 0xC7, 0x00,  //                  ###   ###          //
		     0x00, 0x01, 0x86, 0x00,  //                  ##    ##           //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x1F, 0xF0, 0x00,  //              #########              //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x03, 0x98, 0x00, 0x00,  //         ###  ##                     //
		     0x01, 0xF0, 0x00, 0x00,  //          #####                      //

		     // @4712   [g]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x18, 0x00,  //                      ##             //
		     0x00, 0x0F, 0x98, 0x00,  //               #####  ##             //
		     0x00, 0x39, 0xF8, 0x00,  //             ###  ######             //
		     0x00, 0x30, 0xE0, 0x00,  //             ##    ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x39, 0xC0, 0x00,  //             ###  ###                //
		     0x00, 0x1F, 0x80, 0x00,  //              ######                 //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x3E, 0x00, 0x00,  //             #####                   //
		     0x00, 0x1F, 0xE0, 0x00,  //              ########               //
		     0x00, 0x31, 0xF0, 0x00,  //             ##   #####              //
		     0x00, 0xE0, 0x70, 0x00,  //           ###      ###              //
		     0x00, 0xE0, 0x70, 0x00,  //           ###      ###              //
		     0x00, 0xE0, 0x70, 0x00,  //           ###      ###              //
		     0x00, 0xE0, 0x60, 0x00,  //           ###      ##               //
		     0x00, 0xF1, 0xC0, 0x00,  //           ####   ###                //
		     0x00, 0x3F, 0x00, 0x00,  //             ######                  //

		     // @4836   [h]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x70, 0x00, 0x00,  //            ###                      //
		     0x00, 0x70, 0x00, 0x00,  //            ###                      //
		     0x00, 0x70, 0x00, 0x00,  //            ###                      //
		     0x00, 0x70, 0x00, 0x00,  //            ###                      //
		     0x00, 0x70, 0x00, 0x00,  //            ###                      //
		     0x00, 0x70, 0x00, 0x00,  //            ###                      //
		     0x00, 0x70, 0x00, 0x00,  //            ###                      //
		     0x00, 0x73, 0xC0, 0x00,  //            ###  ####                //
		     0x00, 0x77, 0xE0, 0x00,  //            ### ######               //
		     0x00, 0x7E, 0xE0, 0x00,  //            ###### ###               //
		     0x00, 0x7C, 0xE0, 0x00,  //            #####  ###               //
		     0x00, 0x78, 0xE0, 0x00,  //            ####   ###               //
		     0x00, 0x78, 0xE0, 0x00,  //            ####   ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x60, 0xE0, 0x00,  //            ##     ###               //
		     0x00, 0x60, 0xF0, 0x00,  //            ##     ####              //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @4960   [i]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x07, 0x80, 0x00,  //                ####                 //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x80, 0x00,  //                ####                 //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @5084   [j]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x39, 0x80, 0x00,  //             ###  ##                 //
		     0x00, 0x1F, 0x00, 0x00,  //              #####                  //

		     // @5208   [k]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x70, 0x00, 0x00,  //            ###                      //
		     0x00, 0x70, 0x00, 0x00,  //            ###                      //
		     0x00, 0x70, 0x00, 0x00,  //            ###                      //
		     0x00, 0x70, 0x00, 0x00,  //            ###                      //
		     0x00, 0x70, 0x00, 0x00,  //            ###                      //
		     0x00, 0x70, 0x00, 0x00,  //            ###                      //
		     0x00, 0x70, 0x00, 0x00,  //            ###                      //
		     0x00, 0x71, 0xE0, 0x00,  //            ###   ####               //
		     0x00, 0x77, 0xE0, 0x00,  //            ### ######               //
		     0x00, 0x76, 0xE0, 0x00,  //            ### ## ###               //
		     0x00, 0x7C, 0xE0, 0x00,  //            #####  ###               //
		     0x00, 0x79, 0xC0, 0x00,  //            ####  ###                //
		     0x00, 0x7B, 0x00, 0x00,  //            #### ##                  //
		     0x00, 0x7F, 0x00, 0x00,  //            #######                  //
		     0x00, 0x77, 0x00, 0x00,  //            ### ###                  //
		     0x00, 0x73, 0x80, 0x00,  //            ###  ###                 //
		     0x00, 0x63, 0xC0, 0x00,  //            ##   ####                //
		     0x00, 0x61, 0xF0, 0x00,  //            ##    #####              //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @5332   [l]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x80, 0x00,  //                ####                 //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @5456   [m]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x07, 0x9E, 0x3C, 0x00,  //        ####  ####   ####            //
		     0x03, 0xBF, 0x7C, 0x00,  //         ### ###### #####            //
		     0x03, 0xB7, 0xEE, 0x00,  //         ### ## ###### ###           //
		     0x03, 0xE7, 0xCC, 0x00,  //         #####  #####  ##            //
		     0x03, 0xE7, 0x8C, 0x00,  //         #####  ####   ##            //
		     0x03, 0xC7, 0x8C, 0x00,  //         ####   ####   ##            //
		     0x03, 0xC7, 0x0C, 0x00,  //         ####   ###    ##            //
		     0x03, 0x87, 0x1C, 0x00,  //         ###    ###   ###            //
		     0x03, 0x87, 0x1C, 0x00,  //         ###    ###   ###            //
		     0x03, 0x87, 0x1C, 0x00,  //         ###    ###   ###            //
		     0x03, 0x86, 0x0F, 0x00,  //         ###    ##     ####          //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @5580   [n]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0xF1, 0xE0, 0x00,  //           ####   ####               //
		     0x00, 0x77, 0xE0, 0x00,  //            ### ######               //
		     0x00, 0x76, 0xE0, 0x00,  //            ### ## ###               //
		     0x00, 0x7C, 0x60, 0x00,  //            #####   ##               //
		     0x00, 0x7C, 0x60, 0x00,  //            #####   ##               //
		     0x00, 0x78, 0x60, 0x00,  //            ####    ##               //
		     0x00, 0x78, 0xE0, 0x00,  //            ####   ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0x78, 0x00,  //            ###     ####             //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @5704   [o]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x19, 0xE0, 0x00,  //              ##  ####               //
		     0x00, 0x30, 0xE0, 0x00,  //             ##    ###               //
		     0x00, 0x30, 0xE0, 0x00,  //             ##    ###               //
		     0x00, 0x70, 0x70, 0x00,  //            ###     ###              //
		     0x00, 0x70, 0x70, 0x00,  //            ###     ###              //
		     0x00, 0x70, 0x60, 0x00,  //            ###     ##               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0xC0, 0x00,  //            ###    ##                //
		     0x00, 0x39, 0xC0, 0x00,  //             ###  ###                //
		     0x00, 0x1F, 0x00, 0x00,  //              #####                  //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @5828   [p]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x78, 0xF0, 0x00,  //            ####   ####              //
		     0x00, 0x39, 0xF8, 0x00,  //             ###  ######             //
		     0x00, 0x3B, 0xB8, 0x00,  //             ### ### ###             //
		     0x00, 0x3E, 0x38, 0x00,  //             #####   ###             //
		     0x00, 0x3E, 0x38, 0x00,  //             #####   ###             //
		     0x00, 0x3C, 0x38, 0x00,  //             ####    ###             //
		     0x00, 0x3C, 0x38, 0x00,  //             ####    ###             //
		     0x00, 0x38, 0x38, 0x00,  //             ###     ###             //
		     0x00, 0x38, 0x70, 0x00,  //             ###    ###              //
		     0x00, 0x38, 0xE0, 0x00,  //             ###   ###               //
		     0x00, 0x3F, 0xC0, 0x00,  //             ########                //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x30, 0x00, 0x00,  //             ##                      //
		     0x00, 0x30, 0x00, 0x00,  //             ##                      //
		     0x00, 0x30, 0x00, 0x00,  //             ##                      //
		     0x00, 0x30, 0x00, 0x00,  //             ##                      //

		     // @5952   [q]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x0F, 0xE0, 0x00,  //               #######               //
		     0x00, 0x39, 0xE0, 0x00,  //             ###  ####               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x60, 0xE0, 0x00,  //            ##     ###               //
		     0x00, 0xE0, 0xE0, 0x00,  //           ###     ###               //
		     0x00, 0xE1, 0xE0, 0x00,  //           ###    ####               //
		     0x00, 0xE3, 0xE0, 0x00,  //           ###   #####               //
		     0x00, 0xE3, 0xC0, 0x00,  //           ###   ####                //
		     0x00, 0xE6, 0xC0, 0x00,  //           ###  ## ##                //
		     0x00, 0xFC, 0xC0, 0x00,  //           ######  ##                //
		     0x00, 0x78, 0xC0, 0x00,  //            ####   ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x00, 0xCC, 0x00,  //                   ##  ##            //
		     0x00, 0x00, 0xF8, 0x00,  //                   #####             //

		     // @6076   [r]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x3C, 0xF0, 0x00,  //             ####  ####              //
		     0x00, 0x1D, 0xF0, 0x00,  //              ### #####              //
		     0x00, 0x1F, 0x80, 0x00,  //              ######                 //
		     0x00, 0x1F, 0x00, 0x00,  //              #####                  //
		     0x00, 0x1E, 0x00, 0x00,  //              ####                   //
		     0x00, 0x1E, 0x00, 0x00,  //              ####                   //
		     0x00, 0x1E, 0x00, 0x00,  //              ####                   //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @6200   [s]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x0F, 0xC0, 0x00,  //               ######                //
		     0x00, 0x18, 0xE0, 0x00,  //              ##   ###               //
		     0x00, 0x38, 0xC0, 0x00,  //             ###   ##                //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x1E, 0x00, 0x00,  //              ####                   //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x03, 0xC0, 0x00,  //                 ####                //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x30, 0xE0, 0x00,  //             ##    ###               //
		     0x00, 0x38, 0xC0, 0x00,  //             ###   ##                //
		     0x00, 0x1F, 0x80, 0x00,  //              ######                 //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @6324   [t]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x3F, 0xE0, 0x00,  //             #########               //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x0E, 0x60, 0x00,  //               ###  ##               //
		     0x00, 0x07, 0xC0, 0x00,  //                #####                //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @6448   [u]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0xF0, 0xE0, 0x00,  //           ####    ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x71, 0xE0, 0x00,  //            ###   ####               //
		     0x00, 0x71, 0xE0, 0x00,  //            ###   ####               //
		     0x00, 0x71, 0xE0, 0x00,  //            ###   ####               //
		     0x00, 0x73, 0xE0, 0x00,  //            ###  #####               //
		     0x00, 0x77, 0xE0, 0x00,  //            ### ######               //
		     0x00, 0x7E, 0xF0, 0x00,  //            ###### ####              //
		     0x00, 0x3C, 0x78, 0x00,  //             ####   ####             //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @6572   [v]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x78, 0x70, 0x00,  //            ####    ###              //
		     0x00, 0x38, 0x70, 0x00,  //             ###    ###              //
		     0x00, 0x1C, 0x70, 0x00,  //              ###   ###              //
		     0x00, 0x1C, 0x70, 0x00,  //              ###   ###              //
		     0x00, 0x1C, 0x60, 0x00,  //              ###   ##               //
		     0x00, 0x0C, 0xE0, 0x00,  //               ##  ###               //
		     0x00, 0x0E, 0xC0, 0x00,  //               ### ##                //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x0F, 0x00, 0x00,  //               ####                  //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @6696   [w]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x01, 0xE0, 0x0E, 0x00,  //          ####         ###           //
		     0x00, 0xE3, 0x86, 0x00,  //           ###   ###    ##           //
		     0x00, 0x73, 0x86, 0x00,  //            ###  ###    ##           //
		     0x00, 0x71, 0x86, 0x00,  //            ###   ##    ##           //
		     0x00, 0x73, 0xCE, 0x00,  //            ###  ####  ###           //
		     0x00, 0x33, 0xCC, 0x00,  //             ##  ####  ##            //
		     0x00, 0x3F, 0xD8, 0x00,  //             ######## ##             //
		     0x00, 0x3E, 0xD8, 0x00,  //             ##### ## ##             //
		     0x00, 0x3C, 0xF0, 0x00,  //             ####  ####              //
		     0x00, 0x3C, 0xE0, 0x00,  //             ####  ###               //
		     0x00, 0x18, 0xE0, 0x00,  //              ##   ###               //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @6820   [x]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x3C, 0x78, 0x00,  //             ####   ####             //
		     0x00, 0x0E, 0xF8, 0x00,  //               ### #####             //
		     0x00, 0x0F, 0xC0, 0x00,  //               ######                //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x1F, 0x80, 0x00,  //              ######                 //
		     0x00, 0xF9, 0xC0, 0x00,  //           #####  ###                //
		     0x00, 0xF0, 0xF0, 0x00,  //           ####    ####              //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @6944   [y]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x78, 0x38, 0x00,  //            ####     ###             //
		     0x00, 0x38, 0x30, 0x00,  //             ###     ##              //
		     0x00, 0x1C, 0x70, 0x00,  //              ###   ###              //
		     0x00, 0x1C, 0x60, 0x00,  //              ###   ##               //
		     0x00, 0x1C, 0xE0, 0x00,  //              ###  ###               //
		     0x00, 0x0E, 0xC0, 0x00,  //               ### ##                //
		     0x00, 0x0E, 0xC0, 0x00,  //               ### ##                //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x07, 0x80, 0x00,  //                ####                 //
		     0x00, 0x07, 0x80, 0x00,  //                ####                 //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0xF8, 0x00, 0x00,  //           #####                     //
		     0x00, 0xF0, 0x00, 0x00,  //           ####                      //

		     // @7068   [z]   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x1F, 0xF0, 0x00,  //              #########              //
		     0x00, 0x1F, 0xE0, 0x00,  //              ########               //
		     0x00, 0x30, 0xC0, 0x00,  //             ##    ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x01, 0x80, 0x00,  //                  ##                 //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x18, 0x30, 0x00,  //              ##     ##              //
		     0x00, 0x3F, 0xF0, 0x00,  //             ##########              //
		     0x00, 0x33, 0xE0, 0x00,  //             ##  #####               //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @7192   []   (30 px wide)
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x03, 0xC0, 0x00,  //                 ####                //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x0F, 0xC0, 0x00,  //               ######                //
		     0x00, 0x18, 0xE0, 0x00,  //              ##   ###               //
		     0x00, 0x30, 0x60, 0x00,  //             ##     ##               //
		     0x00, 0x70, 0x60, 0x00,  //            ###     ##               //
		     0x00, 0x70, 0x60, 0x00,  //            ###     ##               //
		     0x00, 0x70, 0x00, 0x00,  //            ###                      //
		     0x00, 0x78, 0x00, 0x00,  //            ####                     //
		     0x00, 0x3C, 0x00, 0x00,  //             ####                    //
		     0x00, 0x1F, 0x00, 0x00,  //              #####                  //
		     0x00, 0x07, 0xC0, 0x00,  //                #####                //
		     0x00, 0x03, 0xE0, 0x00,  //                 #####               //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x60, 0x70, 0x00,  //            ##      ###              //
		     0x00, 0x60, 0x60, 0x00,  //            ##      ##               //
		     0x00, 0x60, 0xE0, 0x00,  //            ##     ###               //
		     0x00, 0x71, 0xC0, 0x00,  //            ###   ###                //
		     0x00, 0x7F, 0x00, 0x00,  //            #######                  //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @7316   []   (30 px wide)
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x03, 0xC0, 0x00,  //                 ####                //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x7F, 0xF8, 0x00,  //            ############             //
		     0x00, 0x60, 0x78, 0x00,  //            ##      ####             //
		     0x00, 0x60, 0x70, 0x00,  //            ##      ###              //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x70, 0x0C, 0x00,  //            ###        ##            //
		     0x00, 0x70, 0x1C, 0x00,  //            ###       ###            //
		     0x00, 0xFF, 0xF8, 0x00,  //           #############             //
		     0x01, 0xE1, 0xF8, 0x00,  //          ####    ######             //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @7440   []   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0x80, 0x00,  //                  ##                 //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x0F, 0xC0, 0x00,  //               ######                //
		     0x00, 0x18, 0xE0, 0x00,  //              ##   ###               //
		     0x00, 0x38, 0xC0, 0x00,  //             ###   ##                //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x1E, 0x00, 0x00,  //              ####                   //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x03, 0xC0, 0x00,  //                 ####                //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x30, 0xE0, 0x00,  //             ##    ###               //
		     0x00, 0x38, 0xC0, 0x00,  //             ###   ##                //
		     0x00, 0x1F, 0x80, 0x00,  //              ######                 //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @7564   []   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0x80, 0x00,  //                  ##                 //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x1F, 0xF0, 0x00,  //              #########              //
		     0x00, 0x1F, 0xE0, 0x00,  //              ########               //
		     0x00, 0x30, 0xC0, 0x00,  //             ##    ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x01, 0x80, 0x00,  //                  ##                 //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x18, 0x30, 0x00,  //              ##     ##              //
		     0x00, 0x3F, 0xF0, 0x00,  //             ##########              //
		     0x00, 0x33, 0xE0, 0x00,  //             ##  #####               //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @7688   []   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0xFC, 0x00, 0x00,  //           ######                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1D, 0xE0, 0x00,  //              ### ####               //
		     0x00, 0x1F, 0x00, 0x00,  //              #####                  //
		     0x00, 0x7C, 0x00, 0x00,  //            #####                    //
		     0x00, 0xDC, 0x00, 0x00,  //           ## ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x0C, 0x00,  //              ###      ##            //
		     0x00, 0x1C, 0x0C, 0x00,  //              ###      ##            //
		     0x00, 0x18, 0x1C, 0x00,  //              ##      ###            //
		     0x00, 0x3F, 0xF8, 0x00,  //             ###########             //
		     0x00, 0x3F, 0xF8, 0x00,  //             ###########             //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @7812   []   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x07, 0x80, 0x00,  //                ####                 //
		     0x00, 0x07, 0x80, 0x00,  //                ####                 //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x0D, 0xC0, 0x00,  //               ## ###                //
		     0x00, 0x19, 0xC0, 0x00,  //              ##  ###                //
		     0x00, 0x19, 0xC0, 0x00,  //              ##  ###                //
		     0x00, 0x39, 0xC0, 0x00,  //             ###  ###                //
		     0x00, 0x31, 0xC0, 0x00,  //             ##   ###                //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x7F, 0xE0, 0x00,  //            ##########               //
		     0x00, 0x60, 0xE0, 0x00,  //            ##     ###               //
		     0x00, 0xE0, 0xE0, 0x00,  //           ###     ###               //
		     0x00, 0xC0, 0x70, 0x00,  //           ##       ###              //
		     0x01, 0xC0, 0x70, 0x00,  //          ###       ###              //
		     0x01, 0x80, 0x70, 0x00,  //          ##        ###              //
		     0x03, 0x80, 0x38, 0x00,  //         ###         ###             //
		     0x03, 0x80, 0x3E, 0x00,  //         ###         #####           //
		     0x00, 0x00, 0x30, 0x00,  //                     ##              //
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x00, 0xEC, 0x00,  //                   ### ##            //
		     0x00, 0x00, 0xF8, 0x00,  //                   #####             //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @7936   []   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x7F, 0xF8, 0x00,  //            ############             //
		     0x00, 0x60, 0x78, 0x00,  //            ##      ####             //
		     0x00, 0x60, 0x70, 0x00,  //            ##      ###              //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x1C, 0x00, 0x00,  //              ###                    //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x70, 0x0C, 0x00,  //            ###        ##            //
		     0x00, 0x70, 0x1C, 0x00,  //            ###       ###            //
		     0x00, 0xFF, 0xF8, 0x00,  //           #############             //
		     0x01, 0xE1, 0xF8, 0x00,  //          ####    ######             //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @8060   []   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0xE0, 0x00,  //                ######               //
		     0x00, 0x07, 0x80, 0x00,  //                ####                 //
		     0x00, 0x1F, 0x00, 0x00,  //              #####                  //
		     0x00, 0x37, 0x00, 0x00,  //             ## ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x80, 0x00,  //                ####                 //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @8184   []   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x39, 0xC0, 0x00,  //             ###  ###                //
		     0x00, 0x31, 0xC0, 0x00,  //             ##   ###                //
		     0x00, 0x31, 0xC0, 0x00,  //             ##   ###                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x0F, 0xC0, 0x00,  //               ######                //
		     0x00, 0x39, 0xC0, 0x00,  //             ###  ###                //
		     0x00, 0x71, 0xC0, 0x00,  //            ###   ###                //
		     0x00, 0x73, 0xC0, 0x00,  //            ###  ####                //
		     0x00, 0x77, 0xC0, 0x00,  //            ### #####                //
		     0x00, 0x3C, 0xF0, 0x00,  //             ####  ####              //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0x80, 0x00,  //                  ##                 //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0xB0, 0x00,  //                 ### ##              //
		     0x00, 0x01, 0xE0, 0x00,  //                  ####               //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @8308   []   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x1F, 0xF0, 0x00,  //              #########              //
		     0x00, 0x1F, 0xE0, 0x00,  //              ########               //
		     0x00, 0x30, 0xC0, 0x00,  //             ##    ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x01, 0x80, 0x00,  //                  ##                 //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x18, 0x30, 0x00,  //              ##     ##              //
		     0x00, 0x3F, 0xF0, 0x00,  //             ##########              //
		     0x00, 0x33, 0xE0, 0x00,  //             ##  #####               //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @8432   []   (30 px wide)
		     0x00, 0x00, 0x30, 0x00,  //                     ##              //
		     0x00, 0x00, 0x70, 0x00,  //                    ###              //
		     0x00, 0x01, 0xE0, 0x00,  //                  ####               //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x07, 0xF0, 0x00,  //                #######              //
		     0x00, 0x1C, 0x3C, 0x00,  //              ###    ####            //
		     0x00, 0x38, 0x1C, 0x00,  //             ###      ###            //
		     0x00, 0x70, 0x0C, 0x00,  //            ###        ##            //
		     0x00, 0xE0, 0x0C, 0x00,  //           ###         ##            //
		     0x00, 0xE0, 0x00, 0x00,  //           ###                       //
		     0x01, 0xE0, 0x00, 0x00,  //          ####                       //
		     0x01, 0xC0, 0x00, 0x00,  //          ###                        //
		     0x01, 0xC0, 0x00, 0x00,  //          ###                        //
		     0x01, 0xC0, 0x00, 0x00,  //          ###                        //
		     0x01, 0xC0, 0x00, 0x00,  //          ###                        //
		     0x01, 0xE0, 0x00, 0x00,  //          ####                       //
		     0x01, 0xE0, 0x00, 0x00,  //          ####                       //
		     0x00, 0xE0, 0x00, 0x00,  //           ###                       //
		     0x00, 0xF0, 0x00, 0x00,  //           ####                      //
		     0x00, 0x78, 0x18, 0x00,  //            ####      ##             //
		     0x00, 0x3C, 0x70, 0x00,  //             ####   ###              //
		     0x00, 0x0F, 0xC0, 0x00,  //               ######                //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @8556   []   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0xFF, 0xF0, 0x00,  //           ############              //
		     0x00, 0x38, 0x30, 0x00,  //             ###     ##              //
		     0x00, 0x38, 0x30, 0x00,  //             ###     ##              //
		     0x00, 0x38, 0x30, 0x00,  //             ###     ##              //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x3F, 0xE0, 0x00,  //             #########               //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x30, 0x18, 0x00,  //             ##       ##             //
		     0x00, 0x30, 0x18, 0x00,  //             ##       ##             //
		     0x00, 0x7F, 0xF8, 0x00,  //            ############             //
		     0x00, 0x7B, 0xF0, 0x00,  //            #### ######              //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x07, 0x70, 0x00,  //                ### ###              //
		     0x00, 0x03, 0xC0, 0x00,  //                 ####                //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @8680   []   (30 px wide)
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x03, 0xC0, 0x00,  //                 ####                //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x03, 0xF0, 0x0E, 0x00,  //         ######        ###           //
		     0x00, 0x78, 0x0E, 0x00,  //            ####       ###           //
		     0x00, 0x78, 0x0C, 0x00,  //            ####       ##            //
		     0x00, 0x7C, 0x0C, 0x00,  //            #####      ##            //
		     0x00, 0x7C, 0x0C, 0x00,  //            #####      ##            //
		     0x00, 0x7E, 0x0C, 0x00,  //            ######     ##            //
		     0x00, 0x6F, 0x0C, 0x00,  //            ## ####    ##            //
		     0x00, 0x67, 0x0C, 0x00,  //            ##  ###    ##            //
		     0x00, 0x67, 0x8C, 0x00,  //            ##  ####   ##            //
		     0x00, 0x63, 0x8C, 0x00,  //            ##   ###   ##            //
		     0x00, 0x61, 0xCC, 0x00,  //            ##    ###  ##            //
		     0x00, 0xE1, 0xEC, 0x00,  //           ###    #### ##            //
		     0x00, 0xE0, 0xEC, 0x00,  //           ###     ### ##            //
		     0x00, 0xE0, 0xF8, 0x00,  //           ###     #####             //
		     0x00, 0xC0, 0x78, 0x00,  //           ##       ####             //
		     0x00, 0xC0, 0x38, 0x00,  //           ##        ###             //
		     0x01, 0xC0, 0x38, 0x00,  //          ###        ###             //
		     0x01, 0xC0, 0x18, 0x00,  //          ###         ##             //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @8804   []   (30 px wide)
		     0x00, 0x00, 0x60, 0x00,  //                    ##               //
		     0x00, 0x00, 0xE0, 0x00,  //                   ###               //
		     0x00, 0x03, 0xC0, 0x00,  //                 ####                //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x0F, 0xE0, 0x00,  //               #######               //
		     0x00, 0x38, 0x70, 0x00,  //             ###    ###              //
		     0x00, 0x70, 0x38, 0x00,  //            ###      ###             //
		     0x00, 0x60, 0x1C, 0x00,  //            ##        ###            //
		     0x00, 0xE0, 0x1C, 0x00,  //           ###        ###            //
		     0x00, 0xE0, 0x1E, 0x00,  //           ###        ####           //
		     0x01, 0xC0, 0x0E, 0x00,  //          ###          ###           //
		     0x01, 0xC0, 0x0E, 0x00,  //          ###          ###           //
		     0x01, 0xC0, 0x0E, 0x00,  //          ###          ###           //
		     0x01, 0xC0, 0x0E, 0x00,  //          ###          ###           //
		     0x01, 0xC0, 0x0E, 0x00,  //          ###          ###           //
		     0x01, 0xC0, 0x0E, 0x00,  //          ###          ###           //
		     0x01, 0xE0, 0x1C, 0x00,  //          ####        ###            //
		     0x00, 0xE0, 0x1C, 0x00,  //           ###        ###            //
		     0x00, 0xE0, 0x18, 0x00,  //           ###        ##             //
		     0x00, 0x70, 0x38, 0x00,  //            ###      ###             //
		     0x00, 0x38, 0x70, 0x00,  //             ###    ###              //
		     0x00, 0x1F, 0xC0, 0x00,  //              #######                //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @8928   []   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x00, 0xC0, 0x00,  //                   ##                //
		     0x00, 0x01, 0xC0, 0x00,  //                  ###                //
		     0x00, 0x01, 0x80, 0x00,  //                  ##                 //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x07, 0xE0, 0x00,  //                ######               //
		     0x00, 0x0C, 0xE0, 0x00,  //               ##  ###               //
		     0x00, 0x18, 0x60, 0x00,  //              ##    ##               //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x1C, 0xE0, 0x00,  //              ###  ###               //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @9052   []   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x07, 0xE0, 0x00,  //                ######               //
		     0x00, 0x0C, 0xE0, 0x00,  //               ##  ###               //
		     0x00, 0x18, 0xE0, 0x00,  //              ##   ###               //
		     0x00, 0x39, 0xE0, 0x00,  //             ###  ####               //
		     0x00, 0x3F, 0x00, 0x00,  //             ######                  //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x38, 0x00, 0x00,  //             ###                     //
		     0x00, 0x3C, 0x00, 0x00,  //             ####                    //
		     0x00, 0x1C, 0xE0, 0x00,  //              ###  ###               //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x07, 0x00, 0x00,  //                ###                  //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x0E, 0x00, 0x00,  //               ###                   //
		     0x00, 0x0E, 0x60, 0x00,  //               ###  ##               //
		     0x00, 0x07, 0xC0, 0x00,  //                #####                //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @9176   []   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x01, 0x80, 0x00,  //                  ##                 //
		     0x00, 0x01, 0x80, 0x00,  //                  ##                 //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0xF1, 0xE0, 0x00,  //           ####   ####               //
		     0x00, 0x77, 0xE0, 0x00,  //            ### ######               //
		     0x00, 0x76, 0xE0, 0x00,  //            ### ## ###               //
		     0x00, 0x7C, 0x60, 0x00,  //            #####   ##               //
		     0x00, 0x7C, 0x60, 0x00,  //            #####   ##               //
		     0x00, 0x78, 0x60, 0x00,  //            ####    ##               //
		     0x00, 0x78, 0xE0, 0x00,  //            ####   ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0x78, 0x00,  //            ###     ####             //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //

		     // @9300   []   (30 px wide)
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x01, 0x80, 0x00,  //                  ##                 //
		     0x00, 0x01, 0x80, 0x00,  //                  ##                 //
		     0x00, 0x03, 0x80, 0x00,  //                 ###                 //
		     0x00, 0x03, 0x00, 0x00,  //                 ##                  //
		     0x00, 0x06, 0x00, 0x00,  //                ##                   //
		     0x00, 0x0C, 0x00, 0x00,  //               ##                    //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x0F, 0x80, 0x00,  //               #####                 //
		     0x00, 0x19, 0xE0, 0x00,  //              ##  ####               //
		     0x00, 0x30, 0xE0, 0x00,  //             ##    ###               //
		     0x00, 0x30, 0xE0, 0x00,  //             ##    ###               //
		     0x00, 0x70, 0x70, 0x00,  //            ###     ###              //
		     0x00, 0x70, 0x70, 0x00,  //            ###     ###              //
		     0x00, 0x70, 0x60, 0x00,  //            ###     ##               //
		     0x00, 0x70, 0xE0, 0x00,  //            ###    ###               //
		     0x00, 0x70, 0xC0, 0x00,  //            ###    ##                //
		     0x00, 0x39, 0xC0, 0x00,  //             ###  ###                //
		     0x00, 0x1F, 0x00, 0x00,  //              #####                  //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
		     0x00, 0x00, 0x00, 0x00,  //                                     //
};
const uint16_t font7desc[]=
{
		      0 ,		// A  (65)
		    124 ,		// B  (66)
		    248 ,		// C  (67)
		    372 ,		// D  (68)
		    496 ,		// E  (69)
		    620 ,		// F  (70)
		    744 ,		// G  (71)
		    868 ,		// H  (72)
		    992 ,		// I  (73)
		    1116 ,		// J  (74)
		    1240 ,		// K  (75)
		    1364 ,		// L  (76)
		    1488 ,		// M  (77)
		    1612 ,		// N  (78)
		    1736 ,		// O  (79)
		    1860 ,		// P  (80)
		    1984 ,		// Q  (81)
		    2108 ,		// R  (82)
		    2232 ,		// S  (83)
		    2356 ,		// T  (84)
		    2480 ,		// U  (85)
		    2604 ,		// V  (86)
		    2728 ,		// W  (87)
		    2852 ,		// X  (88)
		    2976 ,		// Y  (89)
		    3100 ,		// Z  (90)
		    3224 ,		// [  (91)
		    3348 ,		// //  (92)
		    3472 ,		// ]  (93)
		    3596 ,		// ^  (94)
		    3720 ,		// _  (95)
		    3844 ,		// `  (96)
		    3968 ,		// a  (97)
		    4092 ,		// b  (98)
		    4216 ,		// c  (99)
		    4340 ,		// d  (100)
		    4464 ,		// e  (101)
		    4588 ,		// f  (102)
		    4712 ,		// g  (103)
		    4836 ,		// h  (104)
		    4960 ,		// i  (105)
		    5084 ,		// j  (106)
		    5208 ,		// k  (107)
		    5332 ,		// l  (108)
		    5456 ,		// m  (109)
		    5580 ,		// n  (110)
		    5704 ,		// o  (111)
		    5828 ,		// p  (112)
		    5952 ,		// q  (113)
		    6076 ,		// r  (114)
		    6200 ,		// s  (115)
		    6324 ,		// t  (116)
		    6448 ,		// u  (117)
		    6572 ,		// v  (118)
		    6696 ,		// w  (119)
		    6820 ,		// x  (120)
		    6944 ,		// y  (121)
		    7068 ,		// z  (122)
		    0 ,		// {
		    0 ,		// |
		    0 ,		// }
		    0 ,		// ~
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    7192 ,		//   (140)
		    0 ,		//
		    0 ,		//
		    7316 ,		//   (143)
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		    0 ,		//
		   0 ,		//
		   0 ,		//
		   7440 ,		//   (156)
		   0 ,		//
		   0 ,		//
		   7564 ,		//   (159)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7688 ,		//   (163)
		   0 ,		//
		   7812 ,		//   (165)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   7936 ,		//   (175)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   8060 ,		//   (179)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   8184 ,		//   (185)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   8308 ,		//   (191)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   8432 ,		//   (198)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   8556 ,		//   (202)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   8680 ,		//   (209)
		   0 ,		//
		   8804 ,		//   (211)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   8928 ,		//   (230)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   9052 ,		//   (234)
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   0 ,		//
		   9176 ,		//   (241)
		   0 ,		//
		   9300 ,		//   (243)
};
const uint8_t fontinfo7[]=
{
		 31,  // Character height
		    'A',  //  Start character
		    0,  //  number of pixels of interspace between characters
		    30,  // number of pixels of space character

};
